<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
    pageEncoding="ISO-8859-1"%>
<%@ include file="/common/taglibs.jsp"%>

<!DOCTYPE html>
<html lang="en">
<head>
	<link id="contextPathHolder" data-contextPath="${pageContext.request.contextPath}"/>
	<meta http-equiv="X-UA-Compatible" content="IE=edge">

	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1" />
	<meta name="description" content="" />
	<meta name="author" content="" />

	<link rel="icon" href="<c:url value="/resources/assets/images/favicon.ico"/>">

	<title>DELFINES HOTEL & CONVENTION CENTER</title>

	<link rel="stylesheet" href="<c:url value="/resources/assets/js/jquery-ui/css/no-theme/jquery-ui-1.10.3.custom.min.css"/>">
	<link rel="stylesheet" href="<c:url value="/resources/assets/css/font-icons/entypo/css/entypo.css"/>">
	<link rel="stylesheet" href="//fonts.googleapis.com/css?family=Noto+Sans:400,700,400italic">
	<link rel="stylesheet" href="<c:url value="/resources/assets/css/bootstrap.css"/>">
	<link rel="stylesheet" href="<c:url value="/resources/assets/css/neon-core.css"/>">
	<link rel="stylesheet" href="<c:url value="/resources/assets/css/neon-theme.css"/>">
	<link rel="stylesheet" href="<c:url value="/resources/assets/css/neon-forms.css"/>">
	<link rel="stylesheet" href="<c:url value="/resources/assets/css/custom.css"/>">
	
	<script src="./resources/assets/js/jquery-1.11.3.min.js"></script>

	<script type="text/javascript"	src="<c:url value="/resources/js/fn_login.js" />"></script>
</head>

<body>
	<div class="container">
		<div class="panel-group" id="accordion">
			<div class="panel panel-success">
  				<div class="panel-heading clearfix">
				      <h4 class="panel-title pull-left" style="padding-top: 7.5px;"><b>HK by Floors</b></h4>
				      <div class="btn-group pull-right">
				      
				      	<a href="<c:url value="/hk"/>" class="btn btn-info btn-sm"><i class="entypo-menu"></i> By Status</a>
				        <a href="<c:url value="/hks"/>" class="btn btn-success btn-sm"><i class="entypo-layout"></i> By Floors</a>
				         			        
				      </div>
			    </div>
			 </div>
			 
			 
			 <div class="panel panel-gray">   
			    <div class="panel-heading clearfix">
			      	   <c:forEach items="${listaEstadistica}" var="o" varStatus="i" >
			      	   		<div class="row">
						  		<div class="col-sm-12">
						  			<div class="form-group">
								    	<label class="control-label control-label-left col-sm-2" >DI&nbsp;&nbsp;${o.cantidadDi}</label>
								    	<label class="control-label control-label-left col-sm-2" >CL&nbsp;&nbsp;${o.cantidadCl}</label>
								    	<label class="control-label control-label-left col-sm-2" >IP&nbsp;&nbsp;${o.cantidadIp}</label>
								    	<label class="control-label control-label-left col-sm-2" >OS&nbsp;&nbsp;${o.cantidadOs}</label>
								    	<label class="control-label control-label-left col-sm-2" >OO&nbsp;&nbsp;${o.cantidadOo}</label>
								    </div>
								</div>
							</div>
						
							<div class="row">
						  		<div class="col-sm-12">
						  			<div class="form-group">
								    	<label class="control-label control-label-left col-sm-6" >
						  					<i class="entypo-users"></i>OCC&nbsp;${o.cantidadOcc}
						  					<i class="entypo-light-down"></i>VAC&nbsp;${o.cantidadVac}
								    	</label>
								    	<label class="control-label control-label-left col-sm-6" >
								    		<i class="entypo-users"></i>adults&nbsp;${o.adults}&nbsp;
								    		children&nbsp;${o.children}
								    	</label>
								    	
								    </div>
								</div>
							</div>
											
			      	   		<div class="row">
						  		<div class="col-sm-12">
						  			<div class="form-group">
								    	<label class="control-label control-label-left col-sm-6" >
								    		<i class="entypo-block"></i>DISC&nbsp;&nbsp;${o.cantidadDisc}
								    	</label>
								    	<label class="control-label control-label-left col-sm-6" >
								    		<c:forEach items="${listaArrival}" var="r" >			
									    		<i class="entypo-flight"></i>arrival room asign&nbsp;${r.arrivalRoomY}&nbsp;&nbsp;no asign&nbsp;${r.arrivalRoomN}&nbsp;
											</c:forEach>
								    	</label>
								    </div>
								</div>
							</div>
						</c:forEach>
			    </div>
			</div> 

		   <c:forEach items="${lista}" var="o" varStatus="i" >
		   
		      	<div class="panel panel-gray">
			         <div class="panel-heading " onclick="collapseRoomStatus(${o.id})" role="button" data-toggle="collapse" data-parent="#accordion" data-target="#rooms${o.id}" aria-expanded="false" aria-controls="rooms${o.id}" >
			            <div class="panel-title">
		            		<i class="entypo-down-open"></i>Piso ${o.codigo}&nbsp;::&nbsp;OCC:${o.cantidadOcc}&nbsp;&nbsp;VAC:${o.cantidadVac}&nbsp;-&nbsp;${o.adults} adults ${o.children} children
		            		 
			            </div>
			         </div>
		         	 <div id="rooms${o.id}" class="panel-collapse collapse" >
						<div class="row">
							<div id="subViewDiv${o.id}"></div>
						</div>
					 </div>
				</div>
					
			</c:forEach>
		</div>
	</div>
				
				
	<script>
		var baseURL=$('#contextPathHolder').attr('data-contextPath');
		function collapseRoomStatus(id){
			$.ajax({
				url : baseURL + "/consulta-hks",
				data : {
					floor:id
				},
				async:false,
				type : "get",
				success : function(response) {
					if(id==2){
						$("#subViewDiv2").html(response)
					}else if(id==3){
						$("#subViewDiv3").html(response)
					}else if(id==4){
						$("#subViewDiv4").html(response)
					}else if(id==5){
						$("#subViewDiv5").html(response)
					}else if(id==6){
						$("#subViewDiv6").html(response)
					}else if(id==7){
						$("#subViewDiv7").html(response)
					}else if(id==8){
						$("#subViewDiv8").html(response)
					}else if(id==9){
						$("#subViewDiv9").html(response)
					}else if(id==10){
						$("#subViewDiv10").html(response)
					}else if(id==11){
						$("#subViewDiv11").html(response)
					}else if(id==12){
						$("#subViewDiv12").html(response)
					}else if(id==14){
						$("#subViewDiv14").html(response)
					}
				}
			});
		}

	</script>
				
	<!-- Imported styles on this page -->
	<link rel="stylesheet" href="<c:url value="/resources/assets/js/jvectormap/jquery-jvectormap-1.2.2.css" />">
	<link rel="stylesheet" href="<c:url value="/resources/assets/js/rickshaw/rickshaw.min.css" />">
	<link rel="stylesheet" href="<c:url value="/resources/assets/css/font-icons/font-awesome/css/font-awesome.min.css" />">

	<!-- Bottom scripts (common) -->
	<script src="<c:url value="/resources/assets/js/gsap/TweenMax.min.js" />"></script>
	<script src="<c:url value="/resources/assets/js/jquery-ui/js/jquery-ui-1.10.3.minimal.min.js" />"></script>
	<script src="<c:url value="/resources/assets/js/bootstrap.js" />"></script>
	<script src="<c:url value="/resources/assets/js/joinable.js" />"></script>
	<script src="<c:url value="/resources/assets/js/resizeable.js" />"></script>
	<script src="<c:url value="/resources/assets/js/neon-api.js" />"></script>
	<script src="<c:url value="/resources/assets/js/jvectormap/jquery-jvectormap-1.2.2.min.js" />"></script>


	<!-- Imported scripts on this page -->
	<script src="<c:url value="/resources/assets/js/jvectormap/jquery-jvectormap-europe-merc-en.js" />"></script>
	<script src="<c:url value="/resources/assets/js/jquery.sparkline.min.js" />"></script>
	<script src="<c:url value="/resources/assets/js/rickshaw/vendor/d3.v3.js" />"></script>
	<script src="<c:url value="/resources/assets/js/rickshaw/rickshaw.min.js" />"></script>
	<script src="<c:url value="/resources/assets/js/raphael-min.js" />"></script>
	<script src="<c:url value="/resources/assets/js/morris.min.js" />"></script>
	<script src="<c:url value="/resources/assets/js/toastr.js" />"></script>


	<!-- JavaScripts initializations and stuff -->
	<script src="<c:url value="/resources/assets/js/neon-custom.js" />"></script>


	<!-- Demo Settings -->
	<script src="<c:url value="/resources/assets/js/neon-demo.js" />"></script>
	
</body>
</html>