$(document).ready(function() {
	
	var baseURL=$('#contextPathHolder').attr('data-contextPath');
    
	$('#mManteReserva').on('shown.bs.modal', function () {
		$('#txtIdCliente').trigger('focus')
	})
	
	$('#mManteCheck').on('shown.bs.modal', function () {
		$("#txtVentaNetaCheck").val("");
		$("#txtNroCheck").val("");
		
		
		$('#txtVentaNetaCheck').trigger('focus')
		
	})
		
	inicio();

	function valida(){
		
		var hIdCliente=$("#hIdClienteEdit").val();
		
		var selTipoReserva=$("#selTipoReserva").val();
		var selOutlet=$("#selOutlet").val();
		var txtAdultos=$("#txtAdultos").val()
		var txtNinos=$("#txtNinos").val();
		var txtFechaReserva=$("#txtFechaReserva").val();
		var txtHoraReserva=$("#txtHoraReserva").val();
		var txtVentaEstimada=$("#txtVentaEstimada").val();
		var txtObservacion=$("#txtObservacion").val().trim().toUpperCase();
		
		if(!(isInt(hIdCliente)&&hIdCliente>0)){
  			alert('Ingrese el cliente!');
  			$("#txtIdCliente").focus();
  			$("#txtIdCliente").select();
  			return false;
  		}
		
		if(!(isInt(selTipoReserva)&&selTipoReserva>0)){
  			alert('Ingrese el tipo de reserva!');
  			$("#selTipoReserva").focus();
  			$("#selTipoReserva").select();
  			return false;
  		}
		
		if(!(isInt(selOutlet)&&selOutlet>0)){
  			alert('Ingrese el outlet!');
  			$("#selOutlet").focus();
  			$("#selOutlet").select();
  			return false;
  		}
		
		if(!(isInt(txtAdultos)&&txtAdultos>=0)){
			alert('Ingrese la cantidad de adultos');
			$("#txtAdultos").focus();
  			$("#txtAdultos").select();
			return false;
		}
		
		
		if(!(isInt(txtNinos)&&txtNinos>=0)){
			alert('Ingrese la cantidad de niños');
			$("#txtNinos").focus();
  			$("#txtNinos").select();
			return false;
		}
		
		if(isEmpty(txtFechaReserva)){
			alert('Ingrese fecha de reserva');
			$("#txtFechaReserva").focus();
  			$("#txtFechaReserva").select();
			return false;
		}
		
		if(isEmpty(txtHoraReserva)){
			alert('Ingrese la hora de reserva');
			$("#txtHoraReserva").focus();
  			$("#txtHoraReserva").select();
			return false;
		}
		
		if(isEmpty(txtVentaEstimada)){
			alert('Ingrese la venta estimada');
			$("#txtVentaEstimada").focus();
  			$("#txtVentaEstimada").select();
			return false;
		}
		
		if(isEmpty(txtObservacion)){
			alert('Ingrese las observaciones');
			$("#txtObservacion").focus();
  			$("#txtObservacion").select();
			return false;
		}
		
		return true;
	}
	
	$("#cmdGuardarReserva").click(function (event) {
		var hIdReserva=$("#hIdReserva").val();
		var hIdCliente=$("#hIdClienteEdit").val();
		var hIdTipoReserva=$("#selTipoReserva").val();
		var hIdOutlet=$("#selOutlet").val();
		
		var txtAdultos=$("#txtAdultos").val()
		var txtNinos=$("#txtNinos").val();
		var txtFechaReserva=$("#txtFechaReserva").val();
		var txtHoraReserva=$("#txtHoraReserva").val();
		
		var txtVentaEstimada=$("#txtVentaEstimada").val();
		txtVentaEstimada=txtVentaEstimada.replace(',','');
		
		var txtObservacion=$("#txtObservacion").val().trim().toUpperCase();
		
		txtObservacion=normalize(txtObservacion);
		
		if(valida()){
			$.ajax({
				url : baseURL + "/guardar-reserva",
				data : {
					idReserva:hIdReserva,
					idCliente:hIdCliente,
					idTipoReserva:hIdTipoReserva,
					idOutlet:hIdOutlet,
					adultos:txtAdultos,
					ninos:txtNinos,
					fechaReserva:txtFechaReserva,
					horaReserva:txtHoraReserva,
					ventaEstimada:txtVentaEstimada,
					observacion:txtObservacion},
				async:false,
				type : "get",
				success : function(response){
					$("#subViewDiv").html(response);
					clearControls();
				}
			});
		}else{
			cancelBubble(event);
		}
		
    });
	
	function clearControls(){
		$("#txtIdCliente").val("");
		$("#hIdReserva").val("0");
		$("#selTipoReserva").val("");
		$("#selOutlet").val("");
		$("#txtAdultos").val("")
		$("#txtNinos").val("");
		$("#txtFechaReserva").val("");
		$("#txtHoraReserva").val("");
		$("#txtVentaEstimada").val("");
		$("#txtObservacion").val("");
		
		$("#txtIdCliente").focus();
		$("#txtIdCliente").select();
		$('#txtIdCliente').trigger('focus')
	}
	
	
	function cancelBubble(e) {
		 var evt = e ? e:window.event;
		 if (evt.stopPropagation)    evt.stopPropagation();
		 if (evt.cancelBubble!=null) evt.cancelBubble = true;
	}
	
	$("#cmdBuscar").click(function (event) {
		var txtFechaIni=$("#txtSearchFechaIni").val();
		var txtFechaFin=$("#txtSearchFechaFin").val();
		
		var selIdOutlet=$("#selSearchIdOutlet").val();
		var selIdTipoReserva=$("#selSearchIdTipoReserva").val();
		var selIdEjecutivo=$("#selSearchIdEjecutivo").val();
		
		if((!isEmpty(txtFechaIni)) && isEmpty(txtFechaFin)){
			txtFechaFin=txtFechaIni;
		}
		
		$.ajax({
			url : baseURL + "/buscar-registro-reservas",
			data : {
				fechaIni:txtFechaIni,
				fechaFin:txtFechaFin,
				idOutlet:selIdOutlet,
				idTipoReserva:selIdTipoReserva,
				idEjecutivo:selIdEjecutivo
			},
			async:false,
			type : "get",
			success : function(response) {
				$("#subViewDiv").html(response);
			}
		});
		
    });
	
	function inicio(){
		$.ajax({
			url : baseURL + "/lista-reservas",
			async:false,
			type : "get",
			success : function(response) {
				$("#subViewDiv").html( response );
			}
		});
	}
	
	function isEmpty(str){
        return !str.replace(/^\s+/g, '').length; // boolean (`true` if field is empty)
    }
	
	function isInt(x) {
		   var y = parseInt(x, 10);
		   return !isNaN(y) && x == y && x.toString() == y.toString();
	}
	
	$("#cmdGuardarCliente").click(function(){
		var selTipoPersona=$("#selTipoPersona").val();
		var intTipoPersona=parseInt(selTipoPersona);
		if(intTipoPersona==1){//Natural
			
			var hIdCliente=$("#hIdClienteEdit").val();
			
			var idTipoDocumento=1//DNI
			var txtApellidosNombres = $("#txtApellidosNombres").val().trim().toUpperCase();
			txtApellidosNombres=normalize(txtApellidosNombres);
			
	        var txtDni = $("#txtDni").val().trim().toUpperCase();
	        var txtTelefono = $("#txtTelefono").val().trim().toUpperCase();
	        var txtCorreo = $("#txtCorreo").val().trim().toUpperCase();
	        var selDistrito = $("#selDistrito").val();
	        var txtNumeroSocio = $("#txtNumeroSocio").val().trim().toUpperCase();
	        
	        if(!isEmpty(txtApellidosNombres)){
	        	if(!isEmpty(txtDni)){
			        $.ajax({
						url : baseURL + "/registro-cliente-simple",
						data : {
							idCliente: hIdCliente,	
							idTipoCliente:selTipoPersona,
							idTipoDocumento:idTipoDocumento,
							denominacion:txtApellidosNombres,
							nrodocumento:txtDni,
							telefono:txtTelefono,
							correo:txtCorreo,
							numeroSocio:txtNumeroSocio,
							idDistrito:selDistrito
						},
						async:false,
						type : "get",
						success : function(cliente) {
							$("#hIdCliente").val(cliente.idCliente);
							$("#txtIdCliente").val(cliente.nroDocumento+" "+cliente.denominacion);
							reloadDataList();
							$("#txtIdCliente").focus();
							$("#txtIdCliente").select();
						}
					});
	        	}else{
	        		alert('Debe ingresar el número de DNI!');
	        	}
	        }else{
	        	alert('Debe ingresar los apellidos y nombres!');
	        }
		}else if(intTipoPersona==2){//Empresa
			var hIdCliente=$("#hIdClienteEdit").val();
			var idTipoDocumento=2//RUC
			var txtRazonSocial = $("#txtRazonSocial").val().trim().toUpperCase();
			txtRazonSocial=normalize(txtRazonSocial);
			
	        var txtRuc = $("#txtRuc").val().trim().toUpperCase();
			var txtTelefono = $("#txtTelefono").val().trim().toUpperCase();
			var txtCorreo = $("#txtCorreo").val().trim().toUpperCase();
			var selDistrito = $("#selDistrito").val();
	        var txtNumeroSocio = $("#txtNumeroSocio").val().trim().toUpperCase();
	        
	        if(!isEmpty(txtRazonSocial)){
	        	if(!isEmpty(txtRuc)){
			        $.ajax({
						url : baseURL + "/registro-cliente-simple",
						data : {
							idCliente: hIdCliente,
							idTipoCliente:selTipoPersona,
							idTipoDocumento:idTipoDocumento,
							denominacion:txtRazonSocial,
							nrodocumento:txtRuc,
							telefono:txtTelefono,
							correo:txtCorreo,
							numeroSocio:txtNumeroSocio,
							idDistrito:selDistrito
						},
						async:false,
						type : "get",
						success : function(cliente) {
							$("#hIdCliente").val(cliente.idCliente);
							$("#txtIdCliente").val(cliente.nroDocumento+" "+cliente.denominacion);
							reloadDataList();
							$("#txtIdCliente").focus();
							$("#txtIdCliente").select();
						}
					});
	        	}else{
	        		alert('Debe ingresar el número de RUC!');
	        	}
	        }else{
	        	alert('Debe ingresar la razón social!');
	        }
		}
    });
	
	
	$("#cmdGuardarCheck").click(function(){
			
		var hIdClienteCheck=$("#hIdClienteCheck").val();
		var hIdReservaCheck=$("#hIdReservaCheck").val();
		
		var txtVentaNetaCheck=$("#txtVentaNetaCheck").val();
		txtVentaNetaCheck=txtVentaNetaCheck.replace(',','');
		
		var txtNroCheck=$("#txtNroCheck").val();
        
        if(!isEmpty(txtVentaNetaCheck)){
        	if(!isEmpty(txtNroCheck)){
		        $.ajax({
					url : baseURL + "/registro-check",
					data : {
						idCliente: hIdClienteCheck,	
						idReserva:hIdReservaCheck,
						ventaNeta:txtVentaNetaCheck,
						nroCheck:txtNroCheck
					},
					async:false,
					type : "get",
					success : function(response) {
						$("#subViewDiv").html(response);
					}
				});
        	}else{
        		alert('Debe el número de Check!');
        	}
        }else{
        	alert('Debe ingresar la Venta Neta!');
        }
	        
    });
	
	function reloadDataList(){
		$.ajax({
			url : baseURL + "/obtener-clientes-lista",
			async:false,
			type : "get",
			contentType: "application/json", //this is required for spring 3 - ajax to work (at least for me)
			dataType : 'json',
			success : function(data) {
				var dataList = $("#lClientes");
				dataList.empty();
				if(data.length) {
		          for(var i=0, len=data.length; i<len; i++) {
		        	  dataList.append("<option data-value='" + data[i]['id'] + "' id='"+data[i]['descripcion']+"' value='" + data[i]['denominacion']+ "'>");
		          }
		        }
			}
		});
	}
	
	
});

var normalize = (function() {
	  var from = "ÃÀÁÄÂÈÉËÊÌÍÏÎÒÓÖÔÙÚÜÛãàáäâèéëêìíïîòóöôùúüûÑñÇç", 
	      to   = "AAAAAEEEEIIIIOOOOUUUUaaaaaeeeeiiiioooouuuuNncc",
	      mapping = {};
	 
	  for(var i = 0, j = from.length; i < j; i++ )
	      mapping[ from.charAt( i ) ] = to.charAt( i );
	 
	  return function( str ) {
	      var ret = [];
	      for( var i = 0, j = str.length; i < j; i++ ) {
	          var c = str.charAt( i );
	          if( mapping.hasOwnProperty( str.charAt( i ) ) )
	              ret.push( mapping[ c ] );
	          else
	              ret.push( c );
	      }      
	      return ret.join( '' );
	  }
	})();