$(document).ready(function() {
	
	var baseURL=$('#contextPathHolder').attr('data-contextPath');
    
    $("#cmdBuscarRegistroTicket").click(function(){
		var txtApellidosNombres = $("#txtApellidosNombres").val();
		var selIdArea = $("#selIdArea").val();
		
		$.ajax({
			url : baseURL + "/buscar-usuario-ticket",
			data : {
				apellidosNombres : txtApellidosNombres,
				idArea:selIdArea
			},
			async:false,
			type : "get",
			success : function(response) {
				$("#subViewDiv").html( response );
			}
		});
		
    });

    $("#frmGuardarRegistroTicket").submit(function(e){
    	e.preventDefault();
		var txtTicketDesde = $("#txtTicketDesde").val();
		var txtTicketHasta = $("#txtTicketHasta").val();
		//--
		var txtMetaEntregados = $("#txtMetaEntregados").val();
		var txtMetaValidados = $("#txtMetaValidados").val();
		//--
		var txtIdUsuario = $("#hIdUsuario").val();
		
		if(validaNumeros()){
			$.ajax({
				url : baseURL + "/registro-usuario-ticket",
				data : {
					ticketDesde : txtTicketDesde,
					ticketHasta : txtTicketHasta,
					metaEntregados:txtMetaEntregados,
					metaValidados:txtMetaValidados,
					idUsuario:txtIdUsuario
				},
				async:false,
				type : "get",
				success : function(exito) {
					$("#txtTicketDesde").val("");
					$("#txtTicketHasta").val("");
					$("#txtMetaEntregados").val("");
					$("#txtMetaValidados").val("");
					
					$("[data-dismiss=modal]").trigger({ type: "click" });
					alert('Se registro satifactoriamente');
					
					$("#cmdBuscarRegistroTicket").click();
				}
			});
		}
		
    });

    function validaNumeros(){
    	
		var ticketDesde = isEmpty($("#txtTicketDesde").val())?"0":$("#txtTicketDesde").val();
		var ticketHasta = isEmpty($("#txtTicketHasta").val())?"0":$("#txtTicketHasta").val();
		
		var cantidad=parseInt(ticketHasta)-parseInt(ticketDesde);
		if(cantidad<=0){
			alert('El valor de Ticket hasta debe ser mayor que el valor de Ticket desde');
			return false;
		}else{
			var metaEntregados = isEmpty($("#txtMetaEntregados").val())?"0":$("#txtMetaEntregados").val();
			var metaValidados = isEmpty($("#txtMetaValidados").val())?"0":$("#txtMetaValidados").val();
			
			if(metaEntregados<=0){
				alert('El valor de Meta entregados debe ser mayor a cero');
				return false;
			}
			if(metaValidados<=0){
				alert('El valor de Meta validados debe ser mayor a cero');
				return false;
			}
		}
		return true;
    }
    
    function isEmpty(str){
        return !str.replace(/^\s+/g, '').length; // boolean (`true` if field is empty)
    }
    
});
