package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.delfines.dao.ConnectionFactory;
import com.delfines.vo.Area;
import com.delfines.vo.General;
import com.delfines.vo.Usuario;

public class GeneralBo {
	
	public List<General> listarGeneral(Integer grupo){
		List<General> lista = new ArrayList<General>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
            
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select id_general,denominacion,valor,indice,puntos,excelente,muybueno,regular,malo,pesimo FROM general WHERE grupo=? order by indice ASC ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, grupo);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	General general=new General();
            	general.setGeneralId(rs.getInt("id_general"));
            	general.setDenominacion(rs.getString("denominacion"));
            	general.setValor(rs.getInt("valor"));
            	general.setIndice(rs.getInt("indice"));
            	general.setPuntos(rs.getDouble("puntos"));
            	//--
            	general.setExcelente(rs.getInt("excelente"));
            	general.setMuybueno(rs.getInt("muybueno"));
            	general.setRegular(rs.getInt("regular"));
            	general.setMalo(rs.getInt("malo"));
            	general.setPesimo(rs.getInt("pesimo"));
            	lista.add(general);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public int registrarValor(Integer idGeneral,Integer valor,Integer indice
			,Double puntos,Integer excelente,Integer muybueno,Integer regular,Integer malo,Integer pesimo){
		
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            ps = conn.prepareStatement("UPDATE general SET valor=?,indice=?,puntos=?,excelente=?,muybueno=?,regular=?,malo=?,pesimo=? WHERE id_general=?");
            ps.setInt(1, valor);
            ps.setInt(2, indice);
            ps.setDouble(3, ((puntos==null)?0:puntos));//--Decimal
            //--
            ps.setInt(4, ((excelente==null)?0:excelente));
            ps.setInt(5, ((muybueno==null)?0:muybueno));
            ps.setInt(6, ((regular==null)?0:regular));
            ps.setInt(7, ((malo==null)?0:malo));
            ps.setInt(8, ((pesimo==null)?0:pesimo));
            ps.setInt(9, idGeneral);
            
            int i = ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return 1;
	}

	public List<String> listarUrl(){
		List<String> lista = new ArrayList<String>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
            
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select id_parametro,denominacion FROM dbo.parametro WHERE id_parametro=1");
            
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	lista.add(rs.getString("denominacion"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public int actualizaUrl(String url){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            ps = conn.prepareStatement("UPDATE dbo.parametro SET denominacion=? WHERE id_parametro=1");
            ps.setString(1, url);
            
            int i = ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return 1;
	}

	public int guardarParametro(String denominacion){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            ps = conn.prepareStatement("INSERT INTO dbo.general(denominacion,audit_usuarioid,audit_fechahora,audit_terminal,audit_estado,grupo,valor,indice,puntos,excelente,muybueno,regular,malo,pesimo) VALUES(?,1,getdate(),null,'1',2,0,99,0,0,0,0,0,0)");
            ps.setString(1, denominacion);
            int i = ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return 1;
	}
	
}
