package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.delfines.dao.ConnectionFactoryMicros;
import com.delfines.vo.MicrosCheck;
import com.delfines.vo.MicrosInvoice;
import com.delfines.vo.Usuario;

public class MicrosInvoiceBo {
	
	public String getDateTimePrevio(){
		String fecha=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactoryMicros.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select to_char((sysdate-1),'DD/MM/RRRR') as hoy from dual ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	fecha=rs.getString("hoy");
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return fecha;
	}
	
	public String getDateTime(){
		String fecha=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactoryMicros.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select to_char(sysdate,'DD/MM/RRRR') as hoy from dual ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	fecha=rs.getString("hoy");
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return fecha;
	}
	
	
	
	
	public List<MicrosCheck> listarMicrosCheck(String fechaIni,String fechaFin,Usuario pUser){
		List<MicrosCheck> lista = new ArrayList<MicrosCheck>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryMicros.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();  
            query.append("SELECT c.CHECKID,c.checknumber,cd.detailindex,cd.salescount,cd.total,st.stringtext,  ");
            query.append("to_char(t.OBJECTNUMBER) num_table,  ");
            query.append("NVL((select listagg (sd.plaindata, ',') WITHIN GROUP (ORDER BY sd.plaindata) from MICROSDB.CHECK_DETAIL cd inner join MICROSDB.secure_detail sd on (sd.checkdetailid=cd.CHECKDETAILID) where cd.checkid=c.CHECKID group by cd.checkid),'-') secure_detail,  ");
            query.append("(  ");
            query.append("case c.revctrid  ");
            query.append("when 1 then 'Delphos'  ");
            query.append("when 2 then 'RstOceanus'  ");
            query.append("when 3 then 'RService'  ");
            query.append("when 4 then 'Banquetes'  ");
            query.append("when 5 then 'BarOceanus'  ");
            query.append("when 6 then 'Sanis'  ");
            query.append("when 7 then 'CExpress'  ");
            query.append("end       ");  
            query.append(") outlet,  ");
            query.append("to_char(c.checkpostingtime,'DD/MM/RRRR') postingtime  ");
            query.append("FROM MICROSDB.CHECK_DETAIL cd   ");
            query.append("inner JOIN MICROSDB.CHECKS C on (c.CHECKID=cd.CHECKID)  ");
            query.append("inner JOIN MICROSDB.DINING_TABLE t on (c.diningtableid=t.diningtableid)  ");
            query.append("inner join MICROSDB.menu_item_detail mid on (mid.CHECKDETAILID=cd.CHECKDETAILID)  ");
            query.append("inner join MICROSDB.menu_item_definition mif on (mif.MENUITEMDEFID=mid.MENUITEMDEFID)  ");
            query.append("inner join MICROSDB.v_string_table st on (st.STRINGNUMBERID=mif.name1id)  ");
            query.append("where c.checkpostingtime >= TO_DATE('"+fechaIni+"'||'00:00:00', 'DD/MM/YYYY HH24:MI:SS')  ");
            query.append("AND c.checkpostingtime <= TO_DATE('"+fechaFin+"'||'23:59:59', 'DD/MM/YYYY HH24:MI:SS')  ");
            query.append("and c.revctrid!=4 and cd.TOTAL<>0  "); 
            query.append("AND st.stringid NOT IN (  ");
            	query.append("SELECT st.stringid FROM MICROSDB.v_string_table st WHERE ( upper(to_char(st.stringtext)) like 'ESTAC%' OR  TO_CHAR(st.stringtext)='DES. BNI' OR TO_CHAR(st.stringtext)='Desayuno BNI') OR UPPER(st.stringtext) like '%ANTICIP%' ");
            query.append(")  ");
            query.append("order by c.checknumber,cd.detailindex asc  ");
            
            ps = conn.prepareStatement(query.toString());
            
            System.out.println("...");
            rs = ps.executeQuery();
            
            while(rs.next()){
            	MicrosCheck obj=new MicrosCheck();
            	obj.setCheckid(rs.getLong("CHECKID"));
            	obj.setCheckNumber(rs.getInt("checknumber"));
            	obj.setDetailIndex(rs.getInt("detailindex"));
            	obj.setSalesCount(rs.getInt("salescount"));
            	obj.setSalesTotal(rs.getDouble("total"));
            	obj.setServiceText(rs.getString("stringtext"));
            	obj.setNumTable(rs.getInt("num_table"));
            	obj.setSecureDetail(rs.getString("secure_detail"));
            	obj.setOutlet(rs.getString("outlet"));
            	obj.setPostingTime(rs.getString("postingtime"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<MicrosCheck> listarMicrosCheck(String fechaIni,String fechaFin){
		List<MicrosCheck> lista = new ArrayList<MicrosCheck>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryMicros.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
        	
        	query.append("SELECT T.checkdetailid,T.checkid,T.checknumber,T.detailindex,T.salescount,T.total,T.stringtext,T.num_table,T.revctrid,T.postingtime,T.covers,NVL(T.postinghhmm,'00:00')postinghhmm,NVL(T.postingminute,0)postingminute,NVL(T.empleado,'-')empleado,T.payment FROM (");
        	query.append("SELECT cd.checkdetailid,c.checkid,c.checknumber,cd.detailindex,cd.salescount,cd.total,TO_CHAR(st.stringtext) stringtext, ");
        	query.append("to_char(t.OBJECTNUMBER) num_table,   ");
        	query.append("c.revctrid,  ");
        	query.append("to_char(c.checkpostingtime,'DD/MM/RRRR') postingtime, ");  
        	query.append("c.covers  ");
        	query.append(",(select to_char(to_date(MIN(x.postingminute),'sssss'),'mi:ss') from microsdb.totals x where x.checkid=c.CHECKID) postinghhmm,(select MIN(x.postingminute) from microsdb.totals x where x.checkid=c.CHECKID) postingminute ");
	        	query.append(",(select to_char(s.stringtext) from microsdb.totals x  ");
	        	query.append("INNER JOIN MICROSDB.EMPLOYEE E ON (E.employeeid=x.employeeid) ");
	        	query.append("inner join MICROSDB.V_STRING_TABLE s on (s.stringnumberid=E.CHECKNAMEID) ");
	        	query.append("where x.transid = (select MIN(x.transid) from microsdb.totals x where x.checkid=c.CHECKID)) empleado ");
	        	query.append(",c.payment ");
        	query.append("FROM MICROSDB.CHECK_DETAIL cd ");   
        	query.append("inner JOIN MICROSDB.CHECKS C on (c.CHECKID=cd.CHECKID) ");  
        	query.append("inner JOIN MICROSDB.DINING_TABLE t on (c.diningtableid=t.diningtableid) ");  
        	query.append("inner join MICROSDB.menu_item_detail mid on (mid.CHECKDETAILID=cd.CHECKDETAILID) ");  
        	query.append("inner join MICROSDB.menu_item_definition mif on (mif.MENUITEMDEFID=mid.MENUITEMDEFID) ");  
        	query.append("inner join MICROSDB.v_string_table st on (st.STRINGNUMBERID=mif.name1id)   ");
        	query.append("where c.checkpostingtime >= TO_DATE('"+fechaIni+"'||'00:00:00', 'DD/MM/YYYY HH24:MI:SS') ");  
        	query.append("AND c.checkpostingtime <= TO_DATE('"+fechaFin+"'||'23:59:59', 'DD/MM/YYYY HH24:MI:SS')   ");
        	query.append("and c.revctrid!=4 and cd.TOTAL<>0  ");
        	query.append("and c.status NOT IN ('00000000000000000100000010000000','00000000000000000100000000000000') ");
        	query.append("AND st.stringid NOT IN (   ");
        	query.append("SELECT st.stringid FROM MICROSDB.v_string_table st WHERE ( upper(to_char(st.stringtext)) like 'ESTAC%' OR  TO_CHAR(st.stringtext)='DES. BNI' OR TO_CHAR(st.stringtext)='Desayuno BNI') OR UPPER(st.stringtext) like '%ANTICIP%' ");  
        	query.append(") ");
        	query.append("and NVL(c.addedtochecknum,0)=0 ");
        	query.append("and cd.detailtype<>15 ");
        	query.append("and st.stringid!=397630 ");
        		query.append("UNION ALL ");
        	query.append("SELECT cd.checkdetailid,c.checkid,c.checknumber,cd.detailindex,cd.salescount,cd.total,to_char(st.stringtext) stringtext, ");   
        	query.append("to_char(t.OBJECTNUMBER) num_table,    ");
        	query.append("c.revctrid, ");
        	query.append("to_char(c.checkpostingtime,'DD/MM/RRRR') postingtime, ");
        	query.append("c.covers        ");
        	query.append(",(select to_char(to_date(MIN(x.postingminute),'sssss'),'mi:ss') from microsdb.totals x where x.checkid=c.CHECKID) postinghhmm,(select MIN(x.postingminute) from microsdb.totals x where x.checkid=c.CHECKID) postingminute  ");
	        	query.append(",(select to_char(s.stringtext) from microsdb.totals x  ");
	        	query.append("INNER JOIN MICROSDB.EMPLOYEE E ON (E.employeeid=x.employeeid) ");
	        	query.append("inner join MICROSDB.V_STRING_TABLE s on (s.stringnumberid=E.CHECKNAMEID) ");
	        	query.append("where x.transid = (select MIN(x.transid) from microsdb.totals x where x.checkid=c.CHECKID)) empleado ");
	        query.append(",c.payment ");
        	query.append("FROM MICROSDB.CHECK_DETAIL cd ");    
        	query.append("inner JOIN MICROSDB.CHECKS C on (c.CHECKID=cd.CHECKID) ");   
        	query.append("inner JOIN MICROSDB.DINING_TABLE t on (c.diningtableid=t.diningtableid) ");   
        	query.append("inner join microsdb.DISCOUNT_DETAIL dd on (dd.CHECKDETAILID=cd.CHECKDETAILID) ");
        	query.append("inner join microsdb.DISCOUNT di on (di.DSCNTID=dd.DSCNTID) ");
        	query.append("inner join MICROSDB.v_string_table st on (st.STRINGNUMBERID=di.nameid) ");
        	query.append("where c.checkpostingtime >= TO_DATE('"+fechaIni+"'||'00:00:00', 'DD/MM/YYYY HH24:MI:SS') ");   
        	query.append("AND c.checkpostingtime <= TO_DATE('"+fechaFin+"'||'23:59:59', 'DD/MM/YYYY HH24:MI:SS')    ");
        	query.append("and c.revctrid!=4 and cd.TOTAL<>0 ");
        	query.append("and c.status NOT IN ('00000000000000000100000010000000','00000000000000000100000000000000') ");
        	query.append("and cd.detailtype=2 ");
        	query.append("and NVL(c.addedtochecknum,0)=0 ");
        	query.append("and st.stringid!=397630 ");
        	query.append(") T order by T.checknumber,T.checkdetailid,T.detailindex asc ");
        	
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	MicrosCheck obj=new MicrosCheck();
            	obj.setCheckDetailId(rs.getLong("checkdetailid"));
            	obj.setCheckid(rs.getLong("checkid"));
            	obj.setCheckNumber(rs.getInt("checknumber"));
            	obj.setDetailIndex(rs.getInt("detailindex"));
            	obj.setSalesCount(rs.getInt("salescount"));
            	obj.setSalesTotal(rs.getDouble("total"));
            	obj.setServiceText(rs.getString("stringtext"));
            	obj.setNumTable(rs.getInt("num_table"));
            	//obj.setSecureDetail(rs.getString("secure_detail"));
            	obj.setOutlet(rs.getString("revctrid"));
            	obj.setPostingTime(rs.getString("postingtime"));
            	obj.setCovers(rs.getInt("covers"));
            	//
            	obj.setPostinghhmm(rs.getString("postinghhmm"));
            	obj.setPostingMinute(rs.getInt("postingminute"));
            	//
            	obj.setEmpleado(rs.getString("empleado"));
            	obj.setPayment(rs.getDouble("payment"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
}