package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.delfines.dao.ConnectionFactoryOperaBat;
import com.delfines.vo.ForecastHistory;

public class OperaForecastBo {
	
	public String getDateFrom(){
		String fecha=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactoryOperaBat.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select ('01'||to_char(sysdate,'MMRRRR')) as datefrom from dual ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	fecha=rs.getString("datefrom");
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return fecha;
	}
	
	public String getDateTo(){
		String fecha=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactoryOperaBat.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select TO_CHAR(LAST_DAY(to_date(to_char(ADD_MONTHS(SYSDATE, 11),'YYYYMM'),'YYYYMM')),'DDMMRRRR') as dateto from dual ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            if(rs.next()){
            	fecha=rs.getString("dateto");
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return fecha;
	}
	
	public List<ForecastHistory> listarForecast(String fromDate,String toDate){
		List<ForecastHistory> lista = new ArrayList<ForecastHistory>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactoryOperaBat.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT rec_type, ");
            query.append(" TO_CHAR(considered_date,'DD/MM/RRRR') considered_date, ");
            query.append(" SUM(no_rooms * count_resv_01) no_rooms, ");
            query.append(" SUM(revenue * count_revenue_01) revenue ");
            query.append(" FROM ( ");
            query.append(" SELECT SUBSTR(rsf.rec_type,1,6) rec_type, ");
            query.append(" rsf.considered_date considered_date, ");
            query.append(" DECODE(nvl(rsf.owner_rental_flag,'H'),'O',0,rsf.no_rooms) no_rooms, ");
            query.append(" DECODE(nvl(rsf.owner_rental_flag,'H'),'O',0, ");
            query.append(" CASE 'RN'  ");
            query.append(" WHEN 'RN' THEN rsf.net_room_revenue ");  
            query.append(" WHEN 'RG' THEN rsf.net_room_revenue + rsf.room_revenue_tax "); 
            query.append(" WHEN 'TN' THEN rsf.total_revenue   ");
            query.append(" WHEN 'TG' THEN rsf.total_revenue + rsf.total_revenue_tax ");  
            query.append(" ELSE rsf.net_room_revenue ");
            query.append(" END  ");
            query.append(" ) revenue, ");  
            query.append(" (CASE WHEN SUBSTR(rsf.room_category,1,1) <> '-' THEN 1 "); 
            query.append(" WHEN SUBSTR(rsf.rec_type,1,6) = 'A_STAT' THEN 0 ");
            query.append(" WHEN NVL('N','N') = 'Y' THEN 1  ");
            query.append(" ELSE 0 ");
            query.append(" END ) count_resv_01, ");
            query.append(" (CASE WHEN SUBSTR(rsf.room_category,1,1) <> '-' THEN 1 "); 
            query.append(" WHEN SUBSTR(rsf.rec_type,1,6) = 'A_STAT' THEN 1   ");
            query.append(" WHEN NVL('N','N') = 'Y' THEN 1  ");
            query.append(" ELSE 0 ");
            query.append(" END ) count_revenue_01 ");
            query.append(" FROM rep_res_stati_forecast_hld rsf ");
            query.append(" where rsf.considered_date between TO_DATE('").append(fromDate).append("','DDMMRRRR')  and TO_DATE('").append(toDate).append("','DDMMRRRR') ");
            query.append(" and rsf.deduct_yn='Y'  ");
            query.append(" UNION ALL ");
            query.append(" SELECT (CASE WHEN (TO_DATE('").append(fromDate).append("','DDMMRRRR') + ns.n - 1) < pms_p.business_date THEN ");
            query.append(" 'A_STAT' ");
            query.append(" ELSE 'B_FORE' ");
            query.append(" END) rec_type, ");
            query.append(" (TO_DATE('").append(fromDate).append("','DDMMRRRR') + ns.n - 1) considered_date, ");
            query.append(" 0 no_rooms, ");
            query.append(" 0 revenue, ");
            query.append(" 0 count_resv_01, ");
            query.append(" 0 count_revenue_01 ");
            query.append(" FROM number_scale ns ");
            query.append(" WHERE ns.n <= TO_DATE('").append(toDate).append("','DDMMRRRR') - TO_DATE('").append(fromDate).append("','DDMMRRRR') + 1 ");
            query.append(" ) ");
            query.append(" group by rec_type,considered_date ");
            query.append(" ORDER BY rec_type,considered_date ");
            
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	ForecastHistory obj=new ForecastHistory();
            	obj.setRecType(rs.getString("rec_type"));
            	obj.setConsideredDate(rs.getString("considered_date"));
            	obj.setNoRooms(rs.getInt("no_rooms"));
            	obj.setRevenue(rs.getDouble("revenue"));
            	
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
}

