package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.delfines.Constante;
import com.delfines.dao.ConnectionFactoryOpera;
import com.delfines.vo.HkArrival;
import com.delfines.vo.HkFloors;
import com.delfines.vo.HkRoomStatus;
import com.delfines.vo.HkValueStatus;

public class OperaHkBo {
	
	public List<HkRoomStatus> listarHkRoomStatus(Integer floor){
		List<HkRoomStatus> lista = new ArrayList<HkRoomStatus>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT r.room,r.room_status,r.hk_status,c.label,c.short_description,  ");
            query.append(" CASE WHEN  NVL(v.resv_status,'F')='CHECKED IN' THEN 'CI' WHEN NVL(v.resv_status,'F')='CHECKED OUT' THEN 'CO' ELSE '' END resv_status, "); 
            query.append(" TO_CHAR(v.arrival,'DD/MM') arrival,  ");
            query.append(" TO_CHAR(v.departure,'DD/MM') departure,TO_CHAR(v.departure_time) departure_time "); 
            query.append(" ,CASE WHEN r.hk_status<>r.fo_status THEN 'Y' ELSE 'N' END isdiscrepancy "); 
            query.append(" ,NVL(v.adults,0) adults,NVL(v.children,0)children,NVL(SUBSTR(v.company_name,1,15),'-') company_name ");
            query.append("  ,NVL(v.vip,' ') vip ");
            query.append(" FROM OPERA.ROOM r    ");
            query.append(" INNER JOIN OPERA.ROOM_CATEGORY_TEMPLATE c ON (r.room_category=c.room_category) ");  
            query.append(" LEFT JOIN (  ");
            query.append(" select r.room,MIN(r.resv_status) resv_status,min(r.arrival) arrival,max(r.departure) departure,max(r.departure_time) departure_time ");
            query.append(" ,SUM(case when r.resv_status ='CHECKED IN' then r.adults else 0 end) adults, ");
            query.append(" SUM(case when r.resv_status ='CHECKED IN' then r.children else 0 end) children, ");
            query.append(" MAX(case when r.resv_status ='CHECKED IN' then r.company_name else '' end) company_name ");
            query.append(" ,MIN(r.vip) vip ");
            query.append(" from reservation_general_view_hld r  ");
            query.append(" where r.trunc_departure>=pms_p.business_date and r.room is not null "); 
            query.append(" and r.resv_status IN ('CHECKED IN','CHECKED OUT') ");  
            query.append(" group by r.room  ");
            query.append(" ) v ON (v.room=r.room) "); 
            query.append(" WHERE SUITE_TYPE<>'PSUEDO'   ");
            query.append(" AND to_number(r.floor)=?  ");
            query.append(" ORDER BY to_number(r.floor) ASC, to_number(r.room) ASC ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, floor);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	HkRoomStatus obj=new HkRoomStatus();
            	obj.setRoom(rs.getString("room")); 
            	obj.setRoomStatus(rs.getString("room_status"));
            	obj.setHkStatus(rs.getString("hk_status"));
            	obj.setRoomType(rs.getString("label"));
            	obj.setRoomTypeDescription(rs.getString("short_description"));
            	//
            	obj.setResvStatus(rs.getString("resv_status"));
            	obj.setArrival(rs.getString("arrival"));
            	obj.setDeparture(rs.getString("departure"));
            	obj.setDepartureTime(rs.getString("departure_time"));
            	//
            	obj.setIsDiscrepancy(rs.getString("isdiscrepancy").equals("Y")?Boolean.TRUE:Boolean.FALSE);
            	obj.setStatusDiscrepancy(Constante.STATUS_DISCREPANCY_N);
            	obj.setStatusArrivalTime(Constante.STATUS_ARRIVALTIME_N);
            	//--
            	obj.setAdults(rs.getInt("adults"));
            	obj.setChildren(rs.getInt("children"));
            	obj.setCompanyName(rs.getString("company_name"));
            	obj.setVip(rs.getString("vip"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	
	public List<HkFloors> listarHkFloors(){
		List<HkFloors> lista = new ArrayList<HkFloors>(); 
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT TO_NUMBER(r.floor) id,LPAD(r.floor,2,'0') floor, ");
            query.append(" SUM(CASE WHEN r.hk_status='OCC' THEN 1 ELSE 0 END) CANTIDAD_OCC, ");
            query.append(" SUM(CASE WHEN r.hk_status='VAC' THEN 1 ELSE 0 END) CANTIDAD_VAC, ");
            query.append(" SUM(CASE WHEN r.hk_status<>r.fo_status THEN 1 ELSE 0 END) CANTIDAD_DISC, ");
            query.append(" SUM(CASE WHEN r.room_status='IP' THEN 1 ELSE 0 END) CANTIDAD_IP, ");
            query.append(" SUM(CASE WHEN r.room_status='DI' THEN 1 ELSE 0 END) CANTIDAD_DI, ");
            query.append(" SUM(CASE WHEN r.room_status='CL' THEN 1 ELSE 0 END) CANTIDAD_CL, ");
            query.append(" SUM(CASE WHEN r.room_status='OO' THEN 1 ELSE 0 END) CANTIDAD_OO, ");
            query.append(" SUM(CASE WHEN r.room_status='OS' THEN 1 ELSE 0 END) CANTIDAD_OS ");
            query.append(" ,SUM(o.adults) adults,SUM(o.children) children ");
            query.append(" FROM OPERA.ROOM r   ");
            query.append(" LEFT JOIN (  ");
            query.append(" select v.room ,sum(v.adults) adults, sum(v.children) children  ");
            query.append(" from reservation_general_view_hld v  ");
            query.append(" where v.resv_status ='CHECKED IN'    ");
            query.append(" group by v.room  ");
            query.append(" ) o ON (o.room=r.room)  ");
            query.append(" WHERE r.SUITE_TYPE<>'PSUEDO' "); 
            query.append(" GROUP BY TO_NUMBER(r.floor),LPAD(r.floor,2,'0') ");
            query.append(" ORDER BY ID ASC ");
            
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	HkFloors obj=new HkFloors();
            	obj.setId(rs.getInt("id"));
            	obj.setCodigo(rs.getString("floor"));
            	obj.setCantidadOcc(rs.getInt("CANTIDAD_OCC"));
            	obj.setCantidadVac(rs.getInt("CANTIDAD_VAC"));
            	obj.setCantidadDisc(rs.getInt("CANTIDAD_DISC"));
            	
            	obj.setCantidadIp(rs.getInt("CANTIDAD_IP"));
            	obj.setCantidadDi(rs.getInt("CANTIDAD_DI"));
            	obj.setCantidadCl(rs.getInt("CANTIDAD_CL"));
            	obj.setCantidadOo(rs.getInt("CANTIDAD_OO"));
            	obj.setCantidadOs(rs.getInt("CANTIDAD_OS"));
            	//--
            	obj.setAdults(rs.getInt("adults"));
            	obj.setChildren(rs.getInt("children"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	
	public List<HkValueStatus> listarHkRoomStatus(){
		List<HkValueStatus> lista = new ArrayList<HkValueStatus>(); 
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT s.ROOM_STATUS_ID,s.ROOM_STATUS_CODE,s.ROOM_STATUS_DESC, t.cantidad,T.CANTIDAD_OCC,T.CANTIDAD_VAC,T.CANTIDAD_DISC ");
            query.append(" FROM OPERA.ROOM_STATUS_CODES_ALL_ORDER s ");
            query.append(" INNER JOIN ( ");
            query.append(" SELECT r.room_status, COUNT(1) CANTIDAD, ");
            query.append(" SUM(CASE WHEN r.hk_status='OCC' THEN 1 ELSE 0 END) CANTIDAD_OCC, ");
            query.append(" SUM(CASE WHEN r.hk_status='VAC' THEN 1 ELSE 0 END) CANTIDAD_VAC, ");
            query.append(" SUM(CASE WHEN r.hk_status<>r.fo_status THEN 1 ELSE 0 END) CANTIDAD_DISC ");
            query.append(" FROM OPERA.ROOM r ");
            query.append(" WHERE r.SUITE_TYPE<>'PSUEDO' ");  
            query.append(" GROUP BY r.room_status ");
            query.append(" )t ON (t.room_status=s.ROOM_STATUS_CODE) ");
            query.append(" ORDER BY s.ROOM_STATUS_ID ASC ");
            
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	HkValueStatus obj=new HkValueStatus();
            	obj.setId(rs.getInt("ROOM_STATUS_ID"));
            	obj.setCodigo(rs.getString("ROOM_STATUS_CODE"));
            	obj.setDenominacion(rs.getString("ROOM_STATUS_DESC"));
            	obj.setCantidad(rs.getInt("cantidad"));
            	//
            	obj.setCantidadOcc(rs.getInt("CANTIDAD_OCC"));
            	obj.setCantidadVac(rs.getInt("CANTIDAD_VAC"));
            	obj.setCantidadDisc(rs.getInt("CANTIDAD_DISC"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<HkValueStatus> listarHkRoomDiscrepancy(){
		List<HkValueStatus> lista = new ArrayList<HkValueStatus>(); 
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("  SELECT 99 ROOM_STATUS_ID,'DISC' room_status_code,'Discrepancy' room_status_desc, COUNT(1) CANTIDAD, "); 
            query.append("  SUM(CASE WHEN r.hk_status='OCC' THEN 1 ELSE 0 END) CANTIDAD_OCC,  ");
            query.append("  SUM(CASE WHEN r.hk_status='VAC' THEN 1 ELSE 0 END) CANTIDAD_VAC,  ");
            query.append("  SUM(CASE WHEN r.hk_status<>r.room_status THEN 1 ELSE 0 END) CANTIDAD_DISC "); 
            query.append("  FROM OPERA.ROOM r ");
            query.append("  WHERE r.SUITE_TYPE<>'PSUEDO' and r.hk_status<>r.fo_status ");
            query.append("  HAVING COUNT(1)>0 ");
            
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	HkValueStatus obj=new HkValueStatus();
            	obj.setId(rs.getInt("ROOM_STATUS_ID"));
            	obj.setCodigo(rs.getString("ROOM_STATUS_CODE"));
            	obj.setDenominacion(rs.getString("ROOM_STATUS_DESC"));
            	obj.setCantidad(rs.getInt("cantidad"));
            	//
            	obj.setCantidadOcc(rs.getInt("CANTIDAD_OCC"));
            	obj.setCantidadVac(rs.getInt("CANTIDAD_VAC"));
            	obj.setCantidadDisc(rs.getInt("CANTIDAD_DISC"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<HkRoomStatus> listarHkRoomStatusByStatus(Integer status){
		List<HkRoomStatus> lista = new ArrayList<HkRoomStatus>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT r.room,r.room_status,r.hk_status,c.label,c.short_description, ");
            query.append(" CASE WHEN  NVL(v.resv_status,'F')='CHECKED IN' THEN 'CI' WHEN NVL(v.resv_status,'F')='CHECKED OUT' THEN 'CO' ELSE '' END resv_status, ");
            query.append(" TO_CHAR(v.arrival,'DD/MM') arrival, ");
            query.append(" TO_CHAR(v.departure,'DD/MM') departure,TO_CHAR(v.departure_time) departure_time ");
            query.append(" ,CASE WHEN r.hk_status<>r.fo_status THEN 'Y' ELSE 'N' END isdiscrepancy ");
            query.append(" ,l.repair_remarks ");
            query.append(" ,x.reserved,x.arrival_next,x.arrival_next_time ");
            query.append("  ,NVL(v.vip,' ') vip ");
            query.append(" FROM OPERA.ROOM r   ");
            query.append(" INNER JOIN OPERA.ROOM_CATEGORY_TEMPLATE c ON (r.room_category=c.room_category) "); 
            query.append(" LEFT JOIN ( ");
            query.append(" select r.room,MIN(r.resv_status) resv_status,min(r.arrival) arrival,max(r.departure) departure,max(r.departure_time) departure_time,MIN(r.vip) vip ");
            query.append(" from reservation_general_view_hld r ");
            query.append(" where r.trunc_departure>=pms_p.business_date and r.room is not null ");
            query.append(" and r.resv_status IN ('CHECKED IN','CHECKED OUT')  ");
            query.append(" group by r.room ");
            query.append(" ) v ON (v.room=r.room) ");
            query.append(" LEFT JOIN ( ");
            query.append(" SELECT r.room,(r.reason_code||' '||r.repair_remarks) repair_remarks ");
            query.append(" FROM opera.room_repairs r    ");
            query.append(" WHERE R.END_DATE>=pms_p.business_date AND R.COMPLETED_DATE IS NULL ");
            query.append(" )l ON (l.room=r.room) ");
            query.append(" LEFT JOIN ( ");
            query.append(" SELECT V.ROOM,1 reserved,MIN(v.arrival) arrival_next,MIN(v.arrival_time) arrival_next_time ");
            query.append(" from reservation_general_view_hld v   ");
            query.append(" where v.resv_status ='RESERVED'  ");
            query.append(" and TO_CHAR(v.arrival,'DDMMRRRR')=TO_CHAR(pms_p.business_date,'DDMMRRRR') "); 
            query.append(" GROUP BY V.ROOM  ");
            query.append(" ) x ON (x.room=r.room) ");
            query.append(" WHERE SUITE_TYPE<>'PSUEDO' "); 
            query.append(" AND r.room_status=?  ");
            query.append(" ORDER BY r.hk_status DESC,to_number(r.floor) ASC, to_number(r.room) ASC ");
            
            ps = conn.prepareStatement(query.toString());
            
            if(status==1){//DI	Dirty
            	ps.setString(1, "DI");
            }else if(status==2){//CL	Clean
            	ps.setString(1, "CL");
            }else if(status==3){//IP	Inspected
            	ps.setString(1, "IP");
            }else if(status==4){//OS	Out of Service
            	ps.setString(1, "OS");
            }else if(status==5){//OO	Out of Order
            	ps.setString(1, "OO");
            }
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	HkRoomStatus obj=new HkRoomStatus();
            	obj.setRoom(rs.getString("room")); 
            	obj.setRoomStatus(rs.getString("room_status"));
            	obj.setHkStatus(rs.getString("hk_status"));
            	obj.setRoomType(rs.getString("label"));
            	obj.setRoomTypeDescription(rs.getString("short_description"));
            	//
            	obj.setResvStatus(rs.getString("resv_status"));
            	obj.setArrival(rs.getString("arrival"));
            	obj.setDeparture(rs.getString("departure"));
            	obj.setDepartureTime(rs.getString("departure_time"));
            	//
            	obj.setIsDiscrepancy(rs.getString("isdiscrepancy").equals("Y")?Boolean.TRUE:Boolean.FALSE);
            	obj.setStatusDiscrepancy(Constante.STATUS_DISCREPANCY_N);
            	obj.setStatusArrivalTime(Constante.STATUS_ARRIVALTIME_N);
            	//
            	obj.setRepairRemarks(rs.getString("repair_remarks"));
            	//
            	obj.setReserved(rs.getInt("reserved")==1?Boolean.TRUE:Boolean.FALSE);
            	obj.setArrivalNext(rs.getString("arrival_next"));
            	obj.setArrivalNextTime(rs.getString("arrival_next_time"));
            	//
            	obj.setVip(rs.getString("vip"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<HkRoomStatus> listarHkRoomStatusByDiscrepancy(){
		List<HkRoomStatus> lista = new ArrayList<HkRoomStatus>(); 
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT r.room,r.room_status,r.hk_status,c.label,c.short_description, ");
            query.append(" CASE WHEN  NVL(v.resv_status,'F')='CHECKED IN' THEN 'CI' WHEN NVL(v.resv_status,'F')='CHECKED OUT' THEN 'CO' ELSE '' END resv_status, ");
            query.append(" TO_CHAR(v.arrival,'DD/MM') arrival, ");
            query.append(" TO_CHAR(v.departure,'DD/MM') departure,TO_CHAR(v.departure_time) departure_time ");
            query.append(" ,CASE WHEN r.hk_status<>r.fo_status THEN 'Y' ELSE 'N' END isdiscrepancy ");
            query.append("  ,NVL(v.vip,' ') vip ");
            query.append(" FROM OPERA.ROOM r   ");
            query.append(" INNER JOIN OPERA.ROOM_CATEGORY_TEMPLATE c ON (r.room_category=c.room_category) "); 
            query.append(" LEFT JOIN ( ");
            query.append(" select r.room,MIN(r.resv_status) resv_status,min(r.arrival) arrival,max(r.departure) departure,max(r.departure_time) departure_time,MIN(r.vip) vip ");
            query.append(" from reservation_general_view_hld r ");
            query.append(" where r.trunc_departure>=pms_p.business_date and r.room is not null ");
            query.append(" and r.resv_status IN ('CHECKED IN','CHECKED OUT')  ");
            query.append(" group by r.room ");
            query.append(" ) v ON (v.room=r.room) ");
            query.append(" WHERE SUITE_TYPE<>'PSUEDO' "); 
            query.append(" AND r.fo_status<>r.hk_status  ");
            query.append(" ORDER BY r.hk_status DESC,to_number(r.floor) ASC, to_number(r.room) ASC ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	HkRoomStatus obj=new HkRoomStatus();
            	obj.setRoom(rs.getString("room")); 
            	obj.setRoomStatus(rs.getString("room_status"));
            	obj.setHkStatus(rs.getString("hk_status"));
            	obj.setRoomType(rs.getString("label"));
            	obj.setRoomTypeDescription(rs.getString("short_description"));
            	//
            	obj.setResvStatus(rs.getString("resv_status"));
            	obj.setArrival(rs.getString("arrival"));
            	obj.setDeparture(rs.getString("departure"));
            	obj.setDepartureTime(rs.getString("departure_time"));
            	//
            	obj.setIsDiscrepancy(rs.getString("isdiscrepancy").equals("Y")?Boolean.TRUE:Boolean.FALSE);
            	obj.setStatusDiscrepancy(Constante.STATUS_DISCREPANCY_Y);
            	obj.setStatusArrivalTime(Constante.STATUS_ARRIVALTIME_N);
            	obj.setVip(rs.getString("vip"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	
	/**
	 * Arrival Time
	 * @return
	 */
	public List<HkRoomStatus> listarHkRoomStatusByArrivalTime(){
		List<HkRoomStatus> lista = new ArrayList<HkRoomStatus>(); 
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("  SELECT r.room,r.room_status,r.hk_status,c.label,c.short_description,  ");
            query.append("  CASE WHEN  NVL(v.resv_status,'F')='CHECKED IN' THEN 'CI' WHEN NVL(v.resv_status,'F')='CHECKED OUT' THEN 'CO' ELSE '' END resv_status, "); 
            query.append("  TO_CHAR(v.arrival,'DD/MM') arrival,  ");
            query.append("  TO_CHAR(v.departure,'DD/MM') departure,TO_CHAR(v.departure_time) departure_time "); 
            query.append("  ,CASE WHEN r.hk_status<>r.fo_status THEN 'Y' ELSE 'N' END isdiscrepancy "); 
            query.append("  ,v.arrival_time ");
            query.append("  ,NVL(v.vip,' ') vip ");
            query.append("  FROM OPERA.ROOM r    ");
            query.append("  INNER JOIN OPERA.ROOM_CATEGORY_TEMPLATE c ON (r.room_category=c.room_category) ");
            query.append("  LEFT JOIN (  ");
	            query.append("  select v.room,v.resv_status,v.departure,v.departure_time,v.arrival,v.arrival_time,v.vip ");
	            query.append("  from reservation_general_view_hld v "); 
	            query.append("  inner join ( ");
		            query.append("  SELECT V.ROOM,MIN(V.RESV_NAME_ID) RESV_NAME_ID ");
		            query.append("  from reservation_general_view_hld v "); 
		            query.append("  where v.resv_status ='RESERVED' ");
		            query.append("  and TO_CHAR(v.arrival,'DDMMRRRR')=TO_CHAR(pms_p.business_date,'DDMMRRRR') ");
		            query.append("  GROUP BY V.ROOM ");
	            query.append("  ) m ON (v.RESV_NAME_ID=m.RESV_NAME_ID) ");
	            query.append("  where m.RESV_NAME_ID=v.RESV_NAME_ID ");
            query.append("  ) v ON (v.room=r.room)  ");
            query.append("  WHERE r.SUITE_TYPE<>'PSUEDO'   ");
            query.append("  AND r.fo_status='VAC' AND r.room_status IN ('CL','DI','OS') ");
            query.append("  AND v.arrival_time IS NOT NULL ");
            query.append("  ORDER BY r.hk_status DESC,to_number(r.floor) ASC, to_number(r.room) ASC ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	HkRoomStatus obj=new HkRoomStatus();
            	obj.setRoom(rs.getString("room")); 
            	obj.setRoomStatus(rs.getString("room_status"));
            	obj.setHkStatus(rs.getString("hk_status"));
            	obj.setRoomType(rs.getString("label"));
            	obj.setRoomTypeDescription(rs.getString("short_description"));
            	//
            	obj.setResvStatus(rs.getString("resv_status"));
            	obj.setArrival(rs.getString("arrival"));
            	obj.setDeparture(rs.getString("departure"));
            	obj.setDepartureTime(rs.getString("departure_time"));
            	//
            	obj.setIsDiscrepancy(Boolean.FALSE);
            	obj.setIsArrivalTime(Boolean.TRUE);
            	obj.setStatusDiscrepancy(Constante.STATUS_DISCREPANCY_N);
            	obj.setStatusArrivalTime(Constante.STATUS_ARRIVALTIME_Y);
            	obj.setArrivalTime(rs.getString("arrival_time"));
            	obj.setVip(rs.getString("vip"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<HkValueStatus> listarHkRoomArrivalTime(){
		List<HkValueStatus> lista = new ArrayList<HkValueStatus>(); 
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT 98 ROOM_STATUS_ID, ");
            query.append(" 'ARRT' room_status_code,'Arrival Time DI,CL,OS' room_status_desc, ");
            query.append(" COUNT(1) CANTIDAD, ");
            query.append(" 0 CANTIDAD_OCC, ");
            query.append(" COUNT(1) CANTIDAD_VAC, ");
            query.append(" 0 CANTIDAD_DISC ");
            query.append(" FROM OPERA.ROOM r ");
            query.append(" INNER JOIN OPERA.ROOM_CATEGORY_TEMPLATE c ON (r.room_category=c.room_category) ");
            query.append(" LEFT JOIN ( ");
            query.append(" select v.room,v.resv_status,v.departure,v.departure_time,v.arrival,v.arrival_time ");
            query.append(" from reservation_general_view_hld v "); 
            query.append(" inner join ( ");
            query.append(" SELECT V.ROOM,MIN(V.RESV_NAME_ID) RESV_NAME_ID ");
            query.append(" from reservation_general_view_hld v  ");
            query.append(" where v.resv_status ='RESERVED' ");
            query.append(" and TO_CHAR(v.arrival,'DDMMRRRR')=TO_CHAR(pms_p.business_date,'DDMMRRRR') ");
            query.append(" GROUP BY V.ROOM ");
            query.append(" ) m ON (v.RESV_NAME_ID=m.RESV_NAME_ID) ");
            query.append(" where m.RESV_NAME_ID=v.RESV_NAME_ID ");
            query.append(" ) v ON (v.room=r.room)  ");
            query.append(" WHERE r.SUITE_TYPE<>'PSUEDO'  ");
            query.append(" AND r.fo_status='VAC' AND r.room_status IN ('CL','DI','OS') ");
            query.append(" AND v.arrival_time IS NOT NULL ");
            query.append(" GROUP BY r.fo_status ");
            
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	HkValueStatus obj=new HkValueStatus();
            	obj.setId(rs.getInt("ROOM_STATUS_ID"));
            	obj.setCodigo(rs.getString("ROOM_STATUS_CODE"));
            	obj.setDenominacion(rs.getString("ROOM_STATUS_DESC"));
            	obj.setCantidad(rs.getInt("cantidad"));
            	//
            	obj.setCantidadOcc(rs.getInt("CANTIDAD_OCC"));
            	obj.setCantidadVac(rs.getInt("CANTIDAD_VAC"));
            	obj.setCantidadDisc(rs.getInt("CANTIDAD_DISC"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	
	/***
	 * Do Not Disturb
	 */
	
	public List<HkValueStatus> listarHkServiceStatus(String serviceStatus){
		List<HkValueStatus> lista = new ArrayList<HkValueStatus>(); 
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT 97 SERV_STATUS_ID,r.service_status serv_status_code,'Do Not Disturb' serv_status_desc, COUNT(1) CANTIDAD, ");  
            query.append(" SUM(CASE WHEN r.hk_status='OCC' THEN 1 ELSE 0 END) CANTIDAD_OCC, ");
            query.append(" SUM(CASE WHEN r.hk_status='VAC' THEN 1 ELSE 0 END) CANTIDAD_VAC, ");
            query.append(" COUNT(1) CANTIDAD_SERVSTAT ");
            query.append(" FROM OPERA.ROOM r  ");
            query.append(" WHERE r.SUITE_TYPE<>'PSUEDO' "); 
            query.append(" and r.service_status =? ");
            query.append(" group by r.service_status ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, serviceStatus);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	HkValueStatus obj=new HkValueStatus();
            	obj.setId(rs.getInt("SERV_STATUS_ID"));
            	obj.setCodigo(rs.getString("serv_status_code"));
            	obj.setDenominacion(rs.getString("serv_status_desc"));
            	obj.setCantidad(rs.getInt("cantidad"));
            	//
            	obj.setCantidadOcc(rs.getInt("CANTIDAD_OCC"));
            	obj.setCantidadVac(rs.getInt("CANTIDAD_VAC"));
            	obj.setCantidadDisc(rs.getInt("CANTIDAD_SERVSTAT"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<HkRoomStatus> listarHkRoomServiceStatus(String serviceStatus){
		List<HkRoomStatus> lista = new ArrayList<HkRoomStatus>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("  SELECT r.room,r.room_status,r.hk_status,c.label,c.short_description, "); 
            query.append("  CASE WHEN  NVL(v.resv_status,'F')='CHECKED IN' THEN 'CI' WHEN NVL(v.resv_status,'F')='CHECKED OUT' THEN 'CO' ELSE '' END resv_status, "); 
            query.append("  TO_CHAR(v.arrival,'DD/MM') arrival,  ");
            query.append("  TO_CHAR(v.departure,'DD/MM') departure,TO_CHAR(v.departure_time) departure_time "); 
            query.append("  ,CASE WHEN r.hk_status<>r.fo_status THEN 'Y' ELSE 'N' END isdiscrepancy  ");
            query.append("  ,NVL(v.vip,' ') vip ");
            query.append("  FROM OPERA.ROOM r    ");
            query.append("  INNER JOIN OPERA.ROOM_CATEGORY_TEMPLATE c ON (r.room_category=c.room_category) ");  
            query.append("  LEFT JOIN (  ");
            query.append("  select r.room,MIN(r.resv_status) resv_status,min(r.arrival) arrival,max(r.departure) departure,max(r.departure_time) departure_time,MIN(r.vip) vip "); 
            query.append("  from reservation_general_view_hld r  ");
            query.append("  where r.trunc_departure>=pms_p.business_date and r.room is not null "); 
            query.append("  and r.resv_status IN ('CHECKED IN','CHECKED OUT')   ");
            query.append("  group by r.room  ");
            query.append("  ) v ON (v.room=r.room)  ");
            query.append("  WHERE SUITE_TYPE<>'PSUEDO'  "); 
            query.append("  AND r.service_status=? ");
            query.append("  ORDER BY r.hk_status DESC,to_number(r.floor) ASC, to_number(r.room) ASC ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, serviceStatus);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	HkRoomStatus obj=new HkRoomStatus();
            	obj.setRoom(rs.getString("room")); 
            	obj.setRoomStatus(rs.getString("room_status"));
            	obj.setHkStatus(rs.getString("hk_status"));
            	obj.setRoomType(rs.getString("label"));
            	obj.setRoomTypeDescription(rs.getString("short_description"));
            	//
            	obj.setResvStatus(rs.getString("resv_status"));
            	obj.setArrival(rs.getString("arrival"));
            	obj.setDeparture(rs.getString("departure"));
            	obj.setDepartureTime(rs.getString("departure_time"));
            	//
            	obj.setIsDiscrepancy(rs.getString("isdiscrepancy").equals("Y")?Boolean.TRUE:Boolean.FALSE);
            	obj.setStatusDiscrepancy(Constante.STATUS_DISCREPANCY_N);
            	obj.setStatusArrivalTime(Constante.STATUS_ARRIVALTIME_N);
            	obj.setIsDoNotDisturb(Boolean.TRUE);
            	obj.setVip(rs.getString("vip"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	/***
	 * TRACES FOR HK
	 */
	public List<HkValueStatus> listarHkTracesHK(){
		List<HkValueStatus> lista = new ArrayList<HkValueStatus>(); 
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("  SELECT 96 SERV_STATUS_ID,'TRHK' serv_status_code,'Traces for HK' serv_status_desc, COUNT(1) CANTIDAD, ");   
            query.append("  SUM(CASE WHEN r.hk_status='OCC' THEN 1 ELSE 0 END) CANTIDAD_OCC,  ");
            query.append("  SUM(CASE WHEN r.hk_status='VAC' THEN 1 ELSE 0 END) CANTIDAD_VAC, "); 
            query.append("  COUNT(1) CANTIDAD_SERVSTAT "); 
            query.append("  FROM OPERA.ROOM r  "); 
            query.append("  INNER JOIN (   ");
            query.append("  select v.room,v.resv_status,v.departure,v.departure_time,v.arrival,v.arrival_time,g.trace_text ");
            query.append("  from reservation_general_view_hld v   ");
            query.append("  INNER JOIN guest_rsv_traces t ON (v.resv_name_id=t.resv_name_id AND t.dept_id='HK') ");
            query.append("  INNER JOIN guest_traces g ON (g.trace_id=t.trace_id and g.dept_id='HK') ");
            query.append("  where v.room is not null and v.resv_status = 'RESERVED' ");
            query.append("  and TO_CHAR(t.trace_on,'DDMMRRRR')=TO_CHAR(pms_p.business_date,'DDMMRRRR')  ");
            query.append("  and t.status_flag='N'  ");
            query.append("  ) v ON (v.room=r.room)   ");
            query.append("  WHERE r.SUITE_TYPE<>'PSUEDO' ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	HkValueStatus obj=new HkValueStatus();
            	obj.setId(rs.getInt("SERV_STATUS_ID"));
            	obj.setCodigo(rs.getString("serv_status_code"));
            	obj.setDenominacion(rs.getString("serv_status_desc"));
            	obj.setCantidad(rs.getInt("cantidad"));
            	//
            	obj.setCantidadOcc(rs.getInt("CANTIDAD_OCC"));
            	obj.setCantidadVac(rs.getInt("CANTIDAD_VAC"));
            	obj.setCantidadDisc(rs.getInt("CANTIDAD_SERVSTAT"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<HkRoomStatus> listarHkTracesDetailsHK(){
		List<HkRoomStatus> lista = new ArrayList<HkRoomStatus>(); 
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("  SELECT r.room,r.room_status,r.hk_status,c.label,c.short_description,   ");
            query.append("  CASE WHEN  NVL(v.resv_status,'F')='CHECKED IN' THEN 'CI' WHEN NVL(v.resv_status,'F')='CHECKED OUT' THEN 'CO' ELSE '' END resv_status, ");  
            query.append("  TO_CHAR(v.arrival,'DD/MM') arrival,   ");
            query.append("  TO_CHAR(v.departure,'DD/MM') departure,TO_CHAR(v.departure_time) departure_time ");  
            query.append("  ,CASE WHEN r.hk_status<>r.fo_status THEN 'Y' ELSE 'N' END isdiscrepancy ");  
            query.append("  ,v.arrival_time  ");
            query.append("  ,v.trace_text ");
            query.append("  ,NVL(v.vip,' ') vip ");
            query.append("  FROM OPERA.ROOM r     ");
            query.append("  INNER JOIN OPERA.ROOM_CATEGORY_TEMPLATE c ON (r.room_category=c.room_category) "); 
            query.append("  INNER JOIN (   ");
            query.append("  select v.room,v.resv_status,v.departure,v.departure_time,v.arrival,v.arrival_time,g.trace_text,v.vip ");
            query.append("  from reservation_general_view_hld v   ");
            query.append("  INNER JOIN guest_rsv_traces t ON (v.resv_name_id=t.resv_name_id AND t.dept_id='HK') ");
            query.append("  INNER JOIN guest_traces g ON (g.trace_id=t.trace_id and g.dept_id='HK') ");
            query.append("  where v.room is not null and v.resv_status = 'RESERVED' ");
            query.append("  and TO_CHAR(t.trace_on,'DDMMRRRR')=TO_CHAR(pms_p.business_date,'DDMMRRRR')  ");
            query.append("  and t.status_flag='N'  ");
            query.append("  ) v ON (v.room=r.room)   ");
            query.append("  WHERE r.SUITE_TYPE<>'PSUEDO' ");
            query.append("  ORDER BY r.hk_status DESC,to_number(r.floor) ASC, to_number(r.room) ASC ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	HkRoomStatus obj=new HkRoomStatus();
            	obj.setRoom(rs.getString("room")); 
            	obj.setRoomStatus(rs.getString("room_status"));
            	obj.setHkStatus(rs.getString("hk_status"));
            	obj.setRoomType(rs.getString("label"));
            	obj.setRoomTypeDescription(rs.getString("short_description"));
            	//
            	obj.setResvStatus(rs.getString("resv_status"));
            	obj.setArrival(rs.getString("arrival"));
            	obj.setDeparture(rs.getString("departure"));
            	obj.setDepartureTime(rs.getString("departure_time"));
            	//
            	obj.setIsDiscrepancy(Boolean.FALSE);
            	obj.setIsArrivalTime(Boolean.FALSE);
            	obj.setStatusDiscrepancy(Constante.STATUS_DISCREPANCY_N);
            	obj.setStatusArrivalTime(Constante.STATUS_ARRIVALTIME_N);
            	obj.setArrivalTime(rs.getString("arrival_time"));
            	//
            	obj.setIsTracesHk(Boolean.TRUE);
            	obj.setTraceTextHk(rs.getString("trace_text"));
            	obj.setVip(rs.getString("vip"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	/**
	 * Estadistica de habitaciones
	 */
	public List<HkFloors> listarHkEstadistica(){
		List<HkFloors> lista = new ArrayList<HkFloors>(); 
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT SUM(CASE WHEN r.hk_status='OCC' THEN 1 ELSE 0 END) CANTIDAD_OCC, "); 
            query.append(" SUM(CASE WHEN r.hk_status='VAC' THEN 1 ELSE 0 END) CANTIDAD_VAC,  ");
            query.append(" SUM(CASE WHEN r.hk_status<>r.fo_status THEN 1 ELSE 0 END) CANTIDAD_DISC, "); 
            query.append(" SUM(CASE WHEN r.room_status='IP' THEN 1 ELSE 0 END) CANTIDAD_IP,  ");
            query.append(" SUM(CASE WHEN r.room_status='DI' THEN 1 ELSE 0 END) CANTIDAD_DI,  ");
            query.append(" SUM(CASE WHEN r.room_status='CL' THEN 1 ELSE 0 END) CANTIDAD_CL,  ");
            query.append(" SUM(CASE WHEN r.room_status='OO' THEN 1 ELSE 0 END) CANTIDAD_OO,  ");
            query.append(" SUM(CASE WHEN r.room_status='OS' THEN 1 ELSE 0 END) CANTIDAD_OS "); 
            query.append(" ,SUM(o.adults) adults,SUM(o.children) children ");
            query.append(" FROM OPERA.ROOM r    ");
            query.append(" LEFT JOIN ( ");
            query.append(" select v.room ,sum(v.adults) adults, sum(v.children) children  ");  
            query.append(" from reservation_general_view_hld v    ");
            query.append(" where v.resv_status ='CHECKED IN' ");
            query.append(" group by v.room    ");
            query.append(" ) o ON (o.room=r.room)    ");
            query.append(" WHERE r.SUITE_TYPE<>'PSUEDO' ");
            
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	HkFloors obj=new HkFloors();
            	obj.setCantidadOcc(rs.getInt("CANTIDAD_OCC"));
            	obj.setCantidadVac(rs.getInt("CANTIDAD_VAC"));
            	obj.setCantidadDisc(rs.getInt("CANTIDAD_DISC"));
            	
            	obj.setCantidadIp(rs.getInt("CANTIDAD_IP"));
            	obj.setCantidadDi(rs.getInt("CANTIDAD_DI"));
            	obj.setCantidadCl(rs.getInt("CANTIDAD_CL"));
            	obj.setCantidadOo(rs.getInt("CANTIDAD_OO"));
            	obj.setCantidadOs(rs.getInt("CANTIDAD_OS"));
            	//--
            	obj.setAdults(rs.getInt("adults"));
            	obj.setChildren(rs.getInt("children"));
            	
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<HkArrival> listarHkArrivals(){
		List<HkArrival> lista = new ArrayList<HkArrival>(); 
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select COUNT(v.RESV_NAME_ID) arrival_all, ");
            query.append(" SUM(case when v.room is null THEN 1 ELSE 0 end) arrival_room_n, ");
            query.append(" SUM(case when v.room is not null THEN 1 ELSE 0 end) arrival_room_y ");
            query.append(" from reservation_general_view_hld v  ");
            query.append(" where v.resv_status ='RESERVED' ");
            query.append(" and TO_CHAR(v.arrival,'DDMMRRRR')=TO_CHAR(pms_p.business_date,'DDMMRRRR') ");
            query.append(" and v.shared_yn='N' ");
            
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	HkArrival obj=new HkArrival();
            	obj.setArrivalAll(rs.getInt("arrival_all"));
            	obj.setArrivalRoomN(rs.getInt("arrival_room_n"));
            	obj.setArrivalRoomY(rs.getInt("arrival_room_y"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	
	/**
	 * Rate Pack
	 * @return
	 */
	public List<HkRoomStatus> listarHkRatePack(){
		List<HkRoomStatus> lista = new ArrayList<HkRoomStatus>(); 
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("  SELECT r.room,r.room_status,r.hk_status,c.label,c.short_description, ");   
            query.append("  TO_CHAR(v.arrival,'DD/MM') arrival,    ");
            query.append("  TO_CHAR(v.departure,'DD/MM') departure,TO_CHAR(v.departure_time) departure_time ");   
            query.append("  ,CASE WHEN r.hk_status<>r.fo_status THEN 'Y' ELSE 'N' END isdiscrepancy ");   
            query.append("  ,v.arrival_time   ");
            query.append("  ,NVL(v.vip,' ') vip  ");
            query.append("  ,v.rate_code  ");
            query.append("  FROM OPERA.ROOM r ");
            query.append("  INNER JOIN OPERA.ROOM_CATEGORY_TEMPLATE c ON (r.room_category=c.room_category) ");  
            query.append("  INNER JOIN (    ");
            query.append("  select v.room,MAX(v.departure) departure,MAX(v.departure_time) departure_time,MIN(v.arrival) arrival,MIN(v.arrival_time) arrival_time,MAX(v.vip) vip ");
            query.append("  ,MIN(v.rate_code) rate_code ");
            query.append("  from reservation_general_view_hld v ");
            query.append("  where v.resv_status ='RESERVED' ");
            query.append("  AND TO_CHAR(v.arrival,'DDMMRRRR')=TO_CHAR(pms_p.business_date,'DDMMRRRR') ");
            query.append("  AND v.rate_code in ('PQANI','PQBOH','PQREL','PQRFR','PQRNV') ");
            query.append("  AND v.room IS NOT NULL ");
            query.append("  GROUP BY v.room ");
            query.append("  ) v ON (v.room=r.room) ");
            query.append("  WHERE r.SUITE_TYPE<>'PSUEDO' ");
            query.append("  ORDER BY r.hk_status DESC,to_number(r.floor) ASC, to_number(r.room) ASC ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	HkRoomStatus obj=new HkRoomStatus();
            	obj.setRoom(rs.getString("room")); 
            	obj.setRoomStatus(rs.getString("room_status"));
            	obj.setHkStatus(rs.getString("hk_status"));
            	obj.setRoomType(rs.getString("label"));
            	obj.setRoomTypeDescription(rs.getString("short_description"));
            	//
            	obj.setArrival(rs.getString("arrival"));
            	obj.setDeparture(rs.getString("departure"));
            	obj.setDepartureTime(rs.getString("departure_time"));
            	//
            	obj.setIsDiscrepancy(Boolean.FALSE);
            	obj.setIsArrivalTime(Boolean.FALSE);
            	obj.setStatusDiscrepancy(Constante.STATUS_DISCREPANCY_N);
            	obj.setStatusArrivalTime(Constante.STATUS_ARRIVALTIME_N);
            	obj.setArrivalTime(rs.getString("arrival_time"));
            	//
            	obj.setIsTracesHk(Boolean.FALSE);
            	obj.setVip(rs.getString("vip"));
            	//
            	//rate_code
            	obj.setIsRatePack(Boolean.TRUE);
            	obj.setRateCode(rs.getString("rate_code"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	
	public List<HkValueStatus> headerHkRatePack(){
		List<HkValueStatus> lista = new ArrayList<HkValueStatus>(); 
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("  select 95 SERV_STATUS_ID,'RAT-PQ' serv_status_code,'Rate Code Package' serv_status_desc, COUNT(1) CANTIDAD ");
            query.append("  from ( ");
            query.append("  select v.room,COUNT(1) CANTIDAD ");
            query.append("  from reservation_general_view_hld v "); 
            query.append("  where v.resv_status ='RESERVED'  ");
            query.append("  AND TO_CHAR(v.arrival,'DDMMRRRR')=TO_CHAR(pms_p.business_date,'DDMMRRRR') "); 
            query.append("  AND v.rate_code in ('PQANI','PQBOH','PQREL','PQRFR','PQRNV')  ");
            query.append("  AND v.room IS NOT NULL  ");
            query.append("  GROUP BY v.room ) ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	HkValueStatus obj=new HkValueStatus();
            	obj.setId(rs.getInt("SERV_STATUS_ID"));
            	obj.setCodigo(rs.getString("serv_status_code"));
            	obj.setDenominacion(rs.getString("serv_status_desc"));
            	obj.setCantidad(rs.getInt("cantidad"));
            	//
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
}

