package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.delfines.dao.ConnectionFactoryOpera;
import com.delfines.dao.ConnectionFactorySQLAWS;
import com.delfines.vo.AvalBusinessDate;
import com.delfines.vo.AvalCategoryStatus;

public class OperaRoomBo {
	
	public List<AvalCategoryStatus> listRoomCategoryStatus(){
		List<AvalCategoryStatus> lista = new ArrayList<>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select r.n,MAX(convert(varchar(10),r.business_date,103)) business_date,MAX(dbo.GetDiaSemana(convert(date,r.business_date,103))) dia_semana, ");
            query.append(" SUM(CASE WHEN r.category='DL' THEN r.availability ELSE 0 END) category_dl, ");
            query.append(" SUM(CASE WHEN r.category='EK' THEN r.availability ELSE 0 END) category_ek, ");
            query.append(" SUM(CASE WHEN r.category='ET' THEN r.availability ELSE 0 END) category_et, ");
            query.append(" SUM(CASE WHEN r.category='JS' THEN r.availability ELSE 0 END) category_js, ");
            query.append(" SUM(CASE WHEN r.category='PK' THEN r.availability ELSE 0 END) category_pk, ");
            query.append(" SUM(CASE WHEN r.category='PS' THEN r.availability ELSE 0 END) category_ps, ");
            query.append(" SUM(CASE WHEN r.category='PT' THEN r.availability ELSE 0 END) category_pt, ");
            query.append(" SUM(CASE WHEN r.category='SK' THEN r.availability ELSE 0 END) category_sk, ");
            query.append(" SUM(CASE WHEN r.category='SS' THEN r.availability ELSE 0 END) category_ss, ");
            query.append(" SUM(CASE WHEN r.category='ST' THEN r.availability ELSE 0 END) category_st, ");
            query.append(" SUM(r.capacity) capacity, ");
            query.append(" SUM(r.ocupability) ocupability, ");
            query.append(" SUM(r.availability) availability ");
            query.append(" from dbo.room_availability r where r.austate=1 ");
            query.append(" group by r.n ");
            query.append(" order by r.n ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	AvalCategoryStatus obj=new AvalCategoryStatus();
            	obj.setN(rs.getInt("n"));
            	obj.setBusinssDate(rs.getString("business_date"));
            	obj.setDiaSemana(rs.getString("dia_semana"));
            	obj.setAvalCatDL(rs.getInt("category_dl"));
            	obj.setAvalCatEK(rs.getInt("category_ek"));
            	obj.setAvalCatET(rs.getInt("category_et"));
            	obj.setAvalCatJS(rs.getInt("category_js"));
            	obj.setAvalCatPK(rs.getInt("category_pk"));
            	obj.setAvalCatPS(rs.getInt("category_ps"));
            	obj.setAvalCatPT(rs.getInt("category_pt"));
            	obj.setAvalCatSK(rs.getInt("category_sk"));
            	obj.setAvalCatSS(rs.getInt("category_ss"));
            	obj.setAvalCatST(rs.getInt("category_st"));
            	obj.setCapacity(rs.getInt("capacity"));
            	obj.setOcupability(rs.getInt("ocupability"));
            	obj.setAvailability(rs.getInt("availability"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<AvalCategoryStatus> listRoomCategoryStatus(Integer n){
		List<AvalCategoryStatus> lista = new ArrayList<>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select r.n,MAX(convert(varchar(10),r.business_date,103)) business_date,MAX(dbo.GetDiaSemana(convert(date,r.business_date,103))) dia_semana, ");
            query.append(" SUM(CASE WHEN r.category='DL' THEN r.availability ELSE 0 END) category_dl, ");
            query.append(" SUM(CASE WHEN r.category='EK' THEN r.availability ELSE 0 END) category_ek, ");
            query.append(" SUM(CASE WHEN r.category='ET' THEN r.availability ELSE 0 END) category_et, ");
            query.append(" SUM(CASE WHEN r.category='JS' THEN r.availability ELSE 0 END) category_js, ");
            query.append(" SUM(CASE WHEN r.category='PK' THEN r.availability ELSE 0 END) category_pk, ");
            query.append(" SUM(CASE WHEN r.category='PS' THEN r.availability ELSE 0 END) category_ps, ");
            query.append(" SUM(CASE WHEN r.category='PT' THEN r.availability ELSE 0 END) category_pt, ");
            query.append(" SUM(CASE WHEN r.category='SK' THEN r.availability ELSE 0 END) category_sk, ");
            query.append(" SUM(CASE WHEN r.category='SS' THEN r.availability ELSE 0 END) category_ss, ");
            query.append(" SUM(CASE WHEN r.category='ST' THEN r.availability ELSE 0 END) category_st, ");
            query.append(" SUM(r.capacity) capacity, ");
            query.append(" SUM(r.ocupability) ocupability, ");
            query.append(" SUM(r.availability) availability ");
            query.append(" from dbo.room_availability r where r.austate=1 ");
            query.append(" and r.n>=? ");
            query.append(" group by r.n ");
            query.append(" order by r.n ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, n);
            rs = ps.executeQuery();
            
            while(rs.next()){
            	AvalCategoryStatus obj=new AvalCategoryStatus();
            	obj.setN(rs.getInt("n"));
            	obj.setBusinssDate(rs.getString("business_date"));
            	obj.setDiaSemana(rs.getString("dia_semana"));
            	obj.setAvalCatDL(rs.getInt("category_dl"));
            	obj.setAvalCatEK(rs.getInt("category_ek"));
            	obj.setAvalCatET(rs.getInt("category_et"));
            	obj.setAvalCatJS(rs.getInt("category_js"));
            	obj.setAvalCatPK(rs.getInt("category_pk"));
            	obj.setAvalCatPS(rs.getInt("category_ps"));
            	obj.setAvalCatPT(rs.getInt("category_pt"));
            	obj.setAvalCatSK(rs.getInt("category_sk"));
            	obj.setAvalCatSS(rs.getInt("category_ss"));
            	obj.setAvalCatST(rs.getInt("category_st"));
            	obj.setCapacity(rs.getInt("capacity"));
            	obj.setOcupability(rs.getInt("ocupability"));
            	obj.setAvailability(rs.getInt("availability"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<AvalBusinessDate> listBusinessDate(){
		List<AvalBusinessDate> lista = new ArrayList<>(); 
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select r.n,MAX(convert(varchar(10),r.business_date,103)) business_date,MAX(dbo.GetDiaSemana(convert(date,r.business_date,103))) dia_semana ");
            query.append(" from dbo.room_availability r where r.austate=1 "); 
            query.append(" group by r.n  ");
            query.append(" order by r.n ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	StringBuilder item = new StringBuilder();
            	item.append(rs.getString("business_date")).append(" ").append(rs.getString("dia_semana"));
            	AvalBusinessDate obj=new AvalBusinessDate();
            	obj.setN(rs.getInt("n"));
            	obj.setBusinessDate(item.toString());
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
}


