package com.delfines.business;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.apache.taglibs.standard.tag.common.core.OutSupport;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.Constante;
import com.delfines.dao.ConnectionFactory;
import com.delfines.vo.AdSetName;
import com.delfines.vo.AsignaUsuario;
import com.delfines.vo.Correo;
import com.delfines.vo.ErrorLead;
import com.delfines.vo.EventoAlo;
import com.delfines.vo.EventoAyB;
import com.delfines.vo.EventoEve;
import com.delfines.vo.EventoMkt;
import com.delfines.vo.EventoOrg;
import com.delfines.vo.EventoSed;
import com.delfines.vo.Eventos;
import com.delfines.vo.Lead;
import com.delfines.vo.LeadSeguimiento;
import com.delfines.vo.PerfilLead;
import com.delfines.vo.Usuario;
import com.delfines.vo.Value;
import com.delfines.vo.leads.ReporteCorreos;
import com.delfines.vo.leads.ReporteGeneral;

public class RegistroEventosBo {
	
	public String getDateTime(){
		String fecha=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT dbo.getDateTimeAMPM(getdate()) hoy ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	fecha=rs.getString("hoy");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return fecha;
	}
	
	public List<Value> listUsuario(Integer idArea){
		List<Value> lista = new ArrayList<Value>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT e.id_usuario id,upper(e.apellidos_nombres) denominacion FROM dbo.usuario e ");
            query.append("inner join eventos.asigna_usuario au on (au.id_usuario=e.id_usuario and au.estado=1) ");
            query.append("where 1=1 and ");
            if(idArea>0){
            	query.append("e.id_area=? ");
            }else{
            	query.append("e.id_area IN (1,6,9,12) ");//1Ventas//6A&B//9EventosyBanquetes//12Marketing//
            }
            query.append("order by e.apellidos_nombres asc ");
		
            ps = conn.prepareStatement(query.toString());
            if(idArea>0){
            	ps.setInt(1, idArea);
            }
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Value obj=new Value();
            	obj.setId(rs.getInt("id"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	public List<Value> listaPeriodo(){
		List<Value> lista = new ArrayList<Value>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT DISTINCT YEAR(e.fecha_inicio_evento) periodo  FROM eventos.evento e ORDER BY periodo DESC");
		
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Value obj=new Value();
            	obj.setId(rs.getInt("periodo"));
            	obj.setDenominacion(rs.getString("periodo"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<Value> listAdSetName(){
		List<Value> lista = new ArrayList<Value>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select id_adset_name id, denominacion from leads.adset_name where estado='1'  order by denominacion asc ");
		
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Value obj=new Value();
            	obj.setId(rs.getInt("id"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<Value> listArea(){
		List<Value> lista = new ArrayList<Value>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select id_area id, denominacion from dbo.area where id_area IN (1,6,9,12) order by denominacion asc ");//Ventas//A & B//Eventos y Banquetes//Call Center
		
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Value obj=new Value();
            	obj.setId(rs.getInt("id"));
            	obj.setDenominacion(rs.getString("denominacion").toUpperCase());
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}

	
	public Integer guardarEvento(String denominacion,String fechaInicio,String fechaFin,String descripcion,Usuario pUser){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO eventos.evento(fecha_inicio_evento,fecha_fin_evento,denominacion,id_usuario,fechahora_registro,estado,descripcion) ");
            query.append("VALUES(?,?,?,?,getdate(),1,?) ");
            String ids[] = new String[] { "id_evento" };
            
            ps = conn.prepareStatement(query.toString(),ids);
            ps.setDate(1, Util.stringToDate(fechaInicio));
            ps.setDate(2, Util.stringToDate(fechaFin));
            ps.setString(3, denominacion);
            ps.setInt(4, pUser.getUsuarioId());
            ps.setString(5, descripcion);
            //--
            if(ps.executeUpdate()>0){
            	rs = ps.getGeneratedKeys();
                if ( rs.next() ) {
                    pk = rs.getInt(1);
                }
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
		return pk;
	}
	
	
	public Integer actualizarEvento(Integer idEvento,String denominacion,String fechaInicio,String fechaFin,String descripcion,Usuario pUser){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("UPDATE eventos.evento SET ");
            query.append("denominacion = ? ");
            query.append(",fecha_inicio_evento = ? ");
            query.append(",fecha_fin_evento = ? ");
            query.append(",descripcion = ? ");
            query.append("WHERE id_evento=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, denominacion);
            ps.setDate(2, Util.stringToDate(fechaInicio));
            ps.setDate(3, Util.stringToDate(fechaFin));
            ps.setString(4, descripcion);
            ps.setInt(5, idEvento);
            //--
            if(ps.executeUpdate()>0){
            	pk=idEvento;
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
		return pk;
	}
	
	
	
	public Integer eliminarEvento(Integer id,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer res=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("UPDATE eventos.evento SET estado = ?  WHERE id_evento=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, String.valueOf(Constante.ESTADO_ELIMINADO));
            ps.setInt(2, id);
            //--
            res=ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return res;
	}
	
	public List<Value> listaUsuariosByArea(Integer idArea){
		List<Value> lista = new ArrayList<Value>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT u.id_usuario id,upper(u.apellidos_nombres) denominacion "); 
            query.append("FROM dbo.usuario u ");
            query.append("inner join eventos.asigna_usuario a on (u.id_usuario=a.id_usuario) ");
            query.append("WHERE u.audit_estado='1' and a.estado=1 and u.id_area=? ");
            query.append("ORDER BY u.apellidos_nombres asc ");
		
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idArea);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Value obj=new Value();
            	obj.setId(rs.getInt("id"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;	
	}
	
	public Integer actualizaEstadoSeguimiento(Integer idEventoDetail,Integer tab){
		CallableStatement cs = null;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            if(Constante.ID_TAB_ORGANIZACION==tab){
            	query.append("{ call eventos.estado_evento_organizacion(?) }");
            }
            else if(Constante.ID_TAB_SEDE==tab){
            	query.append("{ call eventos.estado_evento_sede(?) }");
            }
            else if(Constante.ID_TAB_EVENTOS==tab){
            	query.append("{ call eventos.estado_evento_eventos(?) }");
            }
            else if(Constante.ID_TAB_ALOJAMIENTO==tab){
            	query.append("{ call eventos.estado_evento_alojamiento(?) }");
            }
            else if(Constante.ID_TAB_AYB==tab){
            	query.append("{ call eventos.estado_evento_ayb(?) }");
            }
            else if(Constante.ID_TAB_MARKETING==tab){
            	query.append("{ call eventos.estado_evento_marketing(?) }");
            }
            
            cs = conn.prepareCall(query.toString());
            cs.setInt(1, idEventoDetail);
            
            cs.execute();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (cs != null) {try {cs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return 1;
	}
	
	public List<Eventos> listarRegistroEventos(String fechaIni,String fechaFin,Integer periodo,Integer idArea,Integer idEjecutivo,Usuario pUser){
		List<Eventos> lista = new ArrayList<Eventos>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT id_evento,periodo_evento,date_fecha_inicio_evento,fecha_inicio_evento,fecha_fin_evento,denominacion,descripcion ");
            query.append(",id_usuario,fecha_registro,ejecutivo,id_area,area ");
            query.append(",organizador,nombre_contacto,telefono_contacto,correo_contacto,servicio_requerido ");
            query.append(",sede_actual,sede_anterior,periodicidad,veces_hotel,contacto_hotel ");
            query.append(",cotiza_eve,ejecutivo_eve,ejecutivo_eve2,revenue_eve,comentario_eve ");
            query.append(",cotiza_alo,ejecutivo_alo,ejecutivo_alo2,ejecutivo_alo3,revenue_alo,comentario_alo ");
            query.append(",cotiza_ayb,ejecutivo_ayb,revenue_ayb,comentario_ayb ");
            query.append(",pagina_web,presencia_web,contacto_mkt,comentario_mkt,nombre_contacto_mkt ");
            query.append("FROM eventos.view_lista_eventos ");
            query.append("WHERE 1=1 ");
			
            if(fechaIni!=null&&fechaIni.trim().length()>0&&
            		fechaFin!=null&&fechaFin.trim().length()>0){
      	    	query.append("and date_fecha_inicio_evento between ? and ? ");
      	    }
            
            if(periodo!=null&&periodo>0){
      	    	query.append("and periodo_evento= ? ");
      	    }
            /*
            if(idArea!=null&&idArea>0){
	            query.append("and id_evento IN ( ");
	            query.append("select eu.id_evento  ");
	            query.append("from eventos.evento_usuario eu  ");
	            query.append("inner join dbo.usuario u on (u.id_usuario=eu.id_usuario) ");
	            query.append("inner join dbo.area a on (a.id_area=u.id_area) ");
	            query.append("where 1=1 ");
	            query.append("and a.id_area=? ");
	            if(idEjecutivo!=null&&idEjecutivo>0){
	            	query.append("and u.id_usuario=? ");
	            }
	            query.append(") ");
            }*/
            
            if(idArea!=null&&idArea>0){
	            query.append("and id_area=? ");
	            
	            if(idEjecutivo!=null&&idEjecutivo>0){
		            query.append("and id_usuario=? ");
	            }
            }
            
            
            
            query.append("ORDER BY date_fecha_inicio_evento ASC ");
            
            Integer index=1;
            
            ps = conn.prepareStatement(query.toString());
            
            if(fechaIni!=null&&fechaIni.trim().length()>0&&
            		fechaFin!=null&&fechaFin.trim().length()>0){
       	    	ps.setDate(index++, Util.stringToDate(fechaIni));
       	    	ps.setDate(index++, Util.stringToDate(fechaFin));
       	    }
            if(periodo!=null&&periodo>0){
            	ps.setInt(index++, periodo);
      	    }
            
            if(idArea!=null&&idArea>0){
            	ps.setInt(index++, idArea);
            	/*
            	if(idEjecutivo!=null&&idEjecutivo>0){
            		ps.setInt(index++, idEjecutivo);
            	}*/
            	
            	 if(idEjecutivo!=null&&idEjecutivo>0){
             		ps.setInt(index++, idEjecutivo);
             	}
      	    }
            
           
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Eventos obj=new Eventos();
            	obj.setIdEvento(rs.getInt("id_evento"));
            	obj.setFechaInicioEvento(rs.getString("fecha_inicio_evento"));
            	obj.setFechaFinEvento(rs.getString("fecha_fin_evento"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	obj.setIdArea(rs.getInt("id_area"));
            	obj.setIdUsuario(rs.getInt("id_usuario"));
            	obj.setFechaHoraRegistro(rs.getString("fecha_registro"));
            	obj.setEjecutivo(rs.getString("ejecutivo"));
            	obj.setArea(rs.getString("area"));
            	obj.setPeriodo(rs.getInt("periodo_evento"));
            	obj.setDescripcion(rs.getString("descripcion"));
            	
	            	EventoOrg obj1=new EventoOrg();
	            	obj1.setOrganizador(rs.getString("organizador"));
	            	obj1.setNombreContacto(rs.getString("nombre_contacto"));
	            	obj1.setTelefonoContacto(rs.getString("telefono_contacto"));
	            	obj1.setCorreoContacto(rs.getString("correo_contacto"));
	            	obj1.setServicio(rs.getString("servicio_requerido"));
            	obj.setEventoOrg(obj1);
            	
	            	EventoSed obj2=new EventoSed();
	            	obj2.setSedeActual(rs.getString("sede_actual"));
	            	obj2.setSedeAnterior(rs.getString("sede_anterior"));
	            	obj2.setPeriodicidad(rs.getString("periodicidad"));
	            	obj2.setVecesHotel(rs.getInt("veces_hotel"));
	            	obj2.setContactoHotel(rs.getString("contacto_hotel"));
            	obj.setEventoSed(obj2);
            	
	            	EventoEve obj3=new EventoEve();
	            	obj3.setCotiza(rs.getString("cotiza_eve"));
	            	obj3.setEjecutivo(rs.getString("ejecutivo_eve"));
	            	obj3.setEjecutivo2(rs.getString("ejecutivo_eve2"));
	            	obj3.setRevenue(rs.getDouble("revenue_eve"));
	            	obj3.setComentario(rs.getString("comentario_eve"));
	            obj.setEventoEve(obj3);
	            	
	            	EventoAlo obj4=new EventoAlo();
	            	obj4.setCotiza(rs.getString("cotiza_alo"));
	            	obj4.setEjecutivo(rs.getString("ejecutivo_alo"));
	            	obj4.setEjecutivo2(rs.getString("ejecutivo_alo2"));
	            	obj4.setEjecutivo3(rs.getString("ejecutivo_alo3"));
	            	obj4.setRevenue(rs.getDouble("revenue_alo"));
	            	obj4.setComentario(rs.getString("comentario_alo"));
	            obj.setEventoAlo(obj4);
	            	
	            	EventoAyB obj5=new EventoAyB();
	            	obj5.setCotiza(rs.getString("cotiza_ayb"));
	            	obj5.setEjecutivo(rs.getString("ejecutivo_ayb"));
	            	obj5.setRevenue(rs.getDouble("revenue_ayb"));
	            	obj5.setComentario(rs.getString("comentario_ayb"));
	            obj.setEventoAyB(obj5);
	            	
	            	EventoMkt obj6=new EventoMkt();
	            	obj6.setPaginaWeb(rs.getString("pagina_web"));
	            	obj6.setPresenciaWeb(rs.getString("presencia_web"));
	            	obj6.setNombreContacto(rs.getString("nombre_contacto_mkt"));
	            	obj6.setComentario(rs.getString("comentario_mkt"));
            	obj.setEventoMkt(obj6);
            	
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public Integer guardarEventoOrganizacion(Integer idEvento,String organizador,String nombreContacto,String telefonoContacto,String correoContacto,Integer idServicio,Usuario pUser){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO eventos.evento_organizacion(id_evento,organizador,nombre_contacto,telefono_contacto,correo_contacto,id_servicio,id_usuario,fechahora_registro,estado) ");
            query.append("VALUES(?,?,?,?,?,?,?,getdate(),1) ");
            String ids[] = new String[] { "id_evento_organizacion" };
            
            ps = conn.prepareStatement(query.toString(),ids);
            ps.setInt(1, idEvento);
            ps.setString(2, organizador);
            ps.setString(3, nombreContacto);
            ps.setString(4, telefonoContacto);
            ps.setString(5, correoContacto);
            ps.setInt(6, idServicio);
            ps.setInt(7, pUser.getUsuarioId());
            //--
            if(ps.executeUpdate()>0){
            	rs = ps.getGeneratedKeys();
                if ( rs.next() ) {
                    pk = rs.getInt(1);
                }
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
		return pk;
	}
	
	
	public Integer guardarEventoSede(Integer idEvento,String sedeActual,String sedeAnterior,Integer idPeriodicidad,Integer vecesHotel,Integer idContactoHotel,Usuario pUser){
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO eventos.evento_sede(id_evento,sede_actual,sede_anterior,id_periodicidad,veces_hotel,id_contacto_hotel,id_usuario,fechahora_registro,estado) ");
            query.append("VALUES(?,?,?,?,?,?,?,getdate(),1) ");
            String ids[] = new String[] { "id_evento_sede" };
            
            ps = conn.prepareStatement(query.toString(),ids);
            ps.setInt(1, idEvento);
            ps.setString(2, sedeActual);
            ps.setString(3, sedeAnterior);
            ps.setInt(4, idPeriodicidad);
            ps.setInt(5, vecesHotel==null?0:vecesHotel);
            ps.setInt(6, idContactoHotel);
            ps.setInt(7, pUser.getUsuarioId());
            //--
            if(ps.executeUpdate()>0){
            	rs = ps.getGeneratedKeys();
                if ( rs.next() ) {
                    pk = rs.getInt(1);
                }
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
		return pk;
	}
	
	public Integer guardarEventoEventos(Integer idEvento,String cotiza,Integer idEjecutivo,Integer idEjecutivo2,Double revenue,String comentario,Usuario pUser){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO eventos.evento_eventos(id_evento,cotiza,id_ejecutivo,id_ejecutivo2,revenue,comentario,id_usuario,fechahora_registro,estado) ");
            query.append("VALUES(?,?,?,?,?,?,?,getdate(),1) ");
            String ids[] = new String[] { "id_evento_eventos" };
            
            ps = conn.prepareStatement(query.toString(),ids);
            ps.setInt(1, idEvento);
            ps.setString(2, cotiza);
            ps.setInt(3, idEjecutivo);
            ps.setInt(4, idEjecutivo2);
            ps.setDouble(5, revenue==null?0.0:revenue);
            ps.setString(6, comentario);
            ps.setInt(7, pUser.getUsuarioId());
            //--
            if(ps.executeUpdate()>0){
            	rs = ps.getGeneratedKeys();
                if ( rs.next() ) {
                    pk = rs.getInt(1);
                }
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
		return pk;
	}
	
	public Integer guardarEventoAlojamiento(Integer idEvento,String cotiza,Integer idEjecutivo,Integer idEjecutivo2,Integer idEjecutivo3,Double revenue,String comentario,Usuario pUser){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO eventos.evento_alojamiento(id_evento,cotiza,id_ejecutivo,id_ejecutivo2,id_ejecutivo3,revenue,comentario,id_usuario,fechahora_registro,estado) ");
            query.append("VALUES(?,?,?,?,?,?,?,?,getdate(),1) ");
            String ids[] = new String[] { "id_evento_alojamiento" };
            
            ps = conn.prepareStatement(query.toString(),ids);
            ps.setInt(1, idEvento);
            ps.setString(2, cotiza);
            ps.setInt(3, idEjecutivo);
            ps.setInt(4, idEjecutivo2);
            ps.setInt(5, idEjecutivo3);
            ps.setDouble(6, revenue==null?0.0:revenue);
            ps.setString(7, comentario);
            ps.setInt(8, pUser.getUsuarioId());
            //--
            if(ps.executeUpdate()>0){
            	rs = ps.getGeneratedKeys();
                if ( rs.next() ) {
                    pk = rs.getInt(1);
                }
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
		return pk;
	}
	
	public Integer guardarEventoAyB(Integer idEvento,String cotiza,Integer idEjecutivo,Double revenue,String comentario,Usuario pUser){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO eventos.evento_ayb(id_evento,cotiza,id_ejecutivo,revenue,comentario,id_usuario,fechahora_registro,estado) ");
            query.append("VALUES(?,?,?,?,?,?,getdate(),1) ");
            String ids[] = new String[] { "id_evento_ayb" };
            
            ps = conn.prepareStatement(query.toString(),ids);
            ps.setInt(1, idEvento);
            ps.setString(2, cotiza);
            ps.setInt(3, idEjecutivo);
            ps.setDouble(4, revenue==null?0.0:revenue);
            ps.setString(5, comentario);
            ps.setInt(6, pUser.getUsuarioId());
            //--
            if(ps.executeUpdate()>0){
            	rs = ps.getGeneratedKeys();
                if ( rs.next() ) {
                    pk = rs.getInt(1);
                }
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
		return pk;
	}
	
	public Integer guardarEventoMarketing(Integer idEvento,String paginaWeb,String presenciaWeb,String nombreContacto,String comentario,Usuario pUser){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO eventos.evento_marketing(id_evento,pagina_web,presencia_web,nombre_contacto,comentario,id_usuario,fechahora_registro,estado) ");
            query.append("VALUES(?,?,?,?,?,?,getdate(),1) ");
            String ids[] = new String[] { "id_evento_marketing" };
            
            ps = conn.prepareStatement(query.toString(),ids);
            ps.setInt(1, idEvento);
            ps.setString(2, paginaWeb);
            ps.setString(3, presenciaWeb);
            ps.setString(4, nombreContacto);
            ps.setString(5, comentario);
            ps.setInt(6, pUser.getUsuarioId());
            //--
            if(ps.executeUpdate()>0){
            	rs = ps.getGeneratedKeys();
                if ( rs.next() ) {
                    pk = rs.getInt(1);
                }
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
		return pk;
	}
	
	
	/*
	 * Detalle
	 */
	
	public Eventos getEventoGen(Integer idEvento){
		Eventos obj = null; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT e.id_evento  ");
            query.append(",dbo.getDateDDMMYYYY(e.fecha_inicio_evento) fecha_inicio_evento "); 
            query.append(",dbo.getDateDDMMYYYY(e.fecha_fin_evento)  fecha_fin_evento "); 
            query.append(",e.denominacion  ");
            query.append(",e.descripcion ");
            query.append(",YEAR(fecha_inicio_evento) periodo ");
            query.append("FROM eventos.evento e  ");
            query.append("WHERE e.id_evento=? ");
			
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idEvento);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	obj=new Eventos();
            	obj.setIdEvento(idEvento);
            	obj.setFechaInicioEvento(rs.getString("fecha_inicio_evento"));
            	obj.setFechaFinEvento(rs.getString("fecha_fin_evento"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	obj.setDescripcion(rs.getString("descripcion"));
            	obj.setPeriodo(rs.getInt("periodo"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}
	
	
	public EventoOrg getEventoOrg(Integer idEvento){
		EventoOrg obj = null; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT TOP 1 o.id_evento_organizacion ");
            query.append(",o.id_evento ");
            query.append(",o.organizador ");
            query.append(",o.nombre_contacto ");
            query.append(",o.telefono_contacto ");
            query.append(",o.correo_contacto ");
            query.append(",o.id_servicio ");
            query.append(",s.denominacion servicio ");
            query.append(",o.id_usuario ");
            query.append(",dbo.getDateTimeAMPM(o.fechahora_registro) fechahora_registro ");
            query.append(",o.estado ");
            query.append("FROM eventos.evento_organizacion o ");
            query.append("LEFT JOIN eventos.servicio s on (o.id_servicio=s.id_servicio) ");
            query.append("WHERE o.id_evento=? AND o.estado=1 ORDER BY o.fechahora_registro DESC ");
			
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idEvento);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	obj=new EventoOrg();
            	obj.setIdEvento(rs.getInt("id_evento"));
            	obj.setIdEventoOrganizacion(rs.getInt("id_evento_organizacion"));
            	obj.setIdUsuario(rs.getInt("id_usuario"));
            	obj.setFechaHoraRegistro(rs.getString("fechahora_registro"));
            	obj.setEstado(rs.getInt("estado"));
            	obj.setOrganizador(rs.getString("organizador"));
            	obj.setNombreContacto(rs.getString("nombre_contacto"));
            	obj.setTelefonoContacto(rs.getString("telefono_contacto"));
            	obj.setCorreoContacto(rs.getString("correo_contacto"));
            	obj.setIdServicio(rs.getInt("id_servicio"));
            	obj.setServicio(rs.getString("servicio"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}
	
	
	public EventoSed getEventoSed(Integer idEvento){
		EventoSed obj = null; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT TOP 1 e.id_evento_sede ");
            query.append(",e.id_evento ");
            query.append(",e.sede_actual ");
            query.append(",e.sede_anterior ");
            query.append(",e.id_periodicidad ");
            query.append(",p.denominacion periodicidad ");
            query.append(",e.veces_hotel ");
            query.append(",e.id_contacto_hotel ");
            query.append(",u.apellidos_nombres contacto_hotel ");
            query.append(",e.id_usuario ");
            query.append(",a.username usuario ");
            query.append(",dbo.getDateTimeAMPM(e.fechahora_registro) fechahora_registro ");
            query.append(",e.estado ");
            query.append("FROM eventos.evento_sede e ");
            query.append("INNER JOIN dbo.usuario a ON (a.id_usuario=e.id_usuario) ");
            query.append("LEFT JOIN eventos.periodicidad p ON (e.id_periodicidad=p.id_periodicidad) ");
            query.append("LEFT JOIN dbo.usuario u ON (u.id_usuario=e.id_contacto_hotel) ");
            query.append("WHERE e.id_evento=? AND e.estado=1 ORDER BY e.fechahora_registro DESC ");
			
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idEvento);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	obj=new EventoSed();
            	obj.setIdEvento(rs.getInt("id_evento"));
            	obj.setIdEventoSede(rs.getInt("id_evento_sede"));
            	obj.setIdUsuario(rs.getInt("id_usuario"));
            	obj.setUsuario(rs.getString("usuario"));
            	obj.setFechaHoraRegistro(rs.getString("fechahora_registro"));
            	
            	obj.setSedeActual(rs.getString("sede_actual"));
            	obj.setSedeAnterior(rs.getString("sede_anterior"));
            	obj.setIdPeriodicidad(rs.getInt("id_periodicidad"));
            	obj.setVecesHotel(rs.getInt("veces_hotel"));
            	obj.setIdContactoHotel(rs.getInt("id_contacto_hotel"));
            	obj.setContactoHotel(rs.getString("contacto_hotel"));
            	
            	obj.setPeriodicidad(rs.getString("periodicidad"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}
	
	
	public EventoEve getEventoEven(Integer idEvento){
		EventoEve obj = null; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT TOP 1 e.id_evento_eventos ");
            query.append(",e.id_evento ");
            query.append(",e.cotiza ");
            query.append(",e.id_ejecutivo ");
            query.append(",u.apellidos_nombres ");
	            query.append(",e.id_ejecutivo2 ");
	            query.append(",u2.apellidos_nombres apellidos_nombres2 ");
            query.append(",e.revenue ");
            query.append(",e.comentario ");
            query.append(",e.id_usuario ");
            query.append(",a.username usuario ");
            query.append(",dbo.getDateTimeAMPM(e.fechahora_registro) fechahora_registro");
            query.append(",e.estado ");
            query.append("FROM eventos.evento_eventos e ");
            query.append("INNER JOIN dbo.usuario a ON (a.id_usuario=e.id_usuario) ");
            query.append("LEFT JOIN dbo.usuario u ON (u.id_usuario=e.id_ejecutivo) ");
            query.append("LEFT JOIN dbo.usuario u2 ON (u2.id_usuario=e.id_ejecutivo2) ");
            query.append("WHERE e.id_evento=? AND e.estado=1 ORDER BY e.fechahora_registro DESC ");
			
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idEvento);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	obj=new EventoEve();
            	obj.setIdEvento(rs.getInt("id_evento"));
            	obj.setIdEventoEventos(rs.getInt("id_evento_eventos"));
            	obj.setIdUsuario(rs.getInt("id_usuario"));
            	obj.setUsuario(rs.getString("usuario"));
            	obj.setFechaHoraRegistro(rs.getString("fechahora_registro"));
            	
            	obj.setCotiza(rs.getString("cotiza"));
            	obj.setIdEjecutivo(rs.getInt("id_ejecutivo"));
            	obj.setIdEjecutivo2(rs.getInt("id_ejecutivo2"));
            	obj.setEjecutivo(rs.getString("apellidos_nombres"));
            	obj.setEjecutivo2(rs.getString("apellidos_nombres2"));
            	obj.setRevenue(rs.getDouble("revenue"));
            	obj.setComentario(rs.getString("comentario"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}
	
	
	public EventoAlo getEventoAlo(Integer idEvento){
		EventoAlo obj = null; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT TOP 1 e.id_evento_alojamiento ");
            query.append(",e.id_evento ");
            query.append(",e.cotiza ");
            query.append(",e.id_ejecutivo ");
            query.append(",u.apellidos_nombres ");
	            query.append(",e.id_ejecutivo2 ");
	            query.append(",u2.apellidos_nombres apellidos_nombres2 ");
	            query.append(",e.id_ejecutivo3 ");
	            query.append(",u3.apellidos_nombres apellidos_nombres3 ");
            query.append(",e.revenue ");
            query.append(",e.comentario ");
            query.append(",e.id_usuario ");
            query.append(",a.username usuario ");
            query.append(",dbo.getDateTimeAMPM(e.fechahora_registro) fechahora_registro");
            query.append(",e.estado ");
            query.append("FROM eventos.evento_alojamiento e ");
            query.append("INNER JOIN dbo.usuario a ON (a.id_usuario=e.id_usuario) ");
            query.append("LEFT JOIN dbo.usuario u ON (u.id_usuario=e.id_ejecutivo) ");
            query.append("LEFT JOIN dbo.usuario u2 ON (u2.id_usuario=e.id_ejecutivo2) ");
            query.append("LEFT JOIN dbo.usuario u3 ON (u3.id_usuario=e.id_ejecutivo3) ");
            query.append("WHERE e.id_evento=? AND e.estado=1 ORDER BY e.fechahora_registro DESC ");
			
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idEvento);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	obj=new EventoAlo();
            	obj.setIdEvento(rs.getInt("id_evento"));
            	obj.setIdEventoAlo(rs.getInt("id_evento_alojamiento"));
            	obj.setIdUsuario(rs.getInt("id_usuario"));
            	obj.setUsuario(rs.getString("usuario"));
            	obj.setFechaHoraRegistro(rs.getString("fechahora_registro"));
            	obj.setCotiza(rs.getString("cotiza"));
            	obj.setIdEjecutivo(rs.getInt("id_ejecutivo"));
            	obj.setIdEjecutivo2(rs.getInt("id_ejecutivo2"));
            	obj.setIdEjecutivo3(rs.getInt("id_ejecutivo3"));
            	obj.setEjecutivo(rs.getString("apellidos_nombres"));
            	obj.setEjecutivo2(rs.getString("apellidos_nombres2"));
            	obj.setEjecutivo3(rs.getString("apellidos_nombres3"));
            	obj.setRevenue(rs.getDouble("revenue"));
            	obj.setComentario(rs.getString("comentario"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return obj;
	}
	
	
	public EventoAyB getEventoAyB(Integer idEvento){
		EventoAyB obj = null; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT TOP 1 e.id_evento_ayb ");
            query.append(",e.id_evento ");
            query.append(",e.cotiza ");
            query.append(",e.id_ejecutivo ");
            query.append(",u.apellidos_nombres ");
            query.append(",e.revenue ");
            query.append(",e.comentario ");
            query.append(",e.id_usuario ");
            query.append(",a.username usuario ");
            query.append(",dbo.getDateTimeAMPM(e.fechahora_registro) fechahora_registro");
            query.append(",e.estado ");
            query.append("FROM eventos.evento_ayb e ");
            query.append("INNER JOIN dbo.usuario a ON (a.id_usuario=e.id_usuario) ");
            query.append("LEFT JOIN dbo.usuario u ON (u.id_usuario=e.id_ejecutivo) ");
            query.append("WHERE e.id_evento=? AND e.estado=1 ORDER BY e.fechahora_registro DESC ");
			
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idEvento);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	obj=new EventoAyB();
            	obj.setIdEvento(rs.getInt("id_evento"));
            	obj.setIdEventoAyB(rs.getInt("id_evento_ayb"));
            	obj.setIdUsuario(rs.getInt("id_usuario"));
            	obj.setUsuario(rs.getString("usuario"));
            	obj.setFechaHoraRegistro(rs.getString("fechahora_registro"));
            	
            	obj.setCotiza(rs.getString("cotiza"));
            	obj.setIdEjecutivo(rs.getInt("id_ejecutivo"));
            	obj.setEjecutivo(rs.getString("apellidos_nombres"));
            	obj.setRevenue(rs.getDouble("revenue"));
            	obj.setComentario(rs.getString("comentario"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}
	
	
	public EventoMkt getEventoMkt(Integer idEvento){
		EventoMkt obj = null; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT TOP 1 e.id_evento_marketing ");
            query.append(",e.id_evento ");
            query.append(",e.id_ejecutivo ");
            query.append(",u.apellidos_nombres ");
            query.append(",e.pagina_web ");
            query.append(",e.presencia_web ");
            query.append(",e.comentario ");
            query.append(",e.id_usuario ");
            query.append(",a.username usuario ");
            query.append(",dbo.getDateTimeAMPM(e.fechahora_registro) fechahora_registro");
            query.append(",e.estado ");
            query.append(",e.nombre_contacto nombre_contacto_mkt ");
            query.append("FROM eventos.evento_marketing e ");
            query.append("INNER JOIN dbo.usuario a ON (a.id_usuario=e.id_usuario) ");
            query.append("LEFT JOIN dbo.usuario u ON (u.id_usuario=e.id_ejecutivo) ");
            query.append("WHERE e.id_evento=? AND e.estado=1 ORDER BY e.fechahora_registro DESC ");
			
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idEvento);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	obj=new EventoMkt();
            	obj.setIdEvento(rs.getInt("id_evento"));
            	obj.setIdEventoMkt(rs.getInt("id_evento_marketing"));
            	obj.setIdUsuario(rs.getInt("id_usuario"));
            	obj.setUsuario(rs.getString("usuario"));
            	obj.setFechaHoraRegistro(rs.getString("fechahora_registro"));
            	
            	obj.setPaginaWeb(rs.getString("pagina_web"));
            	obj.setPresenciaWeb(rs.getString("presencia_web"));
            	
            	obj.setNombreContacto(rs.getString("nombre_contacto_mkt"));
            	obj.setComentario(rs.getString("comentario"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}
	
	
}


 



