package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.delfines.Constante;
import com.delfines.dao.ConnectionFactory;
import com.delfines.dao.ConnectionFactoryReservas;
import com.delfines.vo.Cliente;
import com.delfines.vo.EventoAlo;
import com.delfines.vo.EventoAyB;
import com.delfines.vo.EventoEve;
import com.delfines.vo.EventoMkt;
import com.delfines.vo.EventoOrg;
import com.delfines.vo.EventoSed;
import com.delfines.vo.Eventos;
import com.delfines.vo.Usuario;
import com.delfines.vo.Value;
import com.delfines.vo.reservas.Ejecutivo;
import com.delfines.vo.reservas.Reservas;

public class RegistroReservasBo {
	
	public String getDate(){
		String fecha=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT convert(varchar(20),getdate(),103) hoy ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	fecha=rs.getString("hoy");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return fecha;
	}
	
	public String getDateAdd3(){
		String fecha=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT convert(varchar(20),getdate()+3,103) hoy ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	fecha=rs.getString("hoy");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return fecha;
	}
	
	
	public String getDateTime(){
		String fecha=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactoryReservas.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT dbo.getDateTimeAMPM(getdate()) hoy ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	fecha=rs.getString("hoy");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return fecha;
	}
	
	public List<Ejecutivo> listEjecutivo(){
		List<Ejecutivo> lista = new ArrayList<Ejecutivo>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactoryReservas.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT e.id_ejecutivo,e.apellidos_nombres,e.login FROM dbo.ejecutivo e WHERE e.estado=1 ORDER BY e.apellidos_nombres ASC ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Ejecutivo obj=new Ejecutivo();
            	obj.setEjecutivoId(rs.getInt("id_ejecutivo"));
            	obj.setApellidosNombres(rs.getString("apellidos_nombres"));
            	obj.setLogin(rs.getString("login"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	public List<Value> listTipoReserva(){
		List<Value> lista = new ArrayList<Value>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactoryReservas.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT e.id_tipo_reserva,e.denominacion FROM dbo.tipo_reserva e ORDER BY e.denominacion ASC ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Value obj=new Value();
            	obj.setId(rs.getInt("id_tipo_reserva"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	public List<Value> listOutlet(){
		List<Value> lista = new ArrayList<Value>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactoryReservas.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT e.id_outlet,e.denominacion FROM dbo.outlet e ORDER BY e.denominacion ASC ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Value obj=new Value();
            	obj.setId(rs.getInt("id_outlet"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	public List<Value> listClientes(){
		List<Value> lista = new ArrayList<Value>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactoryReservas.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT c.id_cliente id,(c.nro_documento+' '+c.denominacion) denominacion FROM dbo.cliente c ORDER BY c.denominacion DESC ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Value obj=new Value();
            	obj.setId(rs.getInt("id"));
            	obj.setDenominacion(rs.getString("denominacion").trim());
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	public Integer guardarReserva(Integer idCliente,Integer idTipoReserva,Integer idOutlet,Integer adultos,Integer ninos,String fechaReserva,String horaReserva,Double ventaEstimada,String observacion,Usuario pUser){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactoryReservas.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO dbo.reservas(id_cliente,id_ejecutivo,id_tipo_reserva,id_outlet,cant_adultos,cant_menores,fecha_reserva,hhmm_reserva,venta_proyectada,comentarios,fecha_registro) ");
            query.append("VALUES(?,?,?,?,?,?,?,?,?,?,getdate()) ");
            String ids[] = new String[] { "id_reserva" };
            
            ps = conn.prepareStatement(query.toString(),ids);
            
            ps.setInt(1, idCliente);
            ps.setInt(2, 1);//id_ejecutivo
            ps.setInt(3, idTipoReserva);
            ps.setInt(4, idOutlet);
            ps.setInt(5, adultos);
            ps.setInt(6, ninos);
            ps.setDate(7, Util.stringToDate(fechaReserva));
            ps.setString(8, horaReserva);
            ps.setDouble(9, ventaEstimada);
            ps.setString(10, observacion);
            
            //--
            if(ps.executeUpdate()>0){
            	rs = ps.getGeneratedKeys();
                if ( rs.next() ) {
                    pk = rs.getInt(1);
                }
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
		return pk;
	}
	
	
	public Integer actualizarReserva(Integer idRegistro,Integer idCliente,Integer idTipoReserva,Integer idOutlet,Integer adultos,Integer ninos,String fechaReserva,String horaReserva,Double ventaEstimada,String observacion,Usuario pUser){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactoryReservas.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.reservas ");
            query.append("SET id_cliente = ? ");
            query.append(",id_ejecutivo = ? ");
            query.append(",id_tipo_reserva = ? ");
            query.append(",id_outlet = ? ");
            query.append(",cant_adultos = ? ");
            query.append(",cant_menores = ? ");
            query.append(",fecha_reserva = ? ");
            query.append(",hhmm_reserva = ? ");
            query.append(",venta_proyectada = ? ");
            query.append(",comentarios = ? ");
            query.append("WHERE id_reserva=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idCliente);
            ps.setInt(2, 1);//id_ejecutivo
            ps.setInt(3, idTipoReserva);
            ps.setInt(4, idOutlet);
            ps.setInt(5, adultos);
            ps.setInt(6, ninos);
            ps.setDate(7, Util.stringToDate(fechaReserva));
            ps.setString(8, horaReserva);
            ps.setDouble(9, ventaEstimada);
            ps.setString(10, observacion);
            ps.setInt(11, idRegistro);
            //--
            if(ps.executeUpdate()>0){
            	pk=idRegistro;
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
		return pk;
	}
	
	
	public List<Reservas> listarReservas(String fechaIni,String fechaFin,Integer idOutlet,Integer idTipoReserva,Integer idEjecutivo){
		List<Reservas> lista = new ArrayList<Reservas>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryReservas.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT r.id_reserva,r.id_cliente,r.id_ejecutivo,r.id_tipo_reserva,r.id_outlet, "); 
            query.append("r.cant_adultos,r.cant_menores,convert(varchar, r.fecha_reserva, 103) fecha_reserva,r.hhmm_reserva,r.venta_proyectada, "); 
            query.append("r.comentarios, ");
            query.append("(c.denominacion) apellidos_nombres, ");
            query.append("(c.nro_documento+' '+c.denominacion) sel_apellidos_nombres, ");
            query.append("c.telefono,c.nro_socio, ");
            query.append("tr.denominacion tipo_reserva, ");
            query.append("oo.denominacion outlet, ");
            query.append("e.login ejecutivo, ");
            query.append("r.check_venta_neta,r.check_nro_micros, ");
            query.append("convert(varchar, r.fecha_registro, 103) + right(convert(varchar(32),r.fecha_registro,100),8) fecha_registro ");
            query.append("FROM dbo.reservas r ");
            query.append("inner join dbo.cliente c on (c.id_cliente=r.id_cliente) ");
            query.append("inner join dbo.tipo_reserva tr on (tr.id_tipo_reserva=r.id_tipo_reserva) ");
            query.append("inner join dbo.outlet oo on (oo.id_outlet=r.id_outlet) ");
            query.append("inner join dbo.ejecutivo e on (e.id_ejecutivo=r.id_ejecutivo) ");
            query.append("WHERE 1=1 ");
			
            if(fechaIni!=null&&fechaIni.trim().length()>0&&
            		fechaFin!=null&&fechaFin.trim().length()>0){
      	    	query.append("and r.fecha_reserva between ? and ? ");
      	    }
            
            if(idOutlet!=null&&idOutlet>0){
      	    	query.append("and r.id_outlet= ? ");
      	    }
            
            if(idTipoReserva!=null&&idTipoReserva>0){
	            query.append("and r.id_tipo_reserva=? ");
            }
            
            if(idEjecutivo!=null&&idEjecutivo>0){
	            query.append("and r.id_ejecutivo=? ");
            }
            
            query.append("ORDER BY r.fecha_reserva ASC ");
            
            Integer index=1;
            
            ps = conn.prepareStatement(query.toString());
            
            if(fechaIni!=null&&fechaIni.trim().length()>0&&
            		fechaFin!=null&&fechaFin.trim().length()>0){
       	    	ps.setDate(index++, Util.stringToDate(fechaIni));
       	    	ps.setDate(index++, Util.stringToDate(fechaFin));
       	    }
            if(idOutlet!=null&&idOutlet>0){
            	ps.setInt(index++, idOutlet);
      	    }
            if(idTipoReserva!=null&&idTipoReserva>0){
            	ps.setInt(index++, idTipoReserva);
      	    }
            if(idEjecutivo!=null&&idEjecutivo>0){
         		ps.setInt(index++, idEjecutivo);
         	}            
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Reservas obj=new Reservas();
            	obj.setIdReserva(rs.getInt("id_reserva"));
            	obj.setIdCliente(rs.getInt("id_cliente"));
            	obj.setIdEjecutivo(rs.getInt("id_ejecutivo"));
            		obj.setIdTipoReserva(rs.getInt("id_tipo_reserva"));
            		obj.setIdOutlet(rs.getInt("id_outlet"));
            	obj.setCantAdultos(rs.getInt("cant_adultos"));
            	obj.setCantMenores(rs.getInt("cant_menores"));
            	obj.setFechaReserva(rs.getString("fecha_reserva"));
            	obj.setHhmmReserva(rs.getString("hhmm_reserva"));
            	obj.setVentaProyectada(rs.getDouble("venta_proyectada"));
            	obj.setComentarios(rs.getString("comentarios"));
            	//--
            	obj.setCliente(rs.getString("apellidos_nombres"));
            	obj.setSelCliente(rs.getString("sel_apellidos_nombres"));
            	
            	obj.setTelefono(rs.getString("telefono"));
            	obj.setVipclub(rs.getString("nro_socio"));
            	obj.setTipoReserva(rs.getString("tipo_reserva"));
            	obj.setOutlet(rs.getString("outlet"));
            	obj.setEjecutivo(rs.getString("ejecutivo"));
            	//
            	obj.setFechaCreacion(rs.getString("fecha_registro"));
            	//
            	obj.setCheckVentaNeta(rs.getDouble("check_venta_neta"));
            	obj.setCheckNroMicros(rs.getString("check_nro_micros"));
            	
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public Integer registraCliente(Integer idTipoCliente,Integer idTipoDocumento,String denominacion,
			   String nrodocumento,String telefono,String correo,Integer idDistrito,String nroSocio,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
     try {
     	Connection conn = ConnectionFactoryReservas.getInstance().getConnection();
         
         StringBuilder query = new StringBuilder();
         query.append("INSERT INTO dbo.cliente(id_tipo_cliente,id_tipo_documento,nro_documento,denominacion ");
         query.append(",telefono,id_distrito,correo,nro_socio,estado ");
         query.append(",audit_usuarioid,audit_fechahora,audit_terminal,audit_estado) ");
         query.append("VALUES ");
         query.append("(?,?,?,? ");
         query.append(",?,?,?,?,? ");
         query.append(",?,getdate(),?,1) ");
         
         String ids[] = new String[] { "id_cliente" };
         
         ps = conn.prepareStatement(query.toString(),ids);
         ps.setInt(1, idTipoCliente);
         ps.setInt(2, idTipoDocumento);
         ps.setString(3, nrodocumento);
	        ps.setString(4, denominacion);
	            ps.setString(5, telefono);
	            ps.setInt(6, idDistrito);
	            ps.setString(7, correo);
	            ps.setString(8, nroSocio);
	            ps.setInt(9, Constante.ESTADO_ACTIVO);
         ps.setInt(10, pUsuario.getUsuarioId());
         ps.setString(11, Constante.TERMINAL);
         //--
         if(ps.executeUpdate()>0){
         	rs = ps.getGeneratedKeys();
             if ( rs.next() ) {
                 pk = rs.getInt(1);
             }
         }
         
     } catch (SQLException e) {
         throw new RuntimeException(e);
     } catch (Exception e) {
         throw new RuntimeException(e);
     }finally {
     	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
         if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
     }
     
     return pk;
	}
	
	
	public Integer actualizaCliente(Integer idCliente,Integer idTipoCliente,Integer idTipoDocumento,String denominacion,
			   String nrodocumento,String telefono,String correo,Integer idDistrito,String nroSocio,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer res=0;
     try {
     	Connection conn = ConnectionFactoryReservas.getInstance().getConnection();
         
         StringBuilder query = new StringBuilder();
         query.append("UPDATE dbo.cliente ");
         query.append("SET id_tipo_cliente = ? ");
         query.append(",id_tipo_documento = ? ");
         query.append(",nro_documento = ? ");
         query.append(",denominacion = ? ");
	            query.append(",telefono = ? ");
	            query.append(",correo = ? ");
	            query.append(",id_distrito = ? ");
	            query.append(",nro_socio = ? ");
         query.append(",audit_usuarioid = ? ");
         query.append(",audit_fechahora = getdate() ");
         query.append(",audit_terminal = ? ");
         query.append("WHERE id_cliente=? ");
         
         ps = conn.prepareStatement(query.toString());
         ps.setInt(1, idTipoCliente);
         ps.setInt(2, idTipoDocumento);
         ps.setString(3, nrodocumento);
	        ps.setString(4, denominacion);
	            ps.setString(5, telefono);
	            ps.setString(6, correo);
	            ps.setInt(7, idDistrito);
	            ps.setString(8, nroSocio);
         ps.setInt(9, pUsuario.getUsuarioId());
         ps.setString(10, Constante.TERMINAL);
         ps.setInt(11, idCliente);
         //--
         res=ps.executeUpdate();
         
     } catch (SQLException e) {
         throw new RuntimeException(e);
     } catch (Exception e) {
         throw new RuntimeException(e);
     }finally {
     	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
         if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
     }
     
     return res;
	}
	
	public Cliente getCliente(Integer idCliente){
		Cliente obj = null; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryReservas.getInstance().getConnection();
        	
        	StringBuilder query = new StringBuilder();
            query.append("SELECT c.id_cliente,c.nro_documento,c.denominacion,c.telefono,c.correo,c.id_distrito,c.nro_socio,c.id_tipo_documento,c.id_tipo_cliente, ");
            query.append("tp.denominacion tipo_documento, ");
            query.append("tc.denominacion tipo_cliente ");
            query.append("FROM dbo.cliente c   ");
            query.append("inner join dbo.tipo_documento tp on (c.id_tipo_documento=tp.id_tipo_documento) "); 
            query.append("inner join dbo.tipo_cliente tc on (c.id_tipo_cliente=tc.id_tipo_cliente)  ");
            query.append("WHERE c.estado='1' and c.id_cliente=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idCliente);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	obj=new Cliente();
            	obj.setIdCliente(rs.getInt("id_cliente"));
            	obj.setNroDocumento(rs.getString("nro_documento"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	obj.setTelefono(rs.getString("telefono"));
            	obj.setCorreo(rs.getString("correo"));
            	obj.setIdDistrito(rs.getInt("id_distrito"));
            	obj.setNroSocio(rs.getString("nro_socio"));
            	obj.setIdTipoDocumento(rs.getInt("id_tipo_documento"));
            	obj.setIdTipoCliente(rs.getInt("id_tipo_cliente"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}
	
	
	public List<Value> listDistrito(){
		List<Value> lista = new ArrayList<Value>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactoryReservas.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT e.id_distrito,e.denominacion FROM dbo.distrito e ORDER BY e.denominacion ASC ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Value obj=new Value();
            	obj.setId(rs.getInt("id_distrito"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	
	public Integer registroCheck(Integer idCliente,Integer idReserva,Double ventaNeta,String nroCheck,Usuario pUser){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactoryReservas.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.reservas ");
            query.append("SET check_venta_neta = ? ");
            query.append(",check_nro_micros = ? ");
            query.append(",check_id_usuario_upd = ? ");
            query.append(",check_audit_fecha_hora = getdate() ");
            query.append("WHERE id_reserva=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setDouble(1, ventaNeta);
            ps.setString(2, nroCheck);
            ps.setInt(3, pUser.getUsuarioId());
            ps.setInt(4, idReserva);
            //--
            if(ps.executeUpdate()>0){
            	pk=idReserva;
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
		return pk;
	}
	
	
}


 



