package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.delfines.dao.ConnectionFactory;
import com.delfines.vo.GUser;
import com.delfines.vo.Usuario;

public class UsuarioBo {
	
	public int registroUsuario(Usuario usuario,Integer idUsuario){
		PreparedStatement ps=null;
        try {
            
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO usuario(apellidos_nombres,id_area,username,passwd ");
            query.append(",audit_usuarioid,audit_fechahora,audit_terminal,audit_estado) ");
            query.append("VALUES (?,?,?,?,?,getdate(),NULL,'1') ");
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, usuario.getApellidosNombres());
            ps.setInt(2, usuario.getAreaId().intValue());
            ps.setString(3, "");
            ps.setString(4, "");
            ps.setInt(5, idUsuario);
            
            int i = ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return 1;
	}
	
	public List<Usuario> listarUsuarios(Usuario pUser){
		List<Usuario> listaUsuarios = new ArrayList<Usuario>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
            
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT u.id_usuario,u.apellidos_nombres,a.denominacion,a.id_area,u.username,u.id_perfil FROM usuario u ");
            query.append("INNER JOIN area a ON (u.id_area=a.id_area) ");
            query.append("WHERE 1=1 ");
            query.append(sqlWherefromProfile(pUser.getPerfilId(), pUser.getAreaId(), pUser.getUsuarioId()));
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Usuario usuario=new Usuario();
            	usuario.setUsuarioId(rs.getInt("id_usuario"));
            	usuario.setApellidosNombres(rs.getString("apellidos_nombres"));
            	usuario.setAreaId(rs.getInt("id_area"));
            	usuario.setDenominacionArea(rs.getString("denominacion"));
            	usuario.setUsername(rs.getString("username"));
            	usuario.setPerfilId(rs.getInt("id_perfil"));
            	listaUsuarios.add(usuario);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return listaUsuarios;
	}
	
	
	public List<Usuario> buscarUsuariosByApeNom(String apellidosNombres,Usuario pUser){
		List<Usuario> listaUsuarios = new ArrayList<Usuario>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
            
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT u.id_usuario,u.apellidos_nombres,a.denominacion,a.id_area,u.id_perfil,u.username, ");
			query.append("isnull(t.ticket_desde,0) ticket_desde,isnull(t.ticket_hasta,0) ticket_hasta,isnull(t.cantidad,0) cantidad, ");
			query.append("isnull(t.meta_entrega,0) meta_entrega,isnull(t.meta_validacion,0) meta_validacion ");
			query.append("FROM usuario u  ");
			query.append("INNER JOIN area a ON (u.id_area=a.id_area) "); 
			query.append("LEFT JOIN ticket_meta t ON (t.id_usuario=u.id_usuario) ");
            query.append("WHERE u.apellidos_nombres LIKE '%"+apellidosNombres+"%' ");
            query.append(sqlWherefromProfile(pUser.getPerfilId(), pUser.getAreaId(), pUser.getUsuarioId()));
            
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Usuario usuario=new Usuario();
            	usuario.setUsuarioId(rs.getInt("id_usuario"));
            	usuario.setApellidosNombres(rs.getString("apellidos_nombres"));
            	usuario.setAreaId(rs.getInt("id_area"));
            	usuario.setDenominacionArea(rs.getString("denominacion"));
            	//--
            	usuario.setPerfilId(rs.getInt("id_perfil"));
            	usuario.setUsername(rs.getString("username"));
            	//--
            	usuario.setTicketDesde(rs.getInt("ticket_desde"));
            	usuario.setTicketHasta(rs.getInt("ticket_hasta"));
            	usuario.setCantidad(rs.getInt("cantidad"));
            	usuario.setMetaEntrega(rs.getInt("meta_entrega"));
            	usuario.setMetaValidacion(rs.getInt("meta_validacion"));
            	
            	listaUsuarios.add(usuario);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return listaUsuarios;
	}
	
	
	public List<Usuario> buscarUsuariosByArea(Integer idArea){
		List<Usuario> listaUsuarios = new ArrayList<Usuario>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
            
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT u.id_usuario,u.apellidos_nombres,a.denominacion,a.id_area,u.id_perfil,u.username, ");
			query.append("isnull(t.ticket_desde,0) ticket_desde,isnull(t.ticket_hasta,0) ticket_hasta,isnull(t.cantidad,0) cantidad, ");
			query.append("isnull(t.meta_entrega,0) meta_entrega,isnull(t.meta_validacion,0) meta_validacion ");
			query.append("FROM usuario u  ");
			query.append("INNER JOIN area a ON (u.id_area=a.id_area) "); 
			query.append("LEFT JOIN ticket_meta t ON (t.id_usuario=u.id_usuario) ");
            query.append("WHERE u.id_area=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idArea);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Usuario usuario=new Usuario();
            	usuario.setUsuarioId(rs.getInt("id_usuario"));
            	usuario.setApellidosNombres(rs.getString("apellidos_nombres"));
            	usuario.setAreaId(rs.getInt("id_area"));
            	usuario.setDenominacionArea(rs.getString("denominacion"));
            	usuario.setPerfilId(rs.getInt("id_perfil"));
            	usuario.setUsername(rs.getString("username"));
            	//--
            	usuario.setTicketDesde(rs.getInt("ticket_desde"));
            	usuario.setTicketHasta(rs.getInt("ticket_hasta"));
            	usuario.setCantidad(rs.getInt("cantidad"));
            	usuario.setMetaEntrega(rs.getInt("meta_entrega"));
            	usuario.setMetaValidacion(rs.getInt("meta_validacion"));
            	listaUsuarios.add(usuario);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return listaUsuarios;
	}
	
	public int registroTicketMeta(Integer ticketDesde,Integer ticketHasta,Integer cantidad,Integer metaEntregados,Integer metaValidados,Integer usuarioId){
		PreparedStatement ps=null;
        try {
            
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO ticket_meta(ticket_desde,ticket_hasta,cantidad,meta_entrega,meta_validacion,id_usuario ");
            query.append(",audit_usuarioid,audit_fechahora,audit_terminal,audit_estado) ");
            query.append("VALUES(?,?,?,?,?,? ");
            query.append(",?,GETDATE(),NULL,'1')");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, ticketDesde);
            ps.setInt(2, ticketHasta);
            ps.setInt(3, cantidad);
            ps.setInt(4, metaEntregados);
            ps.setInt(5, metaValidados);
            ps.setInt(6, usuarioId);
            ps.setInt(7, usuarioId);
            
            int i = ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return 1;
	}
	
	public int actualizaTicketMeta(Integer ticketDesde,Integer ticketHasta,Integer cantidad,Integer metaEntregados,Integer metaValidados,Integer usuarioId){
		PreparedStatement ps=null;

        try {
            
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            StringBuilder query = new StringBuilder();
            query.append("UPDATE ticket_meta SET ticket_desde=?,ticket_hasta=?,cantidad=?,meta_entrega=?,meta_validacion=? WHERE id_usuario=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, ticketDesde);
            ps.setInt(2, ticketHasta);
            ps.setInt(3, cantidad);
            ps.setInt(4, metaEntregados);
            ps.setInt(5, metaValidados);
            ps.setInt(6, usuarioId);
                        
            int i = ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}

        }
        
        return 1;
	}
	
	
	public int existeTicketMeta(Integer usuarioId){
		PreparedStatement ps=null;
		ResultSet rs=null;

		int result=0;
        try {
            
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            StringBuilder query = new StringBuilder();
            query.append("select COUNT(1) cantidad from ticket_meta where id_usuario=? ");
            
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, usuarioId);
            
            rs = ps.executeQuery();
            if(rs.next()){
            	result=rs.getInt("cantidad");	
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return result;
	}
	

	public Usuario loginUsuario(String username,String passwd){
		Usuario usuario = new Usuario(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
            
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT u.id_usuario,u.apellidos_nombres,a.denominacion,a.id_area,u.username,u.id_perfil,isnull(p.id_perfil,0) id_perfil_lead,isnull(p.id_modulo,0) id_modulo ");
            query.append(",isnull(au.id_perfil,0) id_perfil_eventos ");
            query.append("FROM usuario u ");
            query.append("INNER JOIN area a ON (u.id_area=a.id_area) ");
            query.append("LEFT JOIN leads.usuario_perfil p ON (u.id_usuario=p.id_usuario  )  ");
            query.append("LEFT JOIN eventos.asigna_usuario au ON (au.id_usuario=u.id_usuario) ");
            query.append("WHERE u.username=? and u.passwd=?  ");
                        
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, username);
            ps.setString(2, passwd);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	usuario.setUsuarioId(rs.getInt("id_usuario"));
            	usuario.setApellidosNombres(rs.getString("apellidos_nombres"));
            	usuario.setAreaId(rs.getInt("id_area"));
            	usuario.setDenominacionArea(rs.getString("denominacion"));
            	usuario.setUsername(rs.getString("username"));
            	usuario.setPerfilId(rs.getInt("id_perfil"));
            	//
            	usuario.setIdPerfilLead(rs.getInt("id_perfil_lead"));
            	usuario.setIdModulo(rs.getInt("id_modulo"));
            	//
            	usuario.setIdPerfilEventos(rs.getInt("id_perfil_eventos"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return usuario;
	}
	
	//--
	public int actulizaLoginPwd(String login,String password,Integer idPerfil,Integer idUsuario){
		PreparedStatement ps=null;
		try {
			
			Connection conn = ConnectionFactory.getInstance().getConnection();
			StringBuilder query = new StringBuilder();
			query.append("UPDATE usuario SET username = ?,passwd = ?,id_perfil = ? WHERE id_usuario=?");
			ps = conn.prepareStatement(query.toString());
			ps.setString(1, login);
			ps.setString(2, password);
			ps.setInt(3, idPerfil);
			ps.setInt(4, idUsuario);
			
			int i = ps.executeUpdate();
			
		} catch (SQLException e) {
			throw new RuntimeException(e);
		} finally {
			if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
		}
		
		return 1;
	}

	public String sqlWherefromProfile(Integer idPerfil,Integer idArea,Integer idUsuario){
		StringBuilder sqlWhere = new StringBuilder();
		
		if(idPerfil==1){
			sqlWhere.append(" AND u.id_area=").append(String.valueOf(idArea));
		}else if(idPerfil==2){
			sqlWhere.append(" AND u.id_area=").append(String.valueOf(idArea)).append(" AND u.id_usuario=").append(String.valueOf(idUsuario));
		}else if(idPerfil==9){
			sqlWhere.append(" AND 1=1 ");
		}
		
		return sqlWhere.toString();
	}
	
	
	public GUser getGUsuario(String gmail){
		GUser usuario = new GUser(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select guser_id,gemail from dbo.guser where lower(gemail)=lower(?) and estado=1 ");
                        
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, gmail);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	usuario.setgUserId(rs.getInt("guser_id"));
            	usuario.setgEmail(rs.getString("gemail"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return usuario;
	}
	
}
