package com.delfines.dao;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.time.ZonedDateTime;
import java.time.format.DateTimeFormatter;

import javax.naming.InitialContext;

import org.apache.tomcat.jdbc.pool.DataSource;
import org.apache.tomcat.jdbc.pool.PoolProperties;

public final class ConnectionFactoryOpera {
	/**desarrollo**/
	public static final String URL = "jdbc:oracle:thin:opera/opera@10.0.0.185:1521:opera";
	
	private static ConnectionFactoryOpera instance;
    private static DataSource dataSource = null;
    private Connection connection;

    private ConnectionFactoryOpera() {
        this.connect();
    }
	
	public static ConnectionFactoryOpera getInstance() {
        if (ConnectionFactoryOpera.instance == null) {
        	ConnectionFactoryOpera.instance = new ConnectionFactoryOpera();
        }
        return ConnectionFactoryOpera.instance;
    }
	
	private void connect() {
        Connection connection = null;
        if (this.dataSource == null) {
            try {
            	
                //InitialContext initialContext = new InitialContext();
                //dataSource = (DataSource)initialContext.lookup(
                //Constant.DEPLOYED ? Constant.PROD_JNDINAME : Constant.TEST_JNDINAME);
              System.out.println("create data source :: "+ZonedDateTime.now().format(DateTimeFormatter.RFC_1123_DATE_TIME));
              PoolProperties p = new PoolProperties();
  	          p.setUrl(URL);
  	          p.setDriverClassName("oracle.jdbc.driver.OracleDriver");
  	          p.setJmxEnabled(true);
  	          p.setTestWhileIdle(false);
  	          p.setTestOnBorrow(true);
  	          p.setValidationQuery("SELECT 1 FROM DUAL");
  	          p.setTestOnReturn(false);
  	          p.setValidationInterval(30000);
  	          p.setTimeBetweenEvictionRunsMillis(30000);
  	          p.setMaxActive(100);
  	          p.setInitialSize(20);
  	          p.setMaxWait(10000);
  	          p.setRemoveAbandonedTimeout(60);
  	          p.setMinEvictableIdleTimeMillis(30000);
  	          p.setMinIdle(10);
  	          p.setLogAbandoned(false);
  	          p.setRemoveAbandoned(true);
  	          p.setJdbcInterceptors(
  	            "org.apache.tomcat.jdbc.pool.interceptor.ConnectionState;"+
  	            "org.apache.tomcat.jdbc.pool.interceptor.StatementFinalizer");
  	          this.dataSource = new org.apache.tomcat.jdbc.pool.DataSource();
  	          this.dataSource.setPoolProperties(p);
  	          
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        try {
        	System.out.println("get connection :: "+ZonedDateTime.now().format(DateTimeFormatter.RFC_1123_DATE_TIME));
            connection = this.dataSource.getConnection();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        this.connection = connection;
    }
	
	public Connection getConnection() {
		try {
			if(this.connection==null||this.connection.isClosed()){
				System.out.println("get connection :: "+ZonedDateTime.now().format(DateTimeFormatter.RFC_1123_DATE_TIME));
				this.connection = this.dataSource.getConnection();
			}
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return this.connection;
    }
    /**
     * Test Connection
     */
    public static void main(String[] args) {
    	
    	String fecha=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactoryMicros.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select sysdate as hoy from dual ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	fecha=rs.getString("hoy");
            }
            System.out.println(fecha);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
    }
}
