package com.delfines.spring.controller;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.LinkedList;
import java.util.List;

import com.delfines.business.OperaForecastBo;
import com.delfines.business.Util;
import com.delfines.vo.ForecastHistory;
import com.delfines.vo.MicrosCheck;

public class ForeCastToText {
	
	private String folderName;
	
	public static void main(String[] args) {
    	try{
    		 List<ForecastHistory> lista=new LinkedList<>();
    		 OperaForecastBo bo=new OperaForecastBo();
    		 
    		 String _from=bo.getDateFrom();
    		 String _to=bo.getDateTo();
    		 
    		 lista=bo.listarForecast(_from, _to);
    		 ForeCastToText write=new ForeCastToText();
			 write.createFile(lista);
    		 
    		 System.out.println("generated !");
    	}catch(Exception e){
    		e.printStackTrace();
    	}
    }
	
	public ForeCastToText(){
		try{
			setFolderName(Util.pathFORECASTHISTORY);
		}catch(Exception e){
			e.printStackTrace();
			setFolderName(Util.pathFORECASTHISTORY);
	    }
	}
	
	public void createFile(List<ForecastHistory> lDetalle) {
		try{
			//TEMPLATE::INICIO
            StringBuilder qdetails = new StringBuilder();
			qdetails.append("REC_TYPE|CONSIDERED_DATE|NO_ROOMS|REVENUE").append("\n");
			//TEMPLATE::FIN
			
			List<String> lista=new LinkedList<>();
			for( ForecastHistory detalle:lDetalle){
				String item=qdetails.toString()
						.replaceAll("REC_TYPE", String.valueOf(detalle.getRecType()))
						.replaceAll("CONSIDERED_DATE", String.valueOf(detalle.getConsideredDate()))
						.replaceAll("NO_ROOMS", String.valueOf(detalle.getNoRooms()))
						.replaceAll("REVENUE", String.valueOf(detalle.getRevenue()));
				lista.add(item);
			}
            
			// Create new file
			String txtname="forecast_history_dialy";
            String path=getFolderName()+txtname+".txt";
            File file = new File(path);
            
            
            // If file doesn't exists, then create it
            if (!file.exists()) {
                file.createNewFile();
            }

            FileWriter fw = new FileWriter(file.getAbsoluteFile());
            BufferedWriter bw = new BufferedWriter(fw);
            
            for (String detalle : lista) {
            	bw.write(detalle);
            }
            // Close connection
            bw.close();
        }
        catch(Exception e){
            e.printStackTrace();
        }
    }
	
	public String getFolderName() {
		return folderName;
	}

	public void setFolderName(String folderName) {
		this.folderName = folderName;
	}
}

