package com.delfines.spring.controller;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.time.format.FormatStyle;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.Constante;
import com.delfines.business.AreaBo;
import com.delfines.business.GeneralBo;
import com.delfines.business.MicrosInvoiceBo;
import com.delfines.business.OperaHkBo;
import com.delfines.business.OperadorBo;
import com.delfines.business.ReferenciaBo;
import com.delfines.business.RegistroEventosBo;
import com.delfines.business.RegistroLeadsBo;
import com.delfines.business.RegistroReservasBo;
import com.delfines.business.UsuarioBo;
import com.delfines.vo.Area;
import com.delfines.vo.Cliente;
import com.delfines.vo.ConsultaReferencia;
import com.delfines.vo.Eventos;
import com.delfines.vo.GUser;
import com.delfines.vo.General;
import com.delfines.vo.HkArrival;
import com.delfines.vo.HkFloors;
import com.delfines.vo.HkValueStatus;
import com.delfines.vo.Operador;
import com.delfines.vo.Referencia;
import com.delfines.vo.Usuario;
import com.delfines.vo.Value;
import com.delfines.vo.reservas.Ejecutivo;

/**
 * @author imssbora
 */
@Controller
public class HelloWorldController {
   
   @RequestMapping(path={"/"},method=RequestMethod.GET)
   public String sayHello(Model model,HttpServletRequest request) {
	   try{
		   request.getSession().removeAttribute("p_guser");
	   }catch(Exception e){
		   e.printStackTrace();
	   }
       return "/hkstatus/glogin";//bien
   }
   
//   @RequestMapping(path={"/inicio"},method=RequestMethod.GET)
//   public String  inicio(Model model,HttpServletRequest request) {
//	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
//	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
//		   return "index";
//	   }else{
//		   return "login";
//	   }
//   }
   
   @RequestMapping(path={"/registro-referencia"},method=RequestMethod.GET)
   public String  registroReferencia(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   try{
			   OperadorBo operador=new OperadorBo();
			   List<Operador> lista = new ArrayList<Operador>();
			   lista=operador.listarOperador();
			   model.addAttribute("listaOperador", lista);
		   }catch(Exception e){
			   e.printStackTrace();
		   }		   
	       return "registro-referencia";
	   }else{
		   return "login";
	   }
   }
   
   @RequestMapping(path={"/registro-usuario"},method=RequestMethod.GET)
   public String registroUsuario(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   try{
			   UsuarioBo usuarioBo=new UsuarioBo();
			   List<Usuario> listaUsuarios = usuarioBo.listarUsuarios(pUsuario);
			   model.addAttribute("listaUsuarios", listaUsuarios);
			   
			   AreaBo areaBo=new AreaBo();
			   List<Area> listaAreas = areaBo.listarArea(pUsuario);
			   model.addAttribute("listaAreas", listaAreas);
		   }catch(Exception e){
			   e.printStackTrace();
		   }
	       return "registro-usuario";
	   }else{
		   return "login";
	   }
   }
   
   @RequestMapping(path={"/valida-referencia"},method=RequestMethod.GET)
   public String  validaReferencia(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   try{
			   UsuarioBo usuarioBo=new UsuarioBo();
			   List<Usuario> listaUsuarios = usuarioBo.listarUsuarios(pUsuario);
			   model.addAttribute("listaUsuarios", listaUsuarios);
		   }catch(Exception e){
			   e.printStackTrace();
		   }
		   
	       return "valida-referencia";
	   }else{
		   return "login";
	   }    
   }
   
   
   @RequestMapping(path={"/consulta-referencia"},method=RequestMethod.GET)
   public String consultaReferencia(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   try{
			   UsuarioBo usuarioBo=new UsuarioBo();
			   List<Usuario> listaUsuarios = usuarioBo.listarUsuarios(pUsuario);
			   model.addAttribute("listaUsuarios", listaUsuarios);
			   
			   AreaBo areaBo=new AreaBo();
			   List<Area> listaAreas = areaBo.listarArea(pUsuario);
			   model.addAttribute("listaAreas", listaAreas);
		   }catch(Exception e){
			   e.printStackTrace();
		   }
		   
		   return "consulta-referencia";
	   }else{
		   return "login";
	   }
   }
   
   
   @RequestMapping(path={"/registro-ticket"},method=RequestMethod.GET)
   public String  registroTicket(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   try{
			   AreaBo areaBo=new AreaBo();
			   List<Area> listaAreas = areaBo.listarArea(pUsuario);
			   model.addAttribute("listaAreas", listaAreas);
		   }catch(Exception e){
			   e.printStackTrace();
		   }
	       return "registro-ticket";
	   }else{
		   return "login";
	   }
   }
   
   
   @RequestMapping(path={"/registro-general"},method=RequestMethod.GET)
   public String registroGeneral(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   try{
			   GeneralBo areaBo=new GeneralBo();
			   
			   List<General> lista1 = areaBo.listarGeneral(1);
			   model.addAttribute("listaGeneral_1", lista1);
		      
			   List<General> lista2 = areaBo.listarGeneral(2);
			   model.addAttribute("listaGeneral_2", lista2);
		   }catch(Exception e){
			   e.printStackTrace();
		   }
	      
	       return "registro-general";
	   }else{
		   return "login";
	   }    
   }
   
   @RequestMapping(path={"/registro-mantenimiento"},method=RequestMethod.GET)
   public String  registroMantenimiento(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   try{
			   GeneralBo generalBo=new GeneralBo();
			   List<String> lista = generalBo.listarUrl();
			   model.addAttribute("listaUrl", lista);
		   }catch(Exception e){
			   e.printStackTrace();
		   }
		   
	       return "registro-mantenimiento";
	   }else{
		   return "login";
	   }
   }

   @RequestMapping(path={"/consulta-referencia-tabla"},method=RequestMethod.GET)
   public String consultaReferenciaTabla(Model model,HttpServletRequest request) {
	   return "consulta-referencia-tabla";
   }
   
   @RequestMapping(path={"/consulta-descargo"},method=RequestMethod.GET)
   public String consultaDescargos(Model model,HttpServletRequest request) {
	   return "consulta-descargo";
   }
   
   /**
    * opciones de menu x sistema
    */
   
   @RequestMapping(path={"/menu-referencias"},method=RequestMethod.GET)
   public String menuReferencias(Model model,HttpServletRequest request) {
	   return "menu-referencias";
   }
   @RequestMapping(path={"/menu-leads"},method=RequestMethod.GET)
   public String menuLeads(Model model,HttpServletRequest request) {
	   return "menu-leads";
   }
   
   @RequestMapping(path={"/menu-eventos"},method=RequestMethod.GET)
   public String menuEventos(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   try{
			   RegistroEventosBo bo=new RegistroEventosBo();
			   List<Eventos> listaEvento=new LinkedList<Eventos>();
			   List<Value> listaAreas = bo.listArea();
			   List<Value> listaPeriodo=bo.listaPeriodo();

			   RegistroLeadsBo rlead=new RegistroLeadsBo();
			   String fechaHoy=rlead.getDate();
			   
			   model.addAttribute("listaEvento",listaEvento);
			   model.addAttribute("listaAreas",listaAreas);
			   model.addAttribute("listaPeriodo", listaPeriodo);
			   model.addAttribute("fechaHoy", fechaHoy);
		   }catch(Exception e){
			   e.printStackTrace();
		   }
		   
		   return "/eventos/registro-eventos";
	   }else{
		   return "login";
	   }
   }
   
   @RequestMapping(path={"/menu-micros"},method=RequestMethod.GET)
   public String menuMicros(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   try{
			   MicrosInvoiceBo bo=new MicrosInvoiceBo();
			   String p_fechaIni=bo.getDateTime();
			   model.addAttribute("p_fechaIni", p_fechaIni);
			   model.addAttribute("p_fechaFin", p_fechaIni);
		   }catch(Exception e){
			   e.printStackTrace();
		   }
		   
		   return "/micros/micros-invoice";
	   }else{
		   return "login";
	   }
   }
   
   /**
    * HK room status
    */
   @RequestMapping(path={"/hks"},method=RequestMethod.GET)
   public String menuHK(Model model,HttpServletRequest request) {
	   GUser pUsuario=(GUser)request.getSession().getAttribute("p_guser");
	   if(pUsuario!=null){
		   try{
	    	   OperaHkBo bo=new OperaHkBo();
	    	   List<HkFloors> lista=new LinkedList<>();
	       	   lista = bo.listarHkFloors();
	       	   
	       	   List<HkFloors> listaEstadistica=bo.listarHkEstadistica();
	       	   List<HkArrival> listaArrival=bo.listarHkArrivals();
	       	
	       	   model.addAttribute("lista",lista);
	       	   model.addAttribute("listaEstadistica",listaEstadistica);
	       	   model.addAttribute("listaArrival",listaArrival);
		   }catch(Exception e){
			   e.printStackTrace();
		   }
		   return "/hkstatus/consulta-hks";   
	   }else{
		   return "/hkstatus/glogin";
	   }
   }
   
   @RequestMapping(path={"/hk"},method=RequestMethod.GET)
   public String menuHKS(Model model,HttpServletRequest request) {
	   GUser pUsuario=(GUser)request.getSession().getAttribute("p_guser");
	   if(pUsuario!=null){
	       try{
	    	   OperaHkBo bo=new OperaHkBo();
	    	   List<HkValueStatus> lista=new LinkedList<>();
	       	   lista = bo.listarHkRoomStatus();
	       		
	       	   List<HkValueStatus> listaDisc=new LinkedList<>();
	       	   listaDisc=bo.listarHkRoomDiscrepancy();
	       	   
	       	   List<HkValueStatus> listaArrTime=new LinkedList<>();
	       	   listaArrTime=bo.listarHkRoomArrivalTime();
	       	   
	       	   List<HkValueStatus> listaStatus=new LinkedList<>();
	    	   listaStatus=bo.listarHkServiceStatus(Constante.SERVICE_STATUS_DND);
	       	   
	    	   List<HkValueStatus> listaTracesHk=new LinkedList<>();
	    	   listaTracesHk=bo.listarHkTracesHK();
	    	   
	    	   List<HkFloors> listaEstadistica=bo.listarHkEstadistica();
	    	   
	    	   List<HkArrival> listaArrival=bo.listarHkArrivals();
	    	   List<HkValueStatus> lHeaderRatePack=bo.headerHkRatePack();
	    	   
	       	   model.addAttribute("lista",lista);
	       	   model.addAttribute("listaDisc",listaDisc);
	       	   model.addAttribute("listaArrT",listaArrTime);
	       	   model.addAttribute("listaStatus",listaStatus);
	       	   model.addAttribute("listaTracesHk",listaTracesHk);
	       	   model.addAttribute("listaEstadistica",listaEstadistica);
	       	   //
	       	   model.addAttribute("listaArrival",listaArrival);
	       	   model.addAttribute("listaRateCode",lHeaderRatePack);
		   }catch(Exception e){
			   e.printStackTrace();
		   }
		   return "/hkstatus/consulta-hk";
	   }else{
		   return "/hkstatus/glogin";
	   }
   }
   
   
   /**
    * Reservas
    * @param model
    * @param request
    * @return
    */
   
   @RequestMapping(path={"/menu-reservas"},method=RequestMethod.GET)
   public String menuReservas(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   try{
			   RegistroReservasBo bo=new RegistroReservasBo();
			   List<Ejecutivo> listaEjecutivo = bo.listEjecutivo();
			   List<Value> listaTipoReserva = bo.listTipoReserva();
			   List<Value> listaOutlet = bo.listOutlet();
			   List<Value> listaClientes = bo.listClientes();
			   
			   List<Value> listaDistrito = bo.listDistrito();
			   
			   String fechaHoy=bo.getDate();
			   String fechaHoyAdd3=bo.getDateAdd3();
			   
			   model.addAttribute("listaClientes",listaClientes);
			   model.addAttribute("listaDistrito",listaDistrito);
			   
			   model.addAttribute("listaEjecutivo",listaEjecutivo);
			   model.addAttribute("listaTipoReserva",listaTipoReserva);
			   model.addAttribute("listaOutlet",listaOutlet);
			   
			   model.addAttribute("p_fechaIni", fechaHoy);
			   model.addAttribute("p_fechaFin", fechaHoyAdd3);
			   
		   }catch(Exception e){
			   e.printStackTrace();
		   }
		   
		   return "/reservas/registro-reservas";
	   }else{
		   return "login";
	   }
   }
   
   
   @RequestMapping(path={"/glogin"},method=RequestMethod.GET)
   public String glogin(Model model,HttpServletRequest request) {
	   return "/hkstatus/glogin";
   }

   @RequestMapping(path={"/valida-gmail"},method=RequestMethod.GET)
   @ResponseBody	
   public GUser validaGmail(String gemail,Model model,HttpServletRequest request) {
	   
	    request.getSession().removeAttribute("p_guser");
	   
	    UsuarioBo servicio=new UsuarioBo();
		GUser usuario=new GUser();
	   	try{
	   		usuario=servicio.getGUsuario(gemail);
	   		if(usuario.getgUserId()!=null&&usuario.getgUserId()>0){
	   			request.getSession().setAttribute("p_guser",usuario);
	   		}
	   	}catch(Exception e){
	   		e.printStackTrace();
	   	}
	   	
	   	return usuario;
	}
   
}
