package com.delfines.spring.controller;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.time.ZonedDateTime;
import java.time.format.DateTimeFormatter;

import com.delfines.Constante;
import com.delfines.dao.ConnectionFactoryMySql;
import com.delfines.dao.ConnectionFactorySQL;

public class LoadLandingPage {

	
	public static void main(String[] args) {
	  /** CARGAR DESDE EL FORMULARIO DE CONTACTOS:INI */
	   try{
		   System.out.println("Initialize load :: "+ZonedDateTime.now().format(DateTimeFormatter.RFC_1123_DATE_TIME));
			   LoadLandingPage load=new LoadLandingPage(); 
			   Integer idFormulario=load.getCurrentIdFormulario();
			   
			   System.out.println("idFormulario:"+idFormulario);
			   Integer records=load.loadFormularioContacto(idFormulario);
			   
			   System.out.println("records:"+records);
			   Integer results=load.loadLeadsFromFormularioContacto();
			   
			   System.out.println("results:"+results);
		   System.out.println("Complete load :: "+ZonedDateTime.now().format(DateTimeFormatter.RFC_1123_DATE_TIME));
		   
	   }catch(Exception e){
		   e.printStackTrace();
	   }
	   /** CARGAR DESDE EL FORMULARIO DE CONTACTOS:FIN */
	}
	
	public Integer loadFormularioContacto(Integer idFormulario){
		Integer record=0;
		Statement stmt=null;
		ResultSet rs=null;
		Connection conn=null;
		try{  
			conn = ConnectionFactoryMySql.getInstance().getConnection();  
    		//here sonoo is database name, root is username and password  
    		stmt=conn.createStatement();  
    		rs=stmt.executeQuery("select id,nombre,telefono,email,servicio,asistentes,DATE_FORMAT(fechaservicio,'%d/%m/%Y') AS fechaservicio,mensaje,campaniacodigo,campanianombre,DATE_FORMAT(created,'%d/%m/%Y') as created,DATE_FORMAT(modified,'%d/%m/%Y') as modified,created_user,modified_user,parameters from formulario_contacto where id>"+String.valueOf(idFormulario));  
    		
    		while(rs.next()){
    			insertFormularioContacto(rs.getInt("id")
    			           ,rs.getString("nombre")
    			           ,rs.getString("telefono")
    			           ,rs.getString("email")
    			           ,rs.getString("servicio")
    			           ,rs.getString("asistentes")
    			           ,rs.getString("fechaservicio")
    			           ,rs.getString("mensaje")
    			           ,rs.getString("campaniacodigo")
    			           ,rs.getString("campanianombre")
    			           ,rs.getString("created")
    			           ,rs.getString("modified")
    			           ,rs.getInt("created_user")
    			           ,rs.getInt("modified_user")
    			           ,rs.getString("parameters"));
    			record++;
    		}
    	}catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (conn != null) {try {conn.close();} catch (SQLException e) {e.printStackTrace();}}
        	if (stmt != null) {try {stmt.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
		return record;
	}
	
	private void insertFormularioContacto(Integer id
	           ,String nombre
	           ,String telefono
	           ,String email
	           ,String servicio
	           ,String asistentes
	           ,String fechaservicio
	           ,String mensaje
	           ,String campaniacodigo
	           ,String campanianombre
	           ,String created
	           ,String modified
	           ,Integer created_user
	           ,Integer modified_user
	           ,String parameters){
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactorySQL.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO landing.formulario_contacto(id,nombre,telefono,email,servicio,asistentes,fechaservicio,mensaje,campaniacodigo,campanianombre,created,modified,created_user,modified_user,parameters) ");
            query.append("VALUES(?,?,?,?,?,?,CONVERT(DATETIME,?,103),?,?,?,CONVERT(DATETIME,?,103),CONVERT(DATETIME,?,103),?,?,?) ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, id);
            ps.setString(2, nombre);
            ps.setString(3, telefono);
            ps.setString(4, email);
            ps.setString(5, servicio);
            ps.setString(6, asistentes);
            	ps.setString(7, fechaservicio);//--DATE
            ps.setString(8, mensaje);
            ps.setInt(9, Integer.valueOf(campaniacodigo));
            ps.setString(10, campanianombre);
            	ps.setString(11, created);//--DATE
            	ps.setString(12, modified);//--DATE
            ps.setInt(13, created_user);
            ps.setInt(14, modified_user);
            ps.setString(15, parameters);
            
            //--
            ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
	}

	public Integer getCurrentIdFormulario(){
		Integer result=Constante.ID_INICIAL; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactorySQL.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT id_current from landing.current_formulario where id_current_formulario=1");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	result=rs.getInt("id_current");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return result;
	}
	
	
	public Integer loadLeadsFromFormularioContacto(){
		CallableStatement cs = null;
		Integer result=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactorySQL.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("{ CALL LEADS.INSERT_LEAD_FROM_FORMULARIO_CONTACTO(?) }");
            
            cs = conn.prepareCall(query.toString());
            cs.registerOutParameter(1, java.sql.Types.INTEGER);
            
            cs.execute();
            result=cs.getInt(1);
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (cs != null) {try {cs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return result;
	}
}
