package com.delfines.spring.controller;

import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.Constante;
import com.delfines.business.RegistroLeadsBo;
import com.delfines.vo.AdSetName;
import com.delfines.vo.Usuario;

/**
 * @author imssbora
 */
@Controller
public class ManteAdsController {
   
   @RequestMapping(path={"/leads/mante-ads"},method=RequestMethod.GET)
   public String manteAds(Model model,HttpServletRequest request) {
	    return "/leads/mante-ads";
   }
   @RequestMapping(path={"/leads/mante-ads-tabla"},method=RequestMethod.GET)
   public String manteAdsTabla(Model model,HttpServletRequest request) {
	    return "/leads/mante-ads-tabla";
   }
   
   @RequestMapping(path={"/lista-ads"},method=RequestMethod.GET)
   public ModelAndView lista(Model model,HttpServletRequest request) {
	    RegistroLeadsBo servicio=new RegistroLeadsBo();
	    List lista=new LinkedList<AdSetName>();
	    lista=servicio.listaAds();
	    
		ModelAndView mv = new ModelAndView("/leads/mante-ads-tabla");
		mv.addObject("lista",lista);
		return mv;
   }
   
   @RequestMapping(path={"/registro-ads"},method=RequestMethod.GET)
   public ModelAndView registro(Integer id,String denominacion,String descripcion,
		   Integer idArea,Integer idSubArea,Double precioPaqAdulto,Double precioPaqNinyo,Integer esIndividual,
		   Model model,HttpServletRequest request) {
	    Integer res=Constante.ID_INICIAL;
	    RegistroLeadsBo servicio=new RegistroLeadsBo();
	    Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	    
	    if(id>0){
	    	res=servicio.actualizaAds(id,denominacion,descripcion,
	    			idArea,idSubArea,precioPaqAdulto,precioPaqNinyo,esIndividual,pUsuario);
	    }else{
	    	res=servicio.registraAds(denominacion,descripcion,
	    			idArea,idSubArea,precioPaqAdulto,precioPaqNinyo,esIndividual,pUsuario);
	    }
	    
	    List lista=new LinkedList<AdSetName>();
	    if(res>0){
	    	lista=servicio.listaAds();	
	    }
		ModelAndView mv = new ModelAndView("/leads/mante-ads-tabla");
		mv.addObject("lista",lista);
		return mv;
   }
   
   
   @RequestMapping(path={"/eliminar-ads"},method=RequestMethod.GET)
   public ModelAndView eliminar(Integer id,Model model,HttpServletRequest request) {
	    Integer res=Constante.ID_INICIAL; 
	    RegistroLeadsBo servicio=new RegistroLeadsBo();
	    Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	    if(id>0){
	    	res=servicio.eliminarAds(id,pUsuario);
	    }
	    
	    List lista=new LinkedList<AdSetName>();
	    if(res>0){
	    	lista=servicio.listaAds();	
	    }
		ModelAndView mv = new ModelAndView("/leads/mante-ads-tabla");
		mv.addObject("lista",lista);
		return mv;
   }
	
}
