package com.delfines.spring.controller;

import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.Constante;
import com.delfines.business.RegistroLeadsBo;
import com.delfines.vo.PerfilLead;
import com.delfines.vo.Usuario;
import com.delfines.vo.Value;

/**
 * @author imssbora
 */
@Controller
public class MantePerfilController {
   
   @RequestMapping(path={"/leads/mante-perfil"},method=RequestMethod.GET)
   public String mantePerfil(Model model,HttpServletRequest request) {
	   
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   
		   RegistroLeadsBo bo=new RegistroLeadsBo();
		   List<Value> lista=bo.listUsuario();
		   
		   model.addAttribute("listaUsuario", lista);
		   
		   return "/leads/mante-perfil";
	   }else{
		   return "login";
	   }
	    
   }
   @RequestMapping(path={"/leads/mante-perfil-tabla"},method=RequestMethod.GET)
   public String mantePerfilTabla(Model model,HttpServletRequest request) {
	    return "/leads/mante-perfil-tabla";
   }
   
   @RequestMapping(path={"/lista-perfil"},method=RequestMethod.GET)
   public ModelAndView lista(Model model,HttpServletRequest request) {
	    RegistroLeadsBo servicio=new RegistroLeadsBo();
	    List lista=new LinkedList<PerfilLead>();
	    lista=servicio.listaPerfil();
	    
		ModelAndView mv = new ModelAndView("/leads/mante-perfil-tabla");
		mv.addObject("lista",lista);
		return mv;
   }
   
   @RequestMapping(path={"/registro-perfil"},method=RequestMethod.GET)
   public ModelAndView registro(Integer id,Integer idArea,Integer idSubArea,Integer idUsuario,Integer idPerfil,
		   Model model,HttpServletRequest request) {
	    Integer res=Constante.ID_INICIAL;
	    RegistroLeadsBo servicio=new RegistroLeadsBo();
	    Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	    
	    if(id>0){
	    	res=servicio.actualizaPerfil(id, idUsuario, idPerfil, idArea, idSubArea, pUsuario);
	    }else{
	    	res=servicio.registraPerfil(idUsuario, idPerfil, idArea, idSubArea, pUsuario);
	    }
	    
	    List lista=new LinkedList<PerfilLead>();
	    if(res>0){
	    	lista=servicio.listaPerfil();	
	    }
		ModelAndView mv = new ModelAndView("/leads/mante-perfil-tabla");
		mv.addObject("lista",lista);
		return mv;
   }
   
   
   @RequestMapping(path={"/eliminar-perfil"},method=RequestMethod.GET)
   public ModelAndView eliminar(Integer id,Model model,HttpServletRequest request) {
	    Integer res=Constante.ID_INICIAL; 
	    RegistroLeadsBo servicio=new RegistroLeadsBo();
	    Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	    if(id>0){
	    	res=servicio.eliminarPerfil(id,pUsuario);
	    }
	    
	    List lista=new LinkedList<PerfilLead>();
	    if(res>0){
	    	lista=servicio.listaPerfil();	
	    }
		ModelAndView mv = new ModelAndView("/leads/mante-perfil-tabla");
		mv.addObject("lista",lista);
		return mv;
   }
	
}
