package com.delfines.spring.controller;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.LinkedList;
import java.util.List;

import com.delfines.business.MicrosInvoiceBo;
import com.delfines.business.Util;
import com.delfines.vo.MicrosCheck;

public class MicrosCheckWrite {
	
	private String folderName;
	
	public static void main(String[] args) {
    	try{
    		 List<MicrosCheck> lista=new LinkedList<>();
    		 MicrosInvoiceBo bo=new MicrosInvoiceBo();
    		 
    		 String p_fechaIni=bo.getDateTime();
    		 String p_fechaFin=bo.getDateTime();
    		 
    		 System.out.println(p_fechaIni+" to "+p_fechaFin);
    		 lista=bo.listarMicrosCheck(p_fechaIni, p_fechaFin);
    		 MicrosCheckWrite write=new MicrosCheckWrite();
			 write.createFile(lista);
    		 
    		 System.out.println("generated !");
    	}catch(Exception e){
    		e.printStackTrace();
    	}
    }
	
	public MicrosCheckWrite(){
		try{
			setFolderName(Util.pathCHECKSAYB);
		}catch(Exception e){
			e.printStackTrace();
			setFolderName(Util.pathCHECKSAYB);
	    }
	}
	
	public void createFile(List<MicrosCheck> lDetalle) {
		try{
			//TEMPLATE::INICIO
            StringBuilder qdetails = new StringBuilder();
			qdetails.append("CHECKDETAILID|CHECKID|CHECKNUMBER|DETAILINDEX|SALESCOUNT|TOTAL|STRINGTEXT|NUMTABLE|REVENUECENTER|POSTINGTIME|COVERS|POSTINGHHMM|EMPLEADO|PAYMENT").append("\n");
			//TEMPLATE::FIN
			
			List<String> lista=new LinkedList<>();
			for( MicrosCheck detalle:lDetalle){
				String item=qdetails.toString()
						.replaceAll("CHECKDETAILID", String.valueOf(detalle.getCheckDetailId()))
						.replaceAll("CHECKID", String.valueOf(detalle.getCheckid()))
						.replaceAll("CHECKNUMBER", String.valueOf(detalle.getCheckNumber()))
						.replaceAll("DETAILINDEX", String.valueOf(detalle.getDetailIndex()))
						.replaceAll("SALESCOUNT", String.valueOf(detalle.getSalesCount()))
						.replaceAll("TOTAL", String.valueOf(detalle.getSalesTotal()))
						.replaceAll("STRINGTEXT", String.valueOf(detalle.getServiceText()))
						.replaceAll("NUMTABLE", String.valueOf(detalle.getNumTable()))
						.replaceAll("REVENUECENTER", String.valueOf(detalle.getOutlet()))
						.replaceAll("POSTINGTIME", String.valueOf(detalle.getPostingTime()))
						.replaceAll("COVERS", String.valueOf(detalle.getCovers()))
						//--
						.replaceAll("POSTINGHHMM", String.valueOf(detalle.getPostinghhmm()))
						.replaceAll("EMPLEADO", detalle.getEmpleado())
						.replaceAll("PAYMENT", String.valueOf(detalle.getPayment()));
				lista.add(item);
			}
            
			// Create new file
			String txtname="micros_checks_ayb";
            String path=getFolderName()+txtname+".dat";
            File file = new File(path);
            
            
            // If file doesn't exists, then create it
            if (!file.exists()) {
                file.createNewFile();
            }

            FileWriter fw = new FileWriter(file.getAbsoluteFile());
            BufferedWriter bw = new BufferedWriter(fw);
            
            for (String detalle : lista) {
            	bw.write(detalle);
            }
            // Close connection
            bw.close();
        }
        catch(Exception e){
            e.printStackTrace();
        }
    }
	
	public String getFolderName() {
		return folderName;
	}

	public void setFolderName(String folderName) {
		this.folderName = folderName;
	}
}

