package com.delfines.spring.controller;

import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.Constante;
import com.delfines.business.MicrosInvoiceBo;
import com.delfines.business.RegistroEventosBo;
import com.delfines.business.RegistroLeadsBo;
import com.delfines.sendmail.SendEmail;
import com.delfines.vo.AsignaUsuario;
import com.delfines.vo.EventoAlo;
import com.delfines.vo.EventoAyB;
import com.delfines.vo.EventoEve;
import com.delfines.vo.EventoMkt;
import com.delfines.vo.EventoOrg;
import com.delfines.vo.EventoSed;
import com.delfines.vo.Eventos;
import com.delfines.vo.MicrosCheck;
import com.delfines.vo.MicrosInvoice;
import com.delfines.vo.Usuario;
import com.delfines.vo.Value;

/**
 * @author imssbora
 */
@Controller
public class MicrosInvoiceController {
   
  
	@RequestMapping(path={"/lista-micros-invoice"},method=RequestMethod.GET)
    @ResponseBody
    public ModelAndView mostrarListaMicrosInvoice(Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   MicrosInvoiceBo bo=new MicrosInvoiceBo();
	   
	   String p_fechaIni=bo.getDateTime();
	   String p_fechaFin=bo.getDateTime();
	   
	   List<MicrosCheck> lista=new LinkedList<>();
	   if(p_fechaIni!=null&&p_fechaIni.trim().length()>0||
					   p_fechaFin!=null&&p_fechaFin.trim().length()>0){
	   		//lista = bo.listarMicrosCheck(p_fechaIni, p_fechaFin, pUser);
	   		
	   		model.addAttribute("p_fechaIni", p_fechaIni);
	   		model.addAttribute("p_fechaFin", p_fechaFin);
	   }
	   
	   ModelAndView mv = new ModelAndView("/micros/micros-invoice-tabla");
	   mv.addObject("lista",lista);
	   
	   return mv;
    }
	
	@RequestMapping(path={"/buscar-micros-invoice"},method=RequestMethod.GET)
	@ResponseBody
	public ModelAndView buscarMicrosInvoice(String fechaIni,String fechaFin, Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   MicrosInvoiceBo bo=new MicrosInvoiceBo();

	   List<MicrosCheck> lista=new LinkedList<>();
	   if(fechaIni!=null&&fechaIni.trim().length()>0||
					   fechaFin!=null&&fechaFin.trim().length()>0){
	   		
		    //lista = bo.listarMicrosCheck(fechaIni,fechaFin,pUser);
	   		
		    model.addAttribute("p_fechaIni", fechaIni);
		    model.addAttribute("p_fechaFin", fechaFin);
	   }
	   
	   ModelAndView mv = new ModelAndView("/micros/micros-invoice-tabla");
	   mv.addObject("lista",lista);
	   return mv;
	}
	
   
}


