package com.delfines.spring.controller;

import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.Constante;
import com.delfines.business.MicrosInvoiceBo;
import com.delfines.business.OperaHkBo;
import com.delfines.business.RegistroEventosBo;
import com.delfines.business.RegistroLeadsBo;
import com.delfines.sendmail.SendEmail;
import com.delfines.vo.AsignaUsuario;
import com.delfines.vo.EventoAlo;
import com.delfines.vo.EventoAyB;
import com.delfines.vo.EventoEve;
import com.delfines.vo.EventoMkt;
import com.delfines.vo.EventoOrg;
import com.delfines.vo.EventoSed;
import com.delfines.vo.Eventos;
import com.delfines.vo.HkRoomStatus;
import com.delfines.vo.MicrosCheck;
import com.delfines.vo.MicrosInvoice;
import com.delfines.vo.Usuario;
import com.delfines.vo.Value;

/**
 * @author imssbora
 */
@Controller
public class OperaHkController {
   
  
	@RequestMapping(path={"/consulta-hks"},method=RequestMethod.GET)
    @ResponseBody
    public ModelAndView consultaHk(Integer floor,Model model,HttpServletRequest request) {
	   OperaHkBo bo=new OperaHkBo();

	   List<HkRoomStatus> lista=new LinkedList<>();
	   if(floor!=null&&floor>0){
	   		lista = bo.listarHkRoomStatus(floor);
	   }
	   
	   ModelAndView mv = new ModelAndView("/hkstatus/consulta-hks-tabla");
	   
	   mv.addObject("lista",lista);
	   return mv;
    }
	
	
	@RequestMapping(path={"/consulta-hk"},method=RequestMethod.GET)
    @ResponseBody
    public ModelAndView consultaHks(Integer status,Model model,HttpServletRequest request) {
	   OperaHkBo bo=new OperaHkBo();

	   List<HkRoomStatus> lista=new LinkedList<>();
	   if(status!=null&&status>0){
		   if(status==99){
			   lista = bo.listarHkRoomStatusByDiscrepancy();
		   }else if(status==98){
			   lista = bo.listarHkRoomStatusByArrivalTime();   
		   }else if(status==97){
			   lista = bo.listarHkRoomServiceStatus(Constante.SERVICE_STATUS_DND);   
		   }else if(status==96){
			   lista = bo.listarHkTracesDetailsHK();   
		   }else if(status==95){
			   lista = bo.listarHkRatePack();   
		   }else{
			   lista = bo.listarHkRoomStatusByStatus(status);   
		   }
	   }
	   
	   ModelAndView mv = new ModelAndView("/hkstatus/consulta-hk-tabla");
	   mv.addObject("lista",lista);
	   return mv;
    }
	
}