package com.delfines.spring.controller;

import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.business.ReferenciaBo;
import com.delfines.vo.ConsultaReferencia;
import com.delfines.vo.EstadoReferencia;
import com.delfines.vo.Referencia;
import com.delfines.vo.Usuario;

/**
 * @author imssbora
 */
@Controller
public class ReferenciaController {
   
	ReferenciaBo referenciaBo=new ReferenciaBo(); 
	
   @RequestMapping(path={"/insert-referencia"},method=RequestMethod.GET)
   public ModelAndView registroReferencia(String apeCliente,String nomCliente,Integer idOperador,
		   String nroTarjeta,String emailCliente,String telefonoCliente,
		   String checkIn,String checkOut,String nickName,Model model,HttpServletRequest request) {
	   
	   Referencia referencia=new Referencia();
	   
	   referencia.setApeCliente(apeCliente);
	   referencia.setNomCliente(nomCliente);
	   referencia.setIdOperador(idOperador);
	   referencia.setNroTarjeta(nroTarjeta);
	   referencia.setEmailCliente(emailCliente);
	   referencia.setTelefonoCliente(telefonoCliente);
	   referencia.setCheckIn(checkIn);
	   referencia.setCheckOut(checkOut);
	   referencia.setNickName(nickName);
      
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   Integer idUsuario=pUsuario.getUsuarioId();
	   	   
	   Integer existe=referenciaBo.existeNroTarjeta(nroTarjeta);
	   if(existe==0){
	   		Integer idReferencia=referenciaBo.registroReferencia(referencia,idUsuario);
	   		referenciaBo.actualizaNroRegistro(idReferencia, idUsuario);
	   		List<Referencia> lista=referenciaBo.buscarReferenciaByTarjeta(nroTarjeta, idUsuario);
		   
	   		ModelAndView mv = new ModelAndView("registro-referencia-tabla");
	   		mv.addObject("listaReferencia",lista);
	   		return mv;
	   }else{
		   ModelAndView mv = new ModelAndView("registro-referencia-tabla");
		   List lista=new LinkedList<>();
	   	   mv.addObject("listaReferencia",lista);
	   	   return mv;
	   }
   }
   
   @RequestMapping(path={"/buscar-referencia"},method=RequestMethod.GET)
   public ModelAndView buscarReferencia(String apeCliente,String nomCliente,Integer idUsuario,
		   String nroRegistro,String fechaRegistro,String nickName,HttpServletRequest request) {
	   
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   List<Referencia> lista=getReferenciaByFilter(apeCliente,nomCliente,idUsuario,nroRegistro,fechaRegistro,nickName,pUsuario);
	   
	   ModelAndView mav = new ModelAndView();
	   mav.setViewName("valida-referencia-tabla");
       mav.addObject("listaReferencia", lista);
       
       //--
       request.getSession().setAttribute("papeCliente",apeCliente);
	   request.getSession().setAttribute("pnomCliente",nomCliente);
	   request.getSession().setAttribute("pidUsuario",idUsuario);
	   request.getSession().setAttribute("pnroRegistro",nroRegistro);
	   request.getSession().setAttribute("pfechaRegistro",fechaRegistro);
	   request.getSession().setAttribute("pnickName",nickName);
       //--
	   return mav;
   }
   //buscar-referencia
   public List<Referencia> getReferenciaByFilter(String apeCliente,String nomCliente,Integer idUsuario,
		   String nroRegistro,String fechaRegistro,String nickName,Usuario pUser){
	   List<Referencia> lista=new LinkedList<>();
	   if(apeCliente.trim().length()>0 || nomCliente.trim().length()>0 ){
		   lista=referenciaBo.buscarReferenciaByCliente(apeCliente,nomCliente,pUser);
	   }else if(idUsuario!=null&&idUsuario>0){
		   lista=referenciaBo.buscarReferenciaByUsuario(idUsuario,pUser);
	   }else if(nroRegistro.trim().length()>0){
		   lista=referenciaBo.buscarReferenciaByNroRegistro(nroRegistro,pUser);
	   }else if(fechaRegistro.trim().length()>0){
		   lista=referenciaBo.buscarReferenciaByFecRegistro(fechaRegistro,pUser);
	   }else if(nickName!=null&&nickName.trim().length()>0){
		   lista=referenciaBo.buscarReferenciaByNickName(nickName,pUser);
	   }
	   return lista;
   }
   
   @RequestMapping(path={"/registro-validacion"},method=RequestMethod.GET)
   public ModelAndView registroValidacion(String entregado,String validado,String nickName,
		   String fechaComentario,String titulo,String puntos,String comentario,Integer idReferencia,Integer idOperador,HttpServletRequest request) {
	   
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   EstadoReferencia referencia=new EstadoReferencia();
	   //--
	   referencia.setEntregado(entregado);
	   referencia.setValidado(validado);
	   //--
	   referencia.setNickName(nickName);
	   referencia.setFechaComentario(fechaComentario);
	   referencia.setTituloComentario(titulo);
	   referencia.setPuntoValoracion(puntos);
	   referencia.setDetalleComentario(comentario);
	   //--
	   referencia.setIdReferencia(idReferencia);//tripadvisor
	   referencia.setIdOperador(idOperador);//
	   //--
	   if(referenciaBo.existeReferenciaValidado(idReferencia)==0){
		   referenciaBo.registroValidacion(referencia,pUsuario.getUsuarioId());   
	   }
	   
	   //--
	   String apeCliente=(String)request.getSession().getAttribute("papeCliente");
	   String nomCliente=(String)request.getSession().getAttribute("pnomCliente");
	   Integer idUsuario=(Integer)request.getSession().getAttribute("pidUsuario");
	   String nroRegistro=(String)request.getSession().getAttribute("pnroRegistro");
	   String fechaRegistro=(String)request.getSession().getAttribute("pfechaRegistro");
	   String p_nickName=(String)request.getSession().getAttribute("pnickName");
	   //--
	   List<Referencia> lista=getReferenciaByFilter(apeCliente,nomCliente,idUsuario,nroRegistro,fechaRegistro,p_nickName,pUsuario);
	   
	   ModelAndView mav = new ModelAndView();
	   mav.setViewName("valida-referencia-tabla");
       mav.addObject("listaReferencia", lista);
       
	   return mav;
   }
   
   @RequestMapping(path={"/buscar-consulta-referencia"},method=RequestMethod.GET)
   public ModelAndView consultaReferencia(Integer nroRegistroIni,Integer nroRegistroFin,
		   String fechaRegistroIni,String fechaRegistroFin,
		   Integer idUsuario,Integer idArea,String nickName,Model model,HttpServletRequest request) {
	   
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   List<ConsultaReferencia> lista=new LinkedList<ConsultaReferencia>();
	   
	   if((nroRegistroIni!=null&&nroRegistroIni>0) && (nroRegistroFin!=null&&nroRegistroFin>0) ){
		   lista=referenciaBo.buscarEstadoReferenciaByNroReferencia(nroRegistroIni, nroRegistroFin,pUsuario);
	   }else if(fechaRegistroIni.trim().length()>0 && fechaRegistroFin.trim().length()>0 ){
		   lista=referenciaBo.buscarEstadoReferenciaByFechaRegistro(fechaRegistroIni, fechaRegistroFin,pUsuario);
	   }else if(idUsuario>0){
		   lista=referenciaBo.buscarEstadoReferenciaByUsuario(idUsuario,pUsuario);
	   }else if(idArea>0){
		   lista=referenciaBo.buscarEstadoReferenciaByArea(idArea,pUsuario);
	   }else if(nickName!=null&&nickName.trim().length()>0){
		   lista=referenciaBo.buscarEstadoReferenciaByNickName(nickName,pUsuario);
	   }
	   
	   //--
       request.getSession().setAttribute("p_nroRegistroIni",nroRegistroIni);
	   request.getSession().setAttribute("p_nroRegistroFin",nroRegistroFin);
	   request.getSession().setAttribute("p_fechaRegistroIni",fechaRegistroIni);
	   request.getSession().setAttribute("p_fechaRegistroFin",fechaRegistroFin);
	   request.getSession().setAttribute("p_idUsuario",idUsuario);
	   request.getSession().setAttribute("p_idArea",idArea);
	   request.getSession().setAttribute("p_nickName",nickName);
       //--
	   
	   ModelAndView mv = new ModelAndView("consulta-referencia-tabla");
       mv.addObject("listaConsultaReferencia",lista);
       return mv;
   }
   
   //buscar-consulta-referencia
   public List<ConsultaReferencia> getConsultaReferenciaByFilter(Integer nroRegistroIni,Integer nroRegistroFin,String fechaRegistroIni,String fechaRegistroFin,
		   Integer idUsuario,Integer  idArea,String nickName,Usuario pUsuario){
	   List<ConsultaReferencia> lista=new LinkedList<ConsultaReferencia>();
	   
	   if((nroRegistroIni!=null&&nroRegistroIni>0) && (nroRegistroFin!=null&&nroRegistroFin>0) ){
		   lista=referenciaBo.buscarEstadoReferenciaByNroReferencia(nroRegistroIni, nroRegistroFin,pUsuario);
	   }else if(fechaRegistroIni.trim().length()>0 && fechaRegistroFin.trim().length()>0 ){
		   lista=referenciaBo.buscarEstadoReferenciaByFechaRegistro(fechaRegistroIni, fechaRegistroFin,pUsuario);
	   }else if(idUsuario>0){
		   lista=referenciaBo.buscarEstadoReferenciaByUsuario(idUsuario,pUsuario);
	   }else if(idArea>0){
		   lista=referenciaBo.buscarEstadoReferenciaByArea(idArea,pUsuario);
	   }else if(nickName!=null&&nickName.trim().length()>0){
		   lista=referenciaBo.buscarEstadoReferenciaByNickName(nickName,pUsuario);
	   }
	   
	   return lista;
   }
   
   @RequestMapping(path={"/retira-validacion"},method=RequestMethod.GET)
   public ModelAndView retirarValidacion(Integer idReferencia,Integer idEstadoReferencia,String motivo,Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");

	   List<ConsultaReferencia> lista=new LinkedList<ConsultaReferencia>();
	   
	   Integer res=referenciaBo.retirarValidacion(idReferencia,idEstadoReferencia,motivo,pUsuario.getUsuarioId());
	   if(res>0){
		   Integer nroRegistroIni=(Integer)request.getSession().getAttribute("p_nroRegistroIni");
		   Integer nroRegistroFin=(Integer)request.getSession().getAttribute("p_nroRegistroFin");
		   String fechaRegistroIni=(String)request.getSession().getAttribute("p_fechaRegistroIni");
		   String fechaRegistroFin=(String)request.getSession().getAttribute("p_fechaRegistroFin");
		   Integer idUsuario=(Integer)request.getSession().getAttribute("p_idUsuario");
		   Integer idArea=(Integer)request.getSession().getAttribute("p_idArea");
		   String nickName=(String)request.getSession().getAttribute("p_nickName");
		   
		   lista=getConsultaReferenciaByFilter(nroRegistroIni, nroRegistroFin, fechaRegistroIni, fechaRegistroFin, idUsuario, idArea, nickName, pUsuario);
	   }
	   ModelAndView mv = new ModelAndView("consulta-referencia-tabla");
       mv.addObject("listaConsultaReferencia",lista);
       return mv;
   }
   
   @RequestMapping(path={"/buscar-consulta-descargo"},method=RequestMethod.GET)
   public ModelAndView consultaDescargo(Integer nroRegistroIni,Integer nroRegistroFin,Model model,HttpServletRequest request) {
	   
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   List<ConsultaReferencia> lista=new LinkedList<ConsultaReferencia>();
	   
	   if((nroRegistroIni!=null&&nroRegistroIni>0) && (nroRegistroFin!=null&&nroRegistroFin>0) ){
		   lista=referenciaBo.buscarEstadoDescargosByNroReferencia(nroRegistroIni, nroRegistroFin,pUsuario);
	   }
	   
	   ModelAndView mv = new ModelAndView("consulta-descargo-tabla");
       mv.addObject("listaConsultaReferencia",lista);
       return mv;
   }   
   
   
}
