package com.delfines.spring.controller;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.Constante;
import com.delfines.business.RegistroLeadsBo;
import com.delfines.vo.Correo;
import com.delfines.vo.Lead;
import com.delfines.vo.LeadSeguimiento;
import com.delfines.vo.PerfilLead;
import com.delfines.vo.Usuario;
import com.delfines.vo.Value;
import com.delfines.vo.leads.ReporteCorreos;
import com.delfines.vo.leads.ReporteGeneral;

/**
 * @author imssbora
 */
@Controller
public class RegistroCorreosController {
   
   @RequestMapping(path={"/lista-correos"},method=RequestMethod.GET)
   public String mostrarListaLeads(Model model,HttpServletRequest request) {
	   
	    return "/correos/registro-correos-tabla";
   }
   
   @RequestMapping(path={"/buscar-correos"},method=RequestMethod.GET)
   public ModelAndView buscarListaLeads(String fechaAdsIni,String fechaAdsFin,Integer idEstado,Integer pIdEjecutivo,
		   String fechaProximaIni,String fechaProximaFin,Integer idSeguimiento,
		   Integer idArea,Integer idAdsetName,Integer idReserva,Integer idMotivo,Integer cantSeg,Integer idCotizado,
		   Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   List<Value> listaEjecutivo=(List<Value>)request.getSession().getAttribute("listaEjecutivo");
	   List<Correo> listaLeads = getListLeads(fechaAdsIni,fechaAdsFin,idEstado,pIdEjecutivo,listaEjecutivo,fechaProximaIni,fechaProximaFin,idSeguimiento,
			   idArea,idAdsetName,idReserva,idMotivo,cantSeg,idCotizado,
			   pUser);
	   
	   request.getSession().setAttribute("fechaAdsIni", fechaAdsIni);
	   request.getSession().setAttribute("fechaAdsFin", fechaAdsFin);
	   request.getSession().setAttribute("idEstado", idEstado);
	   
	   request.getSession().setAttribute("pIdEjecutivo", pIdEjecutivo);
	   
	   request.getSession().setAttribute("fechaProximaIni", fechaProximaIni);
	   request.getSession().setAttribute("fechaProximaFin", fechaProximaFin);
	   request.getSession().setAttribute("idSeguimiento", idSeguimiento);
	   //--
	   request.getSession().setAttribute("pIdArea", idArea);
	   request.getSession().setAttribute("pIdAdsetName", idAdsetName);
	   request.getSession().setAttribute("pIdReserva", idReserva);
	   request.getSession().setAttribute("pIdMotivo", idMotivo);
	   request.getSession().setAttribute("pCantSeg", cantSeg);
	   
	   request.getSession().setAttribute("pIdCotizado", idCotizado);
	   
	   ModelAndView mv = new ModelAndView("/correos/registro-correos-tabla");
	   mv.addObject("listaLeads",listaLeads);
	   return mv;
   }
   
   @RequestMapping(path={"/buscar-correos-seguimiento"},method=RequestMethod.GET)
   @ResponseBody
   public ModelAndView buscarListaLeadsSeguimiento(Integer idEmail,Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   List<LeadSeguimiento> listaLeadSeguimiento=bo.listCorreoSeguimientoByIdEmail(idEmail);

	   ModelAndView mv = new ModelAndView("/correos/registro-correos-tabla-seguimiento");
	   mv.addObject("listaLeadsSeguimiento",listaLeadSeguimiento);
	   return mv;
   }
   
   @RequestMapping(path={"/guardar-seguimiento-correo"},method=RequestMethod.GET)
   public ModelAndView guardarSeguimiento(Integer idEjecutivo,Integer idEmail,Integer idCotizado,Integer idCanal,
			Integer idReserva,Integer idMotivo,Integer paxFinal,Double revenue,Integer idServicioFinal,String observacion,String fechaProxima,
			
			Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   Integer idLeadSeguimiento=bo.guardarSeguimientoCorreo(idEjecutivo,idEmail,idCotizado,idCanal,
				idReserva,idMotivo,paxFinal,revenue,idServicioFinal,observacion,fechaProxima,pUser);
	   
	   if(idLeadSeguimiento>0){
		   bo.actualiaEstadoSeguimientoCorreo(idLeadSeguimiento);
	   }
	   
	   //--Recuperalo desde la session
	   String fechaAdsIni=(String)request.getSession().getAttribute("fechaAdsIni");
	   String fechaAdsFin=(String)request.getSession().getAttribute("fechaAdsFin");
	   Integer idEstado=(Integer)request.getSession().getAttribute("idEstado");
	   
	   Integer pIdEjecutivo=(Integer)request.getSession().getAttribute("pIdEjecutivo");
	   	   
	   List<Value> listaEjecutivo=(List<Value>)request.getSession().getAttribute("listaEjecutivo");
	   
	   String fechaProximaIni=(String)request.getSession().getAttribute("fechaProximaIni");
	   String fechaProximaFin=(String)request.getSession().getAttribute("fechaProximaFin");
	   Integer idSeguimiento=(Integer)request.getSession().getAttribute("idSeguimiento");
	   //
	   Integer pIdArea=(Integer)request.getSession().getAttribute("pIdArea");
	   Integer pIdAdsetName=(Integer)request.getSession().getAttribute("pIdAdsetName");
	   Integer pIdReserva=(Integer)request.getSession().getAttribute("pIdReserva");
	   Integer pIdMotivo=(Integer)request.getSession().getAttribute("pIdMotivo");
	   Integer pCantSeg=(Integer)request.getSession().getAttribute("pCantSeg");
	   
	   Integer pidCotizado=(Integer)request.getSession().getAttribute("pIdCotizado");
	   
	   List<Correo> listaLeadsUpdate = getListLeads(fechaAdsIni,fechaAdsFin,idEstado,pIdEjecutivo,listaEjecutivo,fechaProximaIni,fechaProximaFin,idSeguimiento,
			   pIdArea,pIdAdsetName,pIdReserva,pIdMotivo,pCantSeg,pidCotizado,
			   pUser);
	   
	   ModelAndView mv = new ModelAndView("/correos/registro-correos-tabla");
	   mv.addObject("listaLeads",listaLeadsUpdate);
	   return mv;
   }
   
   public  List<Correo> getListLeads(String fechaAdsIni,String fechaAdsFin,Integer idEstado,Integer pIdEjecutivo,List<Value> listaEjecutivo,
		   String fechaProximaIni,String fechaProximaFin,Integer idSeguimiento,
		   Integer idArea,Integer idAdsetName,Integer idReserva,Integer idMotivo,Integer cantSeg,Integer idCotizado,
		   Usuario pUser){
	   List<Correo> listaLeads = new ArrayList<Correo>();
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   
	   String ids=getIdEjecutivos(listaEjecutivo);
	   listaLeads=bo.listCorreos(fechaAdsIni,fechaAdsFin,idEstado,pIdEjecutivo,ids,fechaProximaIni,fechaProximaFin,idSeguimiento,
			   idArea,idAdsetName,idReserva,idMotivo,cantSeg,idCotizado,
			   pUser);
	   
	   return listaLeads;
   }
   
   public String getIdEjecutivos(List<Value> listaEjecutivo){
		StringBuilder ids = new StringBuilder();
		
		for (Iterator<Value> it = listaEjecutivo.iterator(); it.hasNext(); ) {
		    if (it.hasNext()) {
		    	ids.append(it.next().getId());
		    	ids.append(",");
		    }
		}
		ids.append("0");
		
		return ids.toString();
	}
   
   /**
    * Registro leads
    * @param model
    * @param request
    * @return
    */
   @RequestMapping(path={"/correos/registro-correos"},method=RequestMethod.GET)
   public String  registrLeads(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   
		   RegistroLeadsBo bo=new RegistroLeadsBo();
		   List<Value> listaEjecutivo=bo.listEjecutivoCorreo(pUsuario.getIdPerfilLead(),pUsuario.getAreaId(),pUsuario.getUsuarioId());//SEGUIMIENTO-CORREO
		   List<Value> listaAdSetName=bo.listAdSetName();
		   List<Value> listaArea=bo.listArea();
		   
		   String fechaHoy=bo.getDate();
		   
		   model.addAttribute("listaAdSetName", listaAdSetName);
		   model.addAttribute("listaEjecutivo", listaEjecutivo);
		   model.addAttribute("fechaHoy", fechaHoy);
		   model.addAttribute("listaArea", listaArea);
		   
		   request.getSession().setAttribute("listaEjecutivo",listaEjecutivo);
		   
		   return "/correos/registro-correos";
	   }else{
		   return "login";
	   }
   }
   
   @RequestMapping(path={"/correos/registro-correos-tabla"},method=RequestMethod.GET)
   public String  registrLeadsTabla(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   return "/correos/registro-correos-tabla";
	   }else{
		   return "login";
	   }
   }
   
   @RequestMapping(path={"/asignar-ejecutivo-single-correo"},method=RequestMethod.GET)
   public ModelAndView asignarEjecutivoLeadsSingle(Integer idEjecutivo,Integer idEmail,Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   bo.reAsignarEjecutivoEmail(idEjecutivo,pUser.getIdPerfilLead(), idEmail);
	   
	   //--Recuperalo desde la session
	   String fechaAdsIni=(String)request.getSession().getAttribute("fechaAdsIni");
	   String fechaAdsFin=(String)request.getSession().getAttribute("fechaAdsFin");
	   Integer idEstado=(Integer)request.getSession().getAttribute("idEstado");
	   Integer pIdEjecutivo=(Integer)request.getSession().getAttribute("pIdEjecutivo");
	   
	   List<Value> listaEjecutivo=(List<Value>)request.getSession().getAttribute("listaEjecutivo");
	   
	   String fechaProximaIni=(String)request.getSession().getAttribute("fechaProximaIni");
	   String fechaProximaFin=(String)request.getSession().getAttribute("fechaProximaFin");
	   Integer idSeguimiento=(Integer)request.getSession().getAttribute("idSeguimiento");
	   //
	   Integer pIdArea=(Integer)request.getSession().getAttribute("pIdArea");
	   Integer pIdAdsetName=(Integer)request.getSession().getAttribute("pIdAdsetName");
	   Integer pIdReserva=(Integer)request.getSession().getAttribute("pIdReserva");
	   Integer pIdMotivo=(Integer)request.getSession().getAttribute("pIdMotivo");
	   Integer pCantSeg=(Integer)request.getSession().getAttribute("pCantSeg");
	   
	   Integer pidCotizado=(Integer)request.getSession().getAttribute("pIdCotizado");
	   
	   List<Correo> listaLeadsUpdate = getListLeads(fechaAdsIni,fechaAdsFin,idEstado,pIdEjecutivo,listaEjecutivo,fechaProximaIni,fechaProximaFin,idSeguimiento,
			   pIdArea,pIdAdsetName,pIdReserva,pIdMotivo,pCantSeg,pidCotizado,
			   pUser);
	   
	   ModelAndView mv = new ModelAndView("/correos/registro-correos-tabla");
	   mv.addObject("listaLeads",listaLeadsUpdate);
	   return mv;
   }
   
   
   @RequestMapping(path={"/eliminar-mail-masivo"},method=RequestMethod.GET)
   public ModelAndView eliminarMailMasivo(String mailIdLeads,Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   if(mailIdLeads.trim().length()>0){
		   bo.eliminarMailMasivo(mailIdLeads,pUser);   
	   }
	   
	   //--Recuperalo desde la session
	   String fechaAdsIni=(String)request.getSession().getAttribute("fechaAdsIni");
	   String fechaAdsFin=(String)request.getSession().getAttribute("fechaAdsFin");
	   Integer idEstado=(Integer)request.getSession().getAttribute("idEstado");
	   Integer pIdEjecutivo=(Integer)request.getSession().getAttribute("pIdEjecutivo");
	   List<Value> listaEjecutivo=(List<Value>)request.getSession().getAttribute("listaEjecutivo");
	   
	   String fechaProximaIni=(String)request.getSession().getAttribute("fechaProximaIni");
	   String fechaProximaFin=(String)request.getSession().getAttribute("fechaProximaFin");
	   Integer idSeguimiento=(Integer)request.getSession().getAttribute("idSeguimiento");
	   //
	   Integer pIdArea=(Integer)request.getSession().getAttribute("pIdArea");
	   Integer pIdAdsetName=(Integer)request.getSession().getAttribute("pIdAdsetName");
	   Integer pIdReserva=(Integer)request.getSession().getAttribute("pIdReserva");
	   Integer pIdMotivo=(Integer)request.getSession().getAttribute("pIdMotivo");
	   Integer pCantSeg=(Integer)request.getSession().getAttribute("pCantSeg");
	   
	   Integer pidCotizado=(Integer)request.getSession().getAttribute("pIdCotizado");
	   
	   List<Correo> listaLeadsUpdate = getListLeads(fechaAdsIni,fechaAdsFin,idEstado,pIdEjecutivo,listaEjecutivo,fechaProximaIni,fechaProximaFin,idSeguimiento,
			   pIdArea,pIdAdsetName,pIdReserva,pIdMotivo,pCantSeg,pidCotizado,
			   pUser);
	   
	   ModelAndView mv = new ModelAndView("/correos/registro-correos-tabla");
	   mv.addObject("listaLeads",listaLeadsUpdate);
	   return mv;
   }
   
   @RequestMapping(path={"/eliminar-correo"},method=RequestMethod.GET)
   public ModelAndView eliminar(Integer id,Model model,HttpServletRequest request) {
	   Integer res=Constante.ID_INICIAL; 
	   RegistroLeadsBo servicio=new RegistroLeadsBo();
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(id>0){
		   res=servicio.eliminarCorreo(id,pUsuario);
	   }
	    
	   //--Recuperalo desde la session
	   String fechaAdsIni=(String)request.getSession().getAttribute("fechaAdsIni");
	   String fechaAdsFin=(String)request.getSession().getAttribute("fechaAdsFin");
	   Integer idEstado=(Integer)request.getSession().getAttribute("idEstado");
	   Integer pIdEjecutivo=(Integer)request.getSession().getAttribute("pIdEjecutivo");
	   List<Value> listaEjecutivo=(List<Value>)request.getSession().getAttribute("listaEjecutivo");
	   
	   String fechaProximaIni=(String)request.getSession().getAttribute("fechaProximaIni");
	   String fechaProximaFin=(String)request.getSession().getAttribute("fechaProximaFin");
	   Integer idSeguimiento=(Integer)request.getSession().getAttribute("idSeguimiento");
	   //
	   Integer pIdArea=(Integer)request.getSession().getAttribute("pIdArea");
	   Integer pIdAdsetName=(Integer)request.getSession().getAttribute("pIdAdsetName");
	   Integer pIdReserva=(Integer)request.getSession().getAttribute("pIdReserva");
	   Integer pIdMotivo=(Integer)request.getSession().getAttribute("pIdMotivo");
	   Integer pCantSeg=(Integer)request.getSession().getAttribute("pCantSeg");
	   
	   Integer pidCotizado=(Integer)request.getSession().getAttribute("pIdCotizado");
	   
	   List<Correo> listaLeadsUpdate = getListLeads(fechaAdsIni,fechaAdsFin,idEstado,pIdEjecutivo,listaEjecutivo,fechaProximaIni,fechaProximaFin,idSeguimiento,
			   pIdArea,pIdAdsetName,pIdReserva,pIdMotivo,pCantSeg,pidCotizado,
			   pUsuario);
	   
	   ModelAndView mv = new ModelAndView("/correos/registro-correos-tabla");
	   mv.addObject("listaLeads",listaLeadsUpdate);
	   return mv;
   }
   
   @RequestMapping(value="/get-lead-seguimiento-correo", method=RequestMethod.GET)
	@ResponseBody
	public LeadSeguimiento getLeadSeguimiento(Integer idLeadSeguimiento,Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroLeadsBo bo=new RegistroLeadsBo(); 
	   LeadSeguimiento leadSeguimiento=new LeadSeguimiento(); 
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   leadSeguimiento=bo.getCorreoSeguimiento(idLeadSeguimiento);
	   }
	   return leadSeguimiento;
	}
   
   @RequestMapping(path={"/actualizar-seguimiento-correo"},method=RequestMethod.GET)
   public ModelAndView actualizarSeguimiento(Integer idLeadSeguimiento,Integer idLead,Integer idCotizado,Integer idCanal,
			Integer idReserva,Integer idMotivo,Integer paxFinal,Double revenue,Integer idServicioFinal,String observacion,String fechaProxima,
			Model model,HttpServletRequest request) {
	   
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   Integer id=bo.actualizarSeguimientoCorreo(idLeadSeguimiento,idLead,idCotizado,idCanal,
				idReserva,idMotivo,paxFinal,revenue,idServicioFinal,observacion,fechaProxima,pUser);
	   
	   //--Recuperalo desde la session
	   String fechaAdsIni=(String)request.getSession().getAttribute("fechaAdsIni");
	   String fechaAdsFin=(String)request.getSession().getAttribute("fechaAdsFin");
	   Integer idEstado=(Integer)request.getSession().getAttribute("idEstado");
	   Integer pIdEjecutivo=(Integer)request.getSession().getAttribute("pIdEjecutivo");
	   List<Value> listaEjecutivo=(List<Value>)request.getSession().getAttribute("listaEjecutivo");
	   
	   String fechaProximaIni=(String)request.getSession().getAttribute("fechaProximaIni");
	   String fechaProximaFin=(String)request.getSession().getAttribute("fechaProximaFin");
	   Integer idSeguimiento=(Integer)request.getSession().getAttribute("idSeguimiento");
	   //
	   Integer pIdArea=(Integer)request.getSession().getAttribute("pIdArea");
	   Integer pIdAdsetName=(Integer)request.getSession().getAttribute("pIdAdsetName");
	   Integer pIdReserva=(Integer)request.getSession().getAttribute("pIdReserva");
	   Integer pIdMotivo=(Integer)request.getSession().getAttribute("pIdMotivo");
	   Integer pCantSeg=(Integer)request.getSession().getAttribute("pCantSeg");
	   
	   Integer pidCotizado=(Integer)request.getSession().getAttribute("pIdCotizado");
	   
	   List<Correo> listaLeadsUpdate = getListLeads(fechaAdsIni,fechaAdsFin,idEstado,pIdEjecutivo,listaEjecutivo,fechaProximaIni,fechaProximaFin,idSeguimiento,
			   pIdArea,pIdAdsetName,pIdReserva,pIdMotivo,pCantSeg,pidCotizado,
			   pUser);

	   ModelAndView mv = new ModelAndView("/correos/registro-correos-tabla");
	   mv.addObject("listaLeads",listaLeadsUpdate);
	   return mv;
   }
   
   
   /**
    * Seguimiento de correos
    */
   @RequestMapping(path={"/correos/reporte-correos"},method=RequestMethod.GET)
   public String reporteCorreos(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   
		   RegistroLeadsBo bo=new RegistroLeadsBo();
		   List<Value> listaArea=bo.listArea();
		   List<Value> listaEjecutivo=bo.listEjecutivo(3,0);
		   
		   model.addAttribute("listaArea", listaArea);
		   model.addAttribute("listaEjecutivo", listaEjecutivo);
		   model.addAttribute("fechaHoy", "");
		   
		   return "/correos/reporte-correos";
	   }else{
		   return "login";
	   }
   }
   
   @RequestMapping(path={"/correos/reporte-leads-correos"},method=RequestMethod.GET)
   public String reporteCorreosTabla(Model model,HttpServletRequest request) {
	    return "/correos/reporte-leads-correos";
   }
   
   @RequestMapping(path={"/reporte-correos"},method=RequestMethod.GET)
   @ResponseBody
   public ModelAndView reporteCorreos(String fechaProximaIni,String fechaProximaFin,String fechaCargaIni,String fechaCargaFin,
		   Integer idArea,Integer idEjecutivo,Integer idEstado,Model model,HttpServletRequest request) {
	   List<ReporteCorreos> listaCorreos = new ArrayList<ReporteCorreos>();
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   
	   listaCorreos = bo.listaReporteCorreos(idArea, fechaProximaIni, 
			   fechaProximaFin, fechaCargaIni, fechaCargaFin,
			   idEjecutivo,idEstado);
	   
	   ModelAndView mv = new ModelAndView("/correos/reporte-correos-tabla");
	   mv.addObject("listaCorreos",listaCorreos);
	   return mv;
   }
   
}




