package com.delfines.spring.controller;

import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.Constante;
import com.delfines.business.RegistroEventosBo;
import com.delfines.business.RegistroLeadsBo;
import com.delfines.sendmail.SendEmail;
import com.delfines.vo.AsignaUsuario;
import com.delfines.vo.EventoAlo;
import com.delfines.vo.EventoAyB;
import com.delfines.vo.EventoEve;
import com.delfines.vo.EventoMkt;
import com.delfines.vo.EventoOrg;
import com.delfines.vo.EventoSed;
import com.delfines.vo.Eventos;
import com.delfines.vo.Usuario;
import com.delfines.vo.Value;

/**
 * @author imssbora
 */
@Controller
public class RegistroEventosController {
   
	@RequestMapping(path = { "/guardar-evento-gen"},method=RequestMethod.GET)
    @ResponseBody
    public ModelAndView guardarEventoGeneral(Integer idEvento,String denominacion,String fechaIni,String fechaFin,String descripcion,
		   Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroEventosBo bo=new RegistroEventosBo();
	   if(idEvento!=null&&idEvento>0){
		   idEvento=bo.actualizarEvento(idEvento,denominacion,fechaIni,fechaFin,descripcion,pUser);
	   }
	   ModelAndView mv = new ModelAndView("/eventos/registro-eventos-formulario");
	   mv.addObject("tab","1");
	   return mv;
   }
	
	@RequestMapping(path={"/guardar-evento-org"},method=RequestMethod.GET)
    @ResponseBody
    public ModelAndView guardarEventoOrganizacion(Integer idEvento,String organizador,String nombreContacto,String telefonoContacto,String correoContacto,Integer idServicio,
		   Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroEventosBo bo=new RegistroEventosBo();
	   if(idEvento!=null&&idEvento>0){
		   Integer id=bo.guardarEventoOrganizacion(idEvento,organizador,nombreContacto,telefonoContacto,correoContacto,idServicio,pUser);
		   if(id!=null&&id>0){
			   bo.actualizaEstadoSeguimiento(id,Constante.ID_TAB_ORGANIZACION);
		   }
	   }
	   ModelAndView mv = new ModelAndView("/eventos/registro-eventos-formulario");
	   mv.addObject("tab","2");
	   return mv;
   }
	
	@RequestMapping(path={"/guardar-evento-sede"},method=RequestMethod.GET)
    @ResponseBody
    public ModelAndView guardarEventoSede(Integer idEvento,String sedeActual,String sedeAnterior,Integer idPeriodicidad,Integer vecesHotel,Integer idContactoHotel,
		   Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroEventosBo bo=new RegistroEventosBo();
	   if(idEvento!=null&&idEvento>0){
		   Integer id=bo.guardarEventoSede(idEvento, sedeActual, sedeAnterior, idPeriodicidad, vecesHotel, idContactoHotel,pUser);
		   if(id!=null&&id>0){
			   bo.actualizaEstadoSeguimiento(id,Constante.ID_TAB_SEDE);
		   }
	   }
	   ModelAndView mv = new ModelAndView("/eventos/registro-eventos-formulario");
	   mv.addObject("tab","3");
	   return mv;
   }
	
	
	@RequestMapping(path={"/guardar-evento-eventos"},method=RequestMethod.GET)
    @ResponseBody
    public ModelAndView guardarEventoEventos(Integer idEvento,String cotiza,Integer idEjecutivo,Integer idEjecutivo2,Double revenue,String comentario,
		   Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroEventosBo bo=new RegistroEventosBo();
	   if(idEvento!=null&&idEvento>0){
		   Integer id=bo.guardarEventoEventos(idEvento, cotiza, idEjecutivo,idEjecutivo2,revenue, comentario, pUser);
		   if(id!=null&&id>0){
			   bo.actualizaEstadoSeguimiento(id,Constante.ID_TAB_EVENTOS);
		   }
	   }
	   ModelAndView mv = new ModelAndView("/eventos/registro-eventos-formulario");
	   mv.addObject("tab","4");
	   return mv;
   }
	
	
	@RequestMapping(path={"/guardar-evento-alojamiento"},method=RequestMethod.GET)
    @ResponseBody
    public ModelAndView guardarEventoAlojamiento(Integer idEvento,String cotiza,Integer idEjecutivo,Integer idEjecutivo2,Integer idEjecutivo3,Double revenue,String comentario,
		   Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroEventosBo bo=new RegistroEventosBo();
	   if(idEvento!=null&&idEvento>0){
		   Integer id=bo.guardarEventoAlojamiento(idEvento, cotiza, idEjecutivo,idEjecutivo2,idEjecutivo3, revenue, comentario, pUser);
		   if(id!=null&&id>0){
			   bo.actualizaEstadoSeguimiento(id,Constante.ID_TAB_ALOJAMIENTO);
		   }
	   }
	   ModelAndView mv = new ModelAndView("/eventos/registro-eventos-formulario");
	   mv.addObject("tab","5");
	   return mv;
   }
	
	
	@RequestMapping(path={"/guardar-evento-ayb"},method=RequestMethod.GET)
    @ResponseBody
    public ModelAndView guardarEventoAyB(Integer idEvento,String cotiza,Integer idEjecutivo,Double revenue,String comentario,
		   Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroEventosBo bo=new RegistroEventosBo();
	   if(idEvento!=null&&idEvento>0){
		   Integer id=bo.guardarEventoAyB(idEvento, cotiza, idEjecutivo, revenue, comentario, pUser);
		   if(id!=null&&id>0){
			   bo.actualizaEstadoSeguimiento(id,Constante.ID_TAB_AYB);
		   }
	   }
	   ModelAndView mv = new ModelAndView("/eventos/registro-eventos-formulario");
	   mv.addObject("tab","6");
	   return mv;
   }
	
	
	@RequestMapping(path={"/guardar-evento-marketing"},method=RequestMethod.GET)
    @ResponseBody
    public ModelAndView guardarEventoMarketing(Integer idEvento,String paginaWeb,String presenciaWeb,String nombreContacto,String comentario,
		   Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroEventosBo bo=new RegistroEventosBo();
	   if(idEvento!=null&&idEvento>0){
		   Integer id=bo.guardarEventoMarketing(idEvento, paginaWeb, presenciaWeb, nombreContacto, comentario, pUser);
		   if(id!=null&&id>0){
			   bo.actualizaEstadoSeguimiento(id,Constante.ID_TAB_MARKETING);
		   }
	   }
	   ModelAndView mv = new ModelAndView("/eventos/registro-eventos-formulario");
	   mv.addObject("tab","7");
	   return mv;
   }
	
	
   @RequestMapping(path={"/eventos/registro-eventos"},method=RequestMethod.GET)
   public String registroEventos(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   try{
			   RegistroEventosBo bo=new RegistroEventosBo();
			   List<Eventos> listaEvento=new LinkedList<Eventos>();
			   List<Value> listaAreas = bo.listArea();
			   List<Value> listaPeriodo=bo.listaPeriodo();

			   RegistroLeadsBo rlead=new RegistroLeadsBo();
			   String fechaHoy=rlead.getDate();
			   
			   model.addAttribute("listaEvento",listaEvento);
			   model.addAttribute("listaAreas",listaAreas);
			   model.addAttribute("listaPeriodo", listaPeriodo);
			   model.addAttribute("fechaHoy", fechaHoy);
		   }catch(Exception e){
			   e.printStackTrace();
		   }
		   
		   return "/eventos/registro-eventos";
	   }else{
		   return "login";
	   }
   }
   
   /***********************************INICIO*/
   @RequestMapping(path={"get-evento-ficha"},method=RequestMethod.GET)
   @ResponseBody
   public Value getEventoFicha(Integer idEvento,Model model,HttpServletRequest request) throws Exception {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   request.getSession().setAttribute("idEvento", idEvento);
	   }
	   
	   Value target=new Value();
	   target.setDenominacion("registro-eventos-ficha");
	   return target;
   }
   
   @RequestMapping(path={"/registro-eventos-ficha"},method=RequestMethod.GET)
   public String registroEventosFicha(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   try{
			   
			   RegistroEventosBo bo=new RegistroEventosBo();  
			   
			   Integer idEvento=(Integer)request.getSession().getAttribute("idEvento");
			   
			   Eventos eventoGen=bo.getEventoGen(idEvento);
			   EventoOrg eventoOrg=bo.getEventoOrg(idEvento); 
			   EventoSed eventoSed=bo.getEventoSed(idEvento);
			   EventoEve eventoEve=bo.getEventoEven(idEvento);
			   EventoAlo eventoAlo=bo.getEventoAlo(idEvento);
			   EventoAyB eventoAyB=bo.getEventoAyB(idEvento);
			   EventoMkt eventoMkt=bo.getEventoMkt(idEvento);
			   
			   model.addAttribute("eventoGen", eventoGen);
			   model.addAttribute("eventoOrg", eventoOrg);
			   model.addAttribute("eventoSed", eventoSed);
			   model.addAttribute("eventoEve", eventoEve);
			   model.addAttribute("eventoAlo", eventoAlo);
			   model.addAttribute("eventoAyB", eventoAyB);
			   model.addAttribute("eventoMkt", eventoMkt);
			   
		   }catch(Exception e){
			   e.printStackTrace();
		   }
		   
		   return "/eventos/registro-eventos-ficha";
	   }else{
		   return "login";
	   }
   }
   /***********************************FIN*/
   
   /***********************************INICIO*/
   @RequestMapping(path={"get-evento-form"},method=RequestMethod.GET)
   @ResponseBody
   public Value getEventoForm(Integer idEvento,Model model,HttpServletRequest request) throws Exception {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   request.getSession().setAttribute("idEvento", idEvento);
	   }
	   
	   model.addAttribute("idEvento", idEvento);
	   
	   Value target=new Value();
	   target.setDenominacion("registro-eventos-form");
	   return target;
   }
   
   @RequestMapping(path={"/registro-eventos-form"},method=RequestMethod.GET)
   public String registroEventosForm(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   try{
			   RegistroEventosBo bo=new RegistroEventosBo();  
			   
			   Integer idEvento=(Integer)request.getSession().getAttribute("idEvento");
			   
			   Eventos eventoGen=bo.getEventoGen(idEvento);
			   EventoOrg eventoOrg=bo.getEventoOrg(idEvento); 
			   EventoSed eventoSed=bo.getEventoSed(idEvento);
			   EventoEve eventoEve=bo.getEventoEven(idEvento);
			   EventoAlo eventoAlo=bo.getEventoAlo(idEvento);
			   EventoAyB eventoAyB=bo.getEventoAyB(idEvento);
			   EventoMkt eventoMkt=bo.getEventoMkt(idEvento);
			   
			   List<Value> lEjecutivoGeneral=bo.listUsuario(0);
			   model.addAttribute("lEjecutivoGeneral", lEjecutivoGeneral);
			   
			   List<Value> lEjecutivoVentas=bo.listUsuario(Constante.ID_AREA_VENTAS);
			   model.addAttribute("lEjecutivoVentas", lEjecutivoVentas);
			   
			   List<Value> lEjecutivoAyB=bo.listUsuario(Constante.ID_AREA_AYB);
			   model.addAttribute("lEjecutivoAyB", lEjecutivoAyB);
			   
			   List<Value> lEjecutivoEventos=bo.listUsuario(Constante.ID_AREA_EVENTOS_BANQUETES);
			   model.addAttribute("lEjecutivoEventos", lEjecutivoEventos);
			   
			   List<Value> lEjecutivoMarketing=bo.listUsuario(Constante.ID_AREA_MARKETING);
			   model.addAttribute("lEjecutivoMarketing", lEjecutivoMarketing);
			   
			   model.addAttribute("eventoGen", eventoGen);
			   model.addAttribute("eventoOrg", eventoOrg);
			   model.addAttribute("eventoSed", eventoSed);
			   model.addAttribute("eventoEve", eventoEve);
			   model.addAttribute("eventoAlo", eventoAlo);
			   model.addAttribute("eventoAyB", eventoAyB);
			   model.addAttribute("eventoMkt", eventoMkt);
			   
		   }catch(Exception e){
			   e.printStackTrace();
		   }
		   
		   return "/eventos/registro-eventos-formulario";
	   }else{
		   return "login";
	   }
   }
   /***********************************FIN*/
   
   
   
   @RequestMapping(path={"/registro-eventos-formulario"},method=RequestMethod.GET)
   @ResponseBody
   public ModelAndView registroEventosFormulario(Model model,HttpServletRequest request) {
	   RegistroEventosBo bo=new RegistroEventosBo();
	   ModelAndView mv = new ModelAndView("/eventos/registro-eventos-formulario");
	   return mv;
   }
   
   @RequestMapping(path={"/lista-eventos"},method=RequestMethod.GET)
   @ResponseBody
   public ModelAndView mostrarListaEventos(Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroEventosBo bo=new RegistroEventosBo();
	   
	   List<Value> lPeriodo=bo.listaPeriodo();

	   String p_fechaIni=(String)request.getSession().getAttribute("p_fechaIni");//fecha de carga
	   String p_fechaFin=(String)request.getSession().getAttribute("p_fechaFin");
	   Integer p_periodo=(Integer)request.getSession().getAttribute("p_periodo");
	   
	   Integer p_idarea=(Integer)request.getSession().getAttribute("p_idarea");
	   Integer p_idejecutivo=(Integer)request.getSession().getAttribute("p_idejecutivo");
	   
	   List<Eventos> lista=new LinkedList<>();
	   if(p_periodo!=null&&p_periodo>0||
			   p_fechaIni!=null&&p_fechaIni.trim().length()>0||
					   p_fechaFin!=null&&p_fechaFin.trim().length()>0||
							   p_idarea!=null&&p_idarea>0||
									   p_idejecutivo!=null&&p_idejecutivo>0){
	   		lista = bo.listarRegistroEventos(p_fechaIni,p_fechaFin,p_periodo,p_idarea,p_idejecutivo,pUser);
	   }
	   
	   ModelAndView mv = new ModelAndView("/eventos/registro-eventos-tabla");
	   mv.addObject("lista",lista);
	   mv.addObject("lPeriodo",lPeriodo);
	   
	   return mv;
   }

    @RequestMapping(path={"/buscar-registro-eventos"},method=RequestMethod.GET)
	@ResponseBody
	public ModelAndView buscarRegistroEventos(String fechaIni,String fechaFin, Integer periodo,Integer idArea,Integer idEjecutivo,Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   RegistroEventosBo bo=new RegistroEventosBo();
	   

	   List<Eventos> lista=new LinkedList<>();
	   if(periodo!=null&&periodo>0||
			   fechaIni!=null&&fechaIni.trim().length()>0||
					   fechaFin!=null&&fechaFin.trim().length()>0||
							   idArea!=null&&idArea>0||
							   idEjecutivo!=null&&idEjecutivo>0){
	   		lista = bo.listarRegistroEventos(fechaIni,fechaFin,periodo,idArea,idEjecutivo,pUser);
	   		
	   		request.getSession().setAttribute("p_fechaIni", fechaIni);//fecha de carga
	 	    request.getSession().setAttribute("p_fechaFin", fechaFin);
	 	    request.getSession().setAttribute("p_periodo", periodo);
	 	    //
	 	    request.getSession().setAttribute("p_idarea", idArea);
	 	    request.getSession().setAttribute("p_idejecutivo", idEjecutivo);
	   }
	   
	   ModelAndView mv = new ModelAndView("/eventos/registro-eventos-tabla");
	   mv.addObject("lista",lista);
	   return mv;
	}
   
    @RequestMapping(path={"/guardar-evento"},method=RequestMethod.GET)
    @ResponseBody
    public ModelAndView guardarEvento(Integer idEvento,String denominacion,String fechaInicio,String fechaFin,String descripcion,
		   Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroEventosBo bo=new RegistroEventosBo();
	   if(idEvento>0){
		   idEvento=bo.actualizarEvento(idEvento,denominacion,fechaInicio,fechaFin,descripcion,pUser);
	   }else{
		   idEvento=bo.guardarEvento(denominacion,fechaInicio,fechaFin,descripcion,pUser);
		   
		   if(idEvento!=null&&idEvento>0){
				 //-------------------------Send Email Alert
		   		String fechaHoraHoy=bo.getDateTime();
		   		String subject="Alerta de registro de Eventos";
		   		String text="Se ha creado el evento "+denominacion.trim().toUpperCase()+", para el periodo "+fechaInicio+" - "+fechaFin;
		   		String toList="aluna@losdelfineshotel.com.pe,gburmester@losdelfineshotel.com.pe,jdietz@losdelfineshotel.com.pe,vperalta@losdelfineshotel.com.pe";
		   		String ccList="promociones@losdelfineshotel.com.pe,grupoeventos@losdelfineshotel.com.pe,grupoventas@losdelfineshotel.com.pe,gruposistemas@losdelfineshotel.com.pe,ayb@losdelfineshotel.com.pe";
		   		SendEmail.sendEmailLead(toList, ccList, subject, text);
		   		//-------------------------
		   }
	   }
	   
	   String p_fechaIni=(String)request.getSession().getAttribute("p_fechaIni");//fecha de carga
	   String p_fechaFin=(String)request.getSession().getAttribute("p_fechaFin");
	   Integer p_periodo=(Integer)request.getSession().getAttribute("p_periodo");
	   Integer p_idarea=(Integer)request.getSession().getAttribute("p_idarea");
	   Integer p_idejecutivo=(Integer)request.getSession().getAttribute("p_idejecutivo");
	   
	   List<Eventos> lista=new LinkedList<>();
	   if(p_periodo!=null&&p_periodo>0||
			   p_fechaIni!=null&&p_fechaIni.trim().length()>0||
					   p_fechaFin!=null&&p_fechaFin.trim().length()>0){
	   		lista = bo.listarRegistroEventos(p_fechaIni,p_fechaFin,p_periodo,p_idarea,p_idejecutivo,pUser);
	   }
	   
	   ModelAndView mv = new ModelAndView("/eventos/registro-eventos-tabla");
	   mv.addObject("lista",lista);
	   return mv;
    }
    
   
    @RequestMapping(value="/get-evento", method=RequestMethod.GET)
	@ResponseBody
	public Eventos getEvento(Integer idEvento,Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroEventosBo bo=new RegistroEventosBo(); 
	   Eventos evento=bo.getEventoGen(idEvento);
	   
	   return evento;
	}
   
    
    @RequestMapping(path={"/eliminar-evento"},method=RequestMethod.GET)
    public ModelAndView eliminar(Integer id,Model model,HttpServletRequest request) {
 	    Integer res=Constante.ID_INICIAL; 
 	    RegistroEventosBo bo=new RegistroEventosBo();
 	    Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
 	    if(id!=null&&id>0){
 	    	res=bo.eliminarEvento(id,pUser);
 	    }
 	    
 	   String p_fechaIni=(String)request.getSession().getAttribute("p_fechaIni");//fecha de carga
	   String p_fechaFin=(String)request.getSession().getAttribute("p_fechaFin");
	   Integer p_periodo=(Integer)request.getSession().getAttribute("p_periodo");
	   Integer p_idarea=(Integer)request.getSession().getAttribute("p_idarea");
	   Integer p_idejecutivo=(Integer)request.getSession().getAttribute("p_idejecutivo");
	   
	   List<Eventos> lista=new LinkedList<>();
	   if(p_periodo!=null&&p_periodo>0||
			   p_fechaIni!=null&&p_fechaIni.trim().length()>0||
					   p_fechaFin!=null&&p_fechaFin.trim().length()>0){
	   		lista = bo.listarRegistroEventos(p_fechaIni,p_fechaFin,p_periodo,p_idarea,p_idejecutivo,pUser);
	   }
 	    
 		ModelAndView mv = new ModelAndView("/eventos/registro-eventos-tabla");
 		mv.addObject("lista",lista);
 		return mv;
    }
   
    @RequestMapping(path={"/obtener-ejecutivos-area"},method=RequestMethod.GET)
	@ResponseBody
    public List<Value> obtenerSericiosLista(Integer idArea,Model model,HttpServletRequest request) {
    	RegistroEventosBo bo=new RegistroEventosBo();
	    List lista=bo.listaUsuariosByArea(idArea);
	    return lista;
	}
    
    /***
     * Actualizacion en ficha de datos
     */
    @RequestMapping(path={"actualiza-evento-gen"},method=RequestMethod.GET)
    @ResponseBody
    public Eventos actualizaEventoGen(Integer idEvento,Model model,HttpServletRequest request) throws Exception {
 	   Eventos eventoGen=new Eventos(); 
 	   if(idEvento!=null&&idEvento>0){
 		  RegistroEventosBo bo=new RegistroEventosBo(); 	   
 	 	  eventoGen=bo.getEventoGen(idEvento);   
 	   }
 	   return eventoGen;
    }
    
    @RequestMapping(path={"actualiza-evento-org"},method=RequestMethod.GET)
    @ResponseBody
    public EventoOrg actualizaEventoOrg(Integer idEvento,Model model,HttpServletRequest request) throws Exception {
    	EventoOrg eventoGen=new EventoOrg(); 
 	    if(idEvento!=null&&idEvento>0){
 		  RegistroEventosBo bo=new RegistroEventosBo(); 	   
 	 	  eventoGen=bo.getEventoOrg(idEvento);   
 	    }
 	    return eventoGen;
    }
    
    @RequestMapping(path={"actualiza-evento-sed"},method=RequestMethod.GET)
    @ResponseBody
    public EventoSed actualizaEventoSed(Integer idEvento,Model model,HttpServletRequest request) throws Exception {
 	   EventoSed eventoGen=new EventoSed(); 
 	   if(idEvento!=null&&idEvento>0){
 		  RegistroEventosBo bo=new RegistroEventosBo(); 	   
 	 	  eventoGen=bo.getEventoSed(idEvento);   
 	   }
 	   return eventoGen;
    }
    @RequestMapping(path={"actualiza-evento-eve"},method=RequestMethod.GET)
    @ResponseBody
    public EventoEve actualizaEventoEve(Integer idEvento,Model model,HttpServletRequest request) throws Exception {
 	   EventoEve eventoGen=new EventoEve(); 
 	   if(idEvento!=null&&idEvento>0){
 		  RegistroEventosBo bo=new RegistroEventosBo(); 	   
 	 	  eventoGen=bo.getEventoEven(idEvento);   
 	   }
 	   return eventoGen;
    }
    @RequestMapping(path={"actualiza-evento-alo"},method=RequestMethod.GET)
    @ResponseBody
    public EventoAlo actualizaEventoAlo(Integer idEvento,Model model,HttpServletRequest request) throws Exception {
 	   EventoAlo eventoGen=new EventoAlo(); 
 	   if(idEvento!=null&&idEvento>0){
 		  RegistroEventosBo bo=new RegistroEventosBo(); 	   
 	 	  eventoGen=bo.getEventoAlo(idEvento);   
 	   }
 	   return eventoGen;
    }
    @RequestMapping(path={"actualiza-evento-ayb"},method=RequestMethod.GET)
    @ResponseBody
    public EventoAyB actualizaEventoAyb(Integer idEvento,Model model,HttpServletRequest request) throws Exception {
 	   EventoAyB eventoGen=new EventoAyB(); 
 	   if(idEvento!=null&&idEvento>0){
 		  RegistroEventosBo bo=new RegistroEventosBo(); 	   
 	 	  eventoGen=bo.getEventoAyB(idEvento);   
 	   }
 	   return eventoGen;
    }
    
    @RequestMapping(path={"actualiza-evento-mkt"},method=RequestMethod.GET)
    @ResponseBody
    public EventoMkt actualizaEventoMkt(Integer idEvento,Model model,HttpServletRequest request) throws Exception {
 	   EventoMkt eventoGen=new EventoMkt(); 
 	   if(idEvento!=null&&idEvento>0){
 		  RegistroEventosBo bo=new RegistroEventosBo(); 	   
 	 	  eventoGen=bo.getEventoMkt(idEvento);   
 	   }
 	   return eventoGen;
    }
}


