package com.delfines.spring.controller;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.business.RegistroLeadsBo;
import com.delfines.vo.Lead;
import com.delfines.vo.LeadSeguimiento;
import com.delfines.vo.Usuario;
import com.delfines.vo.Value;
import com.delfines.vo.leads.ReporteGeneral;

/**
 * @author imssbora
 */
@Controller
public class RegistroLeadsController {
   

   @RequestMapping(path={"/leads/reporte-leads"},method=RequestMethod.GET)
   public String reporteLeads(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   
		   RegistroLeadsBo bo=new RegistroLeadsBo();
		   List<Value> listaAdSetName=bo.listAdSetName();
		   List<Value> listaArea=bo.listArea();
		   List<Value> listaSubArea=bo.listSubArea();
		   List<Value> listaEjecutivo=bo.listEjecutivo(3,0);
		   
		   String fechaHoy=bo.getDate();
		   model.addAttribute("listaAdSetName", listaAdSetName);
		   model.addAttribute("listaArea", listaArea);
		   model.addAttribute("listaSubArea", listaSubArea);
		   model.addAttribute("listaEjecutivo", listaEjecutivo);
		   model.addAttribute("fechaHoy", "");
		   
		   return "/leads/reporte-leads";
	   }else{
		   return "login";
	   }
   }
   
   @RequestMapping(path={"/leads/reporte-leads-tabla"},method=RequestMethod.GET)
   public String reporteLeadsTabla(Model model,HttpServletRequest request) {
	    return "/leads/reporte-leads-tabla";
   }
	   
   @RequestMapping(path={"/lista-leads"},method=RequestMethod.GET)
   public String mostrarListaLeads(Model model,HttpServletRequest request) {
	    return "registro-leads-tabla";
   }
   
   @RequestMapping(path={"/asignar-ejecutivo-all"},method=RequestMethod.GET)
   public ModelAndView asignarEjecutivoLeadsAll(Integer idEjecutivo,Integer desde,Integer hasta,Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   
	   //--Recuperalo desde la session
	   Integer idAdsetName=(Integer)request.getSession().getAttribute("idAdsetName");
	   String fechaAdsIni=(String)request.getSession().getAttribute("fechaAdsIni");
	   String fechaAdsFin=(String)request.getSession().getAttribute("fechaAdsFin");
	   Integer idArea=(Integer)request.getSession().getAttribute("idArea");
	   Integer idSubArea=(Integer)request.getSession().getAttribute("idSubArea");
	   Integer idEstado=(Integer)request.getSession().getAttribute("idEstado");
	   String fechaLeadIni=(String)request.getSession().getAttribute("fechaLeadIni");
	   String fechaLeadFin=(String)request.getSession().getAttribute("fechaLeadFin");
	   
	   String fechaProxIni=(String)request.getSession().getAttribute("fechaProxIni");
	   String fechaProxFin=(String)request.getSession().getAttribute("fechaProxFin");
	   
	   Integer idSeguimiento=(Integer)request.getSession().getAttribute("idSeguimiento");
	   //nuevos filtros 28/082018
	   Integer idMotivo=(Integer)request.getSession().getAttribute("idMotivo");
	   Integer idReserva=(Integer)request.getSession().getAttribute("idReserva");
	   Integer seqSeguimiento=(Integer)request.getSession().getAttribute("seqSeguimiento");
	   Integer pidCotizado=(Integer)request.getSession().getAttribute("idCotizado");
	   
	   List<Lead> listaLeads = getListLeads(idAdsetName,fechaAdsIni,fechaAdsFin,idArea,idSubArea,idEstado,fechaLeadIni,fechaLeadFin,fechaProxIni,fechaProxFin,idSeguimiento,
			   idMotivo,idReserva,seqSeguimiento,pidCotizado,
			   pUser);
	   
	   bo.asignarEjecutivo(idEjecutivo,listaLeads,desde,hasta);
		   
	   List<Lead> listaLeadsUpdate = getListLeads(idAdsetName,fechaAdsIni,fechaAdsFin,idArea,idSubArea,idEstado,fechaLeadIni,fechaLeadFin,fechaProxIni,fechaProxFin,idSeguimiento,
			   idMotivo,idReserva,seqSeguimiento,pidCotizado,
			   pUser);
	   
	   ModelAndView mv = new ModelAndView("registro-leads-tabla");
	   mv.addObject("listaLeads",listaLeadsUpdate);
	   return mv;
   }
   
   
   
   @RequestMapping(path={"/asignar-ejecutivo-single"},method=RequestMethod.GET)
   public ModelAndView asignarEjecutivoLeadsSingle(Integer idEjecutivo,Integer idLead,Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   bo.reAsignarEjecutivoLead(idEjecutivo, idLead);
	   
	   //--Recuperalo desde la session
	   Integer idAdsetName=(Integer)request.getSession().getAttribute("idAdsetName");
	   String fechaAdsIni=(String)request.getSession().getAttribute("fechaAdsIni");
	   String fechaAdsFin=(String)request.getSession().getAttribute("fechaAdsFin");
	   Integer idArea=(Integer)request.getSession().getAttribute("idArea");
	   Integer idSubArea=(Integer)request.getSession().getAttribute("idSubArea");
	   Integer idEstado=(Integer)request.getSession().getAttribute("idEstado");
	   String fechaLeadIni=(String)request.getSession().getAttribute("fechaLeadIni");
	   String fechaLeadFin=(String)request.getSession().getAttribute("fechaLeadFin");
	   
	   String fechaProxIni=(String)request.getSession().getAttribute("fechaProxIni");
	   String fechaProxFin=(String)request.getSession().getAttribute("fechaProxFin");
	   
	   Integer idSeguimiento=(Integer)request.getSession().getAttribute("idSeguimiento");
	   
	   //nuevos filtros 28/082018
	   Integer idMotivo=(Integer)request.getSession().getAttribute("idMotivo");
	   Integer idReserva=(Integer)request.getSession().getAttribute("idReserva");
	   Integer seqSeguimiento=(Integer)request.getSession().getAttribute("seqSeguimiento");
	   Integer pidCotizado=(Integer)request.getSession().getAttribute("idCotizado");
	   
	   List<Lead> listaLeadsUpdate = getListLeads(idAdsetName,fechaAdsIni,fechaAdsFin,idArea,idSubArea,idEstado,fechaLeadIni,fechaLeadFin,fechaProxIni,fechaProxFin,idSeguimiento,
			   idMotivo,idReserva,seqSeguimiento,pidCotizado,
			   pUser);
	   
	   ModelAndView mv = new ModelAndView("registro-leads-tabla");
	   mv.addObject("listaLeads",listaLeadsUpdate);
	   return mv;
   }
   
   
   @RequestMapping(path={"/actualizar-fecha-servicio"},method=RequestMethod.GET)
   public ModelAndView actualizarFechaServicio(Integer idLead,String fechaAdset,Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   bo.actualizarFechaServicio(idLead, fechaAdset);
	   
	   //--Recuperalo desde la session
	   Integer idAdsetName=(Integer)request.getSession().getAttribute("idAdsetName");
	   String fechaAdsIni=(String)request.getSession().getAttribute("fechaAdsIni");
	   String fechaAdsFin=(String)request.getSession().getAttribute("fechaAdsFin");
	   Integer idArea=(Integer)request.getSession().getAttribute("idArea");
	   Integer idSubArea=(Integer)request.getSession().getAttribute("idSubArea");
	   Integer idEstado=(Integer)request.getSession().getAttribute("idEstado");
	   String fechaLeadIni=(String)request.getSession().getAttribute("fechaLeadIni");
	   String fechaLeadFin=(String)request.getSession().getAttribute("fechaLeadFin");
	   
	   String fechaProxIni=(String)request.getSession().getAttribute("fechaProxIni");
	   String fechaProxFin=(String)request.getSession().getAttribute("fechaProxFin");
	   
	   Integer idSeguimiento=(Integer)request.getSession().getAttribute("idSeguimiento");
	   
	   //nuevos filtros 28/082018
	   Integer idMotivo=(Integer)request.getSession().getAttribute("idMotivo");
	   Integer idReserva=(Integer)request.getSession().getAttribute("idReserva");
	   Integer seqSeguimiento=(Integer)request.getSession().getAttribute("seqSeguimiento");
	   Integer pidCotizado=(Integer)request.getSession().getAttribute("idCotizado");
	   
	   List<Lead> listaLeadsUpdate = getListLeads(idAdsetName,fechaAdsIni,fechaAdsFin,idArea,idSubArea,idEstado,fechaLeadIni,fechaLeadFin,fechaProxIni,fechaProxFin,idSeguimiento,
			   idMotivo,idReserva,seqSeguimiento,pidCotizado,
			   pUser);
	   
	   ModelAndView mv = new ModelAndView("registro-leads-tabla");
	   mv.addObject("listaLeads",listaLeadsUpdate);
	   return mv;
   }
   
   
   @RequestMapping(path={"/buscar-leads"},method=RequestMethod.GET)
   public ModelAndView buscarListaLeads(Integer idAdsetName,String fechaAdsIni,String fechaAdsFin,Integer idArea,Integer idSubArea,Integer idEstado,
		   String fechaLeadIni,String fechaLeadFin,String fechaProxIni,String fechaProxFin,Integer idSeguimiento,
		   Integer idMotivo,Integer idReserva,Integer seqSeguimiento,Integer idCotizado,
		   Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   List<Lead> listaLeads = getListLeads(idAdsetName,fechaAdsIni,fechaAdsFin,idArea,idSubArea,idEstado,fechaLeadIni,fechaLeadFin,fechaProxIni,fechaProxFin,idSeguimiento,
			   idMotivo,idReserva,seqSeguimiento,idCotizado,
			   pUser);
	   
	   request.getSession().setAttribute("idAdsetName", idAdsetName);
	   request.getSession().setAttribute("fechaAdsIni", fechaAdsIni);//fecha de carga
	   request.getSession().setAttribute("fechaAdsFin", fechaAdsFin);
	   request.getSession().setAttribute("idArea", idArea);
	   request.getSession().setAttribute("idSubArea", idSubArea);
	   request.getSession().setAttribute("idEstado", idEstado);
	   
	   request.getSession().setAttribute("fechaLeadIni", fechaLeadIni);//fecha de evento
	   request.getSession().setAttribute("fechaLeadFin", fechaLeadFin);
	   
	   request.getSession().setAttribute("fechaProxIni", fechaProxIni);//fecha proxima
	   request.getSession().setAttribute("fechaProxFin", fechaProxFin);
	   //--
	   request.getSession().setAttribute("idSeguimiento", idSeguimiento);
	   request.getSession().setAttribute("idCotizado", idCotizado);
	   
	   ModelAndView mv = new ModelAndView("registro-leads-tabla");
	   mv.addObject("listaLeads",listaLeads);
	   return mv;
   }
   
   @RequestMapping(path={"/buscar-leads-seguimiento"},method=RequestMethod.GET)
   @ResponseBody
   public ModelAndView buscarListaLeadsSeguimiento(Integer idLead,Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   List<LeadSeguimiento> listaLeadSeguimiento=bo.listLeadsSeguimientoByIdLead(idLead);
	   	   
	   ModelAndView mv = new ModelAndView("registro-leads-tabla-seguimiento");
	   mv.addObject("listaLeadsSeguimiento",listaLeadSeguimiento);
	   return mv;
   }
   
   @RequestMapping(path={"/guardar-seguimiento"},method=RequestMethod.GET)
   public ModelAndView guardarSeguimiento(Integer idEjecutivo,Integer idLead,Integer idCotizado,Integer idCanal,
			Integer idReserva,Integer idMotivo,Integer paxFinal,Double revenue,Integer idServicioFinal,String observacion,String fechaProxima,Integer hora,
			Model model,HttpServletRequest request) {
	   
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   Integer idLeadSeguimiento=bo.guardarSeguimiento(idEjecutivo,idLead,idCotizado,idCanal,
				idReserva,idMotivo,paxFinal,revenue,idServicioFinal,observacion,fechaProxima,hora,pUser);
	   
	   if(idLeadSeguimiento>0){
		   bo.actualiaEstadoSeguimiento(idLeadSeguimiento);
	   }
	   
	   //--Recuperalo desde la session
	   Integer idAdsetName=(Integer)request.getSession().getAttribute("idAdsetName");
	   String fechaAdsIni=(String)request.getSession().getAttribute("fechaAdsIni");
	   String fechaAdsFin=(String)request.getSession().getAttribute("fechaAdsFin");
	   Integer idArea=(Integer)request.getSession().getAttribute("idArea");
	   Integer idSubArea=(Integer)request.getSession().getAttribute("idSubArea");
	   Integer idEstado=(Integer)request.getSession().getAttribute("idEstado");
	   
	   String fechaLeadIni=(String)request.getSession().getAttribute("fechaLeadIni");
	   String fechaLeadFin=(String)request.getSession().getAttribute("fechaLeadFin");
	   
	   String fechaProxIni=(String)request.getSession().getAttribute("fechaProxIni");
	   String fechaProxFin=(String)request.getSession().getAttribute("fechaProxFin");
	   
	   Integer idSeguimiento=(Integer)request.getSession().getAttribute("idSeguimiento");
	 //nuevos filtros 28/082018
	   idMotivo=(Integer)request.getSession().getAttribute("idMotivo");
	   idReserva=(Integer)request.getSession().getAttribute("idReserva");
	   Integer seqSeguimiento=(Integer)request.getSession().getAttribute("seqSeguimiento");
	   Integer pidCotizado=(Integer)request.getSession().getAttribute("idCotizado");
	   
	   List<Lead> listaLeadsUpdate = getListLeads(idAdsetName,fechaAdsIni,fechaAdsFin,idArea,idSubArea,idEstado,fechaLeadIni,fechaLeadFin,fechaProxIni,fechaProxFin,idSeguimiento,
			   idMotivo,idReserva,seqSeguimiento,pidCotizado,
			   pUser);
	   
	   ModelAndView mv = new ModelAndView("registro-leads-tabla");
	   mv.addObject("listaLeads",listaLeadsUpdate);
	   return mv;
   }
   
   @RequestMapping(path={"/actualizar-seguimiento"},method=RequestMethod.GET)
   public ModelAndView actualizarSeguimiento(Integer idLeadSeguimiento,Integer idLead,Integer idCotizado,Integer idCanal,
			Integer idReserva,Integer idMotivo,Integer paxFinal,Double revenue,Integer idServicioFinal,String observacion,String fechaProxima,Integer hora,
			Model model,HttpServletRequest request) {
	   
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   Integer id=bo.actualizarSeguimiento(idLeadSeguimiento,idLead,idCotizado,idCanal,
				idReserva,idMotivo,paxFinal,revenue,idServicioFinal,observacion,fechaProxima,hora,pUser);
	   
	//--Recuperalo desde la session
	   Integer idAdsetName=(Integer)request.getSession().getAttribute("idAdsetName");
	   String fechaAdsIni=(String)request.getSession().getAttribute("fechaAdsIni");
	   String fechaAdsFin=(String)request.getSession().getAttribute("fechaAdsFin");
	   Integer idArea=(Integer)request.getSession().getAttribute("idArea");
	   Integer idSubArea=(Integer)request.getSession().getAttribute("idSubArea");
	   Integer idEstado=(Integer)request.getSession().getAttribute("idEstado");
	   
	   String fechaLeadIni=(String)request.getSession().getAttribute("fechaLeadIni");
	   String fechaLeadFin=(String)request.getSession().getAttribute("fechaLeadFin");
	   
	   String fechaProxIni=(String)request.getSession().getAttribute("fechaProxIni");
	   String fechaProxFin=(String)request.getSession().getAttribute("fechaProxFin");
	   
	   Integer idSeguimiento=(Integer)request.getSession().getAttribute("idSeguimiento");
	 //nuevos filtros 28/082018
	   idMotivo=(Integer)request.getSession().getAttribute("idMotivo");
	   idReserva=(Integer)request.getSession().getAttribute("idReserva");
	   Integer seqSeguimiento=(Integer)request.getSession().getAttribute("seqSeguimiento");
	   Integer pidCotizado=(Integer)request.getSession().getAttribute("idCotizado");
	   
	   List<Lead> listaLeadsUpdate = getListLeads(idAdsetName,fechaAdsIni,fechaAdsFin,idArea,idSubArea,idEstado,fechaLeadIni,fechaLeadFin,fechaProxIni,fechaProxFin,idSeguimiento,
			   idMotivo,idReserva,seqSeguimiento,pidCotizado,
			   pUser);
	   
	   ModelAndView mv = new ModelAndView("registro-leads-tabla");
	   mv.addObject("listaLeads",listaLeadsUpdate);
	   return mv;
   }
   
   public  List<Lead> getListLeads(Integer idAdsetName,String fechaAdsIni,String fechaAdsFin,Integer idArea,Integer idSubArea,Integer idEstado,
		   String fechaLeadIni,String fechaLeadFin,String fechaProxIni,String fechaProxFin,Integer idSeguimiento,
		   Integer idMotivo,Integer idReserva,Integer seqSeguimiento,Integer idCotizado,
		   Usuario pUser){
	   List<Lead> listaLeads = new ArrayList<Lead>();
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   
	   listaLeads=bo.listLeads(idAdsetName,fechaAdsIni,fechaAdsFin,idArea,idSubArea,idEstado,fechaLeadIni,fechaLeadFin,fechaProxIni,fechaProxFin,idSeguimiento,
			   idMotivo,idReserva,seqSeguimiento,idCotizado,
			   pUser);
	   
	   return listaLeads;
   }
   
   /**
    * Registro leads
    * @param model
    * @param request
    * @return
    */
   @RequestMapping(path={"/registro-leads"},method=RequestMethod.GET)
   public String  registrLeads(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   
		   RegistroLeadsBo bo=new RegistroLeadsBo();
		   List<Value> listaAdSetName=bo.listAdSetName();
		   List<Value> listaArea=bo.listArea();
		   List<Value> listaSubArea=bo.listSubArea();
		   List<Value> listaEjecutivo=bo.listEjecutivo(3,pUsuario.getAreaId());
		   
		   String fechaHoy=bo.getDate();
		   
		   model.addAttribute("listaAdSetName", listaAdSetName);
		   model.addAttribute("listaArea", listaArea);
		   model.addAttribute("listaSubArea", listaSubArea);
		   model.addAttribute("listaEjecutivo", listaEjecutivo);
		   model.addAttribute("fechaHoy", fechaHoy);
		   
		   return "registro-leads";
	   }else{
		   return "login";
	   }
   }
   
   @RequestMapping(path={"/registro-leads-tabla"},method=RequestMethod.GET)
   public String  registrLeadsTabla(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   return "registro-leads-tabla";
	   }else{
		   return "login";
	   }
   }

   @RequestMapping(path={"/reporte-leads"},method=RequestMethod.GET)
   public ModelAndView reporteLeads(Integer idAdsetName,String fechaAdsIni,String fechaAdsFin,String fechaContactoIni,String fechaContactoFin,
		   String fechaProximaIni,String fechaProximaFin,String fechaCargaIni,String fechaCargaFin,
		   Integer idArea,Integer idSubArea,Integer idEjecutivo,Integer idEstado,Model model,HttpServletRequest request) {
	   List<ReporteGeneral> listaLeads = new ArrayList<ReporteGeneral>();
	   RegistroLeadsBo bo=new RegistroLeadsBo();
	   
	   listaLeads = bo.listaReporteGeneral(idArea, idSubArea, idAdsetName, fechaAdsIni, fechaAdsFin, 
			   fechaContactoIni, fechaContactoFin, fechaProximaIni, 
			   fechaProximaFin, fechaCargaIni, fechaCargaFin,
			   idEjecutivo,idEstado);
	   
	   ModelAndView mv = new ModelAndView("/leads/reporte-leads-tabla");
	   mv.addObject("listaLeads",listaLeads);
	   return mv;
   }
   
   
    @RequestMapping(value="/get-lead-seguimiento", method=RequestMethod.GET)
	@ResponseBody
	public LeadSeguimiento getLeadSeguimiento(Integer idLeadSeguimiento,Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroLeadsBo bo=new RegistroLeadsBo(); 
	   LeadSeguimiento leadSeguimiento=new LeadSeguimiento(); 
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   leadSeguimiento=bo.getLeadSeguimiento(idLeadSeguimiento);
	   }
	   return leadSeguimiento;
	}

    @RequestMapping(path={"/guardar-mail-masivo"},method=RequestMethod.GET)
    public ModelAndView guardarMailMasivo(String mailIdLeads,String descripcion,Model model,HttpServletRequest request) {
 	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
 	   
 	   RegistroLeadsBo bo=new RegistroLeadsBo();
 	   Integer id=bo.guardarMailMasivo(mailIdLeads,descripcion,pUser);
 	   
 	//--Recuperalo desde la session
	   Integer idAdsetName=(Integer)request.getSession().getAttribute("idAdsetName");
	   String fechaAdsIni=(String)request.getSession().getAttribute("fechaAdsIni");
	   String fechaAdsFin=(String)request.getSession().getAttribute("fechaAdsFin");
	   Integer idArea=(Integer)request.getSession().getAttribute("idArea");
	   Integer idSubArea=(Integer)request.getSession().getAttribute("idSubArea");
	   Integer idEstado=(Integer)request.getSession().getAttribute("idEstado");
	   
	   String fechaLeadIni=(String)request.getSession().getAttribute("fechaLeadIni");
	   String fechaLeadFin=(String)request.getSession().getAttribute("fechaLeadFin");
	   
	   String fechaProxIni=(String)request.getSession().getAttribute("fechaProxIni");
	   String fechaProxFin=(String)request.getSession().getAttribute("fechaProxFin");
	   
	   Integer idSeguimiento=(Integer)request.getSession().getAttribute("idSeguimiento");
	 //nuevos filtros 28/082018
	   Integer idMotivo=(Integer)request.getSession().getAttribute("idMotivo");
	   Integer idReserva=(Integer)request.getSession().getAttribute("idReserva");
	   Integer seqSeguimiento=(Integer)request.getSession().getAttribute("seqSeguimiento");
	   
	   Integer idCotizado=(Integer)request.getSession().getAttribute("idCotizado");
	   
	   List<Lead> listaLeadsUpdate = getListLeads(idAdsetName,fechaAdsIni,fechaAdsFin,idArea,idSubArea,idEstado,fechaLeadIni,fechaLeadFin,fechaProxIni,fechaProxFin,idSeguimiento,
			   idMotivo,idReserva,seqSeguimiento,idCotizado,
			   pUser);
	   
	   ModelAndView mv = new ModelAndView("registro-leads-tabla");
	   mv.addObject("listaLeads",listaLeadsUpdate);
	   return mv;
    }
    
}




