
package com.delfines.spring.controller;

import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.business.RegistroReservasBo;
import com.delfines.vo.Cliente;
import com.delfines.vo.Eventos;
import com.delfines.vo.Usuario;
import com.delfines.vo.Value;
import com.delfines.vo.reservas.Reservas;

/**
 * @author imssbora
 */
@Controller
public class RegistroReservasController {
   
    @RequestMapping(path={"/guardar-reserva"},method=RequestMethod.GET)
    @ResponseBody
    public ModelAndView guardarReserva(Integer idReserva,Integer idCliente,Integer idTipoReserva,Integer idOutlet,Integer adultos,Integer ninos,String fechaReserva,String horaReserva,Double ventaEstimada,String observacion,
		   Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroReservasBo bo=new RegistroReservasBo();
	   if(idReserva>0){
		   idReserva=bo.actualizarReserva(idReserva,idCliente,idTipoReserva,idOutlet,adultos,ninos,fechaReserva,horaReserva,ventaEstimada,observacion,pUser);
	   }else{
		   idReserva=bo.guardarReserva(idCliente,idTipoReserva,idOutlet,adultos,ninos,fechaReserva,horaReserva,ventaEstimada,observacion,pUser);
	   }
	   
	   String p_fechaIni=(String)request.getSession().getAttribute("p_fechaIni");
	   String p_fechaFin=(String)request.getSession().getAttribute("p_fechaFin");
	   
	   Integer p_idoutlet=(Integer)request.getSession().getAttribute("p_idoutlet");
 	   Integer p_idtiporeserva=(Integer)request.getSession().getAttribute("p_idtiporeserva");
 	   Integer p_idejecutivo=(Integer)request.getSession().getAttribute("p_idejecutivo");
	   
	   List<Reservas> lista=new LinkedList<>();
	   if(p_idoutlet!=null&&p_idoutlet>=0||
 			   p_fechaIni!=null&&p_fechaIni.trim().length()>0||
 					   p_fechaFin!=null&&p_fechaFin.trim().length()>0||
 							  p_idtiporeserva!=null&&p_idtiporeserva>=0||
 									   p_idejecutivo!=null&&p_idejecutivo>=0){
 		  lista = bo.listarReservas(p_fechaIni, p_fechaFin, p_idoutlet, p_idtiporeserva, p_idejecutivo);
 	   }
	   
	   ModelAndView mv = new ModelAndView("/reservas/registro-reservas-tabla");
	   mv.addObject("lista",lista);
	   return mv;
    }

    @RequestMapping(path={"/lista-reservas"},method=RequestMethod.GET)
    @ResponseBody
    public ModelAndView mostrarListaReservas(Model model,HttpServletRequest request) {
 	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
 	   RegistroReservasBo bo=new RegistroReservasBo();
 	   
 	   String p_fechaIni=(String)request.getSession().getAttribute("p_fechaIni");//fecha de carga
 	   String p_fechaFin=(String)request.getSession().getAttribute("p_fechaFin");
 	   
 	   Integer p_idoutlet=(Integer)request.getSession().getAttribute("p_idoutlet");
 	   Integer p_idtiporeserva=(Integer)request.getSession().getAttribute("p_idtiporeserva");
 	   Integer p_idejecutivo=(Integer)request.getSession().getAttribute("p_idejecutivo");
 	   
 	   List<Reservas> lista=new LinkedList<>();
 	   if(p_idoutlet!=null&&p_idoutlet>=0||
 			   p_fechaIni!=null&&p_fechaIni.trim().length()>0||
 					   p_fechaFin!=null&&p_fechaFin.trim().length()>0||
 							  p_idtiporeserva!=null&&p_idtiporeserva>=0||
 									   p_idejecutivo!=null&&p_idejecutivo>=0){
 		  lista = bo.listarReservas(p_fechaIni, p_fechaFin, p_idoutlet, p_idtiporeserva, p_idejecutivo);
 	   }
 	   
 	   ModelAndView mv = new ModelAndView("/reservas/registro-reservas-tabla");
 	   mv.addObject("lista",lista);
 	   
 	   return mv;
    }
    
    @RequestMapping(path={"/buscar-registro-reservas"},method=RequestMethod.GET)
	@ResponseBody
	public ModelAndView buscarRegistroReservas(String fechaIni,String fechaFin,Integer idOutlet,Integer idTipoReserva,Integer idEjecutivo,Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   RegistroReservasBo bo=new RegistroReservasBo();

	   List<Reservas> lista=new LinkedList<>();
	   if(idOutlet!=null&&idOutlet>=0||
			   fechaIni!=null&&fechaIni.trim().length()>0||
					   fechaFin!=null&&fechaFin.trim().length()>0||
							   idTipoReserva!=null&&idTipoReserva>=0||
							   		idEjecutivo!=null&&idEjecutivo>=0){
		   
	   		lista = bo.listarReservas(fechaIni, fechaFin, idOutlet, idTipoReserva, idEjecutivo);
	   		
	   		request.getSession().setAttribute("p_fechaIni", fechaIni);//fecha de carga
	 	    request.getSession().setAttribute("p_fechaFin", fechaFin);
	 	    request.getSession().setAttribute("p_idoutlet", idOutlet);
	 	    request.getSession().setAttribute("p_idtiporeserva", idTipoReserva);
	 	    request.getSession().setAttribute("p_idejecutivo", idEjecutivo);
	   }
	   
	   ModelAndView mv = new ModelAndView("/reservas/registro-reservas-tabla");
	   mv.addObject("lista",lista);
	   return mv;
	}
    
    
    @RequestMapping(path={"/registro-cliente-simple"},method=RequestMethod.GET)
	@ResponseBody	
    public Cliente registroClienteSimple(Integer idCliente,Integer idTipoCliente,Integer idTipoDocumento,String denominacion,
		   String nrodocumento,String telefono,String correo,String numeroSocio,Integer idDistrito,Model model,HttpServletRequest request) {
		Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
		
		RegistroReservasBo servicio=new RegistroReservasBo();
		Cliente cliente=new Cliente();
    	try{
			if(idCliente>0){
				//Actualizar
				idCliente=servicio.actualizaCliente(idCliente, idTipoCliente, idTipoDocumento, denominacion, nrodocumento, telefono,correo,idDistrito,numeroSocio,  pUsuario);	
			}else{
				//Nuevo registro
				idCliente=servicio.registraCliente(idTipoCliente,idTipoDocumento,denominacion,nrodocumento,telefono,correo,idDistrito,numeroSocio,pUsuario);
			}
		    cliente.setIdCliente(idCliente);
		    cliente.setNroDocumento(nrodocumento);
		    cliente.setDenominacion(denominacion);
    	}catch(Exception e){
    		e.printStackTrace();
    	}
    	return cliente;
	}
    
    
    @RequestMapping(path={"/obtener-clientes-lista"},method=RequestMethod.GET)
	@ResponseBody
    public List<Value> obtenerClientesLista(Model model,HttpServletRequest request) {
    	RegistroReservasBo servicio=new RegistroReservasBo();
		List lCliente=new LinkedList<Value>();
		try{
	    	lCliente=servicio.listClientes();
		}catch(Exception e){
			e.printStackTrace();
		}
	    return lCliente;
	}

    @RequestMapping(path={"/buscar-cliente-simple"},method=RequestMethod.GET)
	@ResponseBody	
    public Cliente buscarClienteSimple(Integer idCliente,Model model,HttpServletRequest request) {
    	RegistroReservasBo servicio=new RegistroReservasBo();
		Cliente cliente=new Cliente();
		try{
			cliente=servicio.getCliente(idCliente);
		}catch(Exception e){
			e.printStackTrace();
		}
    	return cliente;
	}
    
    
    @RequestMapping(path={"/registro-check"},method=RequestMethod.GET)
    @ResponseBody
    public ModelAndView registroCheck(Integer idCliente,Integer idReserva,Double ventaNeta,String nroCheck,
		   Model model,HttpServletRequest request) {
	   Usuario pUser=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroReservasBo bo=new RegistroReservasBo();
	   if(idReserva>0){
		   idReserva=bo.registroCheck(idCliente,idReserva,ventaNeta,nroCheck,pUser);
	   }
	   
	   String p_fechaIni=(String)request.getSession().getAttribute("p_fechaIni");
	   String p_fechaFin=(String)request.getSession().getAttribute("p_fechaFin");
	   
	   Integer p_idoutlet=(Integer)request.getSession().getAttribute("p_idoutlet");
 	   Integer p_idtiporeserva=(Integer)request.getSession().getAttribute("p_idtiporeserva");
 	   Integer p_idejecutivo=(Integer)request.getSession().getAttribute("p_idejecutivo");
	   
	   List<Reservas> lista=new LinkedList<>();
	   if(p_idoutlet!=null&&p_idoutlet>=0||
 			   p_fechaIni!=null&&p_fechaIni.trim().length()>0||
 					   p_fechaFin!=null&&p_fechaFin.trim().length()>0||
 							  p_idtiporeserva!=null&&p_idtiporeserva>=0||
 									   p_idejecutivo!=null&&p_idejecutivo>=0){
 		  lista = bo.listarReservas(p_fechaIni, p_fechaFin, p_idoutlet, p_idtiporeserva, p_idejecutivo);
 	   }
	   
	   ModelAndView mv = new ModelAndView("/reservas/registro-reservas-tabla");
	   mv.addObject("lista",lista);
	   return mv;
    }
    
}


