package com.delfines.spring.controller;

import java.io.File;
import java.io.FileFilter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.StandardCopyOption;
import java.nio.file.attribute.FileTime;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.concurrent.TimeUnit;

import org.apache.commons.io.filefilter.AgeFileFilter;

import com.fasterxml.jackson.core.JsonFactory;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonToken;

public class ReloadJson2XML21 {
	
	private String serie;
	private String numero;
	
	public static void main(String[] args) {
		String fecha="01/09/2019";
		Integer nserie=31;
		String serie="F031";
		String numero="2893";
		
		try{
			String _PATH_SOURCE="";
			String _PATH_TARGET="";
			if(nserie==31){
				_PATH_SOURCE="\\\\10.0.0.127\\outXML\\json\\31\\";
				_PATH_TARGET="\\\\10.0.0.227\\Cmds\\";
			}else if(nserie==33){
				_PATH_SOURCE="\\\\10.0.0.127\\outXML\\json\\33\\";
				_PATH_TARGET="\\\\10.0.0.205\\Cmds\\";
			}else if(nserie==36){
				_PATH_SOURCE="\\\\10.0.0.127\\outXML\\json\\36\\";
				_PATH_TARGET="\\\\10.0.0.206\\Cmds\\";
			}else if(nserie==41){
				_PATH_SOURCE="\\\\10.0.0.127\\outXML\\json\\41\\";
				_PATH_TARGET="\\\\10.0.0.208\\Cmds\\";
			}
			
			File directory = new File(_PATH_SOURCE);
			File target = new File(_PATH_TARGET);
	
			Date sdf=new SimpleDateFormat("dd/MM/yyyy").parse(fecha);
			
			ReloadJson2XML21 r=new ReloadJson2XML21(serie,numero);
			r.displayFiles(directory,target, new AgeFileFilter(sdf,false));
			
			System.out.println("terminated!");
		}catch(Exception e){
			e.printStackTrace();
		}
		
    }
	
	public ReloadJson2XML21(String serie,String numero){
		this.serie=serie;
		this.numero=numero;
	}
	
	public  void displayFiles(File directory,File target,FileFilter fileFilter) {
		File[] files = directory.listFiles(fileFilter);
		for (File file : files) {
			if(file.isFile()&&file.getName().toLowerCase().endsWith(".json")){
				json(directory,target,file.getName());	
			}
		}
	}
	
	public void json(File directory,File target,String file){
		Integer result=0;
		try {
			StringBuffer sb=new StringBuffer();
			sb.append(directory.getAbsolutePath()).append("\\").append(file);
			
            JsonFactory factory = new JsonFactory();
            JsonParser parser = factory.createParser(new File(sb.toString()));
            
            while (parser.nextToken() != JsonToken.END_ARRAY) {
                String token = parser.getCurrentName();
                if ("Numero".equals(token)) {
                    parser.nextToken();
                    String fname = parser.getText();
                    if(fname.equals(this.numero)){
                    	result++;
                    }
                }
                if ("Serie".equals(token)) {
                    parser.nextToken();
                    String fname = parser.getText();
                    if(fname.equals(this.serie)){
                    	result++;
                    }
                }
            }
            
            if(result==2){
            	System.out.println("source: "+sb.toString());
            	
            	StringBuffer ds=new StringBuffer();
            	ds.append(target.getAbsolutePath()).append("\\").append(file);
    			
            	copyFile(new File(sb.toString()),new File(ds.toString()));	
            }
            
        } catch (IOException e) {
            e.printStackTrace();
        }
	}
	
	private void copyFile(File src, File dest) throws IOException {
		
		Calendar cal = Calendar.getInstance();
		FileTime fileTime = FileTime.from(cal.getTimeInMillis(),TimeUnit.MILLISECONDS);
		java.nio.file.Files.setLastModifiedTime(src.toPath(), fileTime);
		Files.copy(src.toPath(), dest.toPath(),StandardCopyOption.REPLACE_EXISTING);
	    System.out.println("copy to: "+dest.toPath());
	    
	}
	
}

