package com.delfines.spring.controller;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.io.IOUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.business.RegistroLeadsBo;
import com.delfines.sendmail.SendEmail;
import com.delfines.vo.ErrorLead;
import com.delfines.vo.Lead;
import com.delfines.vo.Usuario;


@Controller
public class RestUploadController {

	@Autowired
    private HttpServletRequest request;
	
    @RequestMapping(path={"/theurl"},method=RequestMethod.POST)
    public ModelAndView doUpload(@RequestParam("file") MultipartFile file,Model model,HttpServletRequest request) {
    	Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
    	List<ErrorLead> listaErrors = new ArrayList<ErrorLead>();
        
    	Integer errors=0;
    	Integer leads=0;
    	
    	if (!file.isEmpty()) {
             try {
                 String filePath = "\\\\10.0.0.190\\test\\leads\\upload\\upload_leads.csv";
                 File dest = new File(filePath);
                 file.transferTo(dest);
                 
                 Map<String, Integer> result=loadLeads(filePath);
                 errors=result.get("errors");
                 leads=result.get("leads");
                 //
                 RegistroLeadsBo bo=new RegistroLeadsBo();
                 if(errors>0){
                	 listaErrors=bo.listLeadsErrors();	 
                 }
             }catch(Exception e){
            	 e.printStackTrace();
             }
    	}
    	ModelAndView mv = new ModelAndView("registro-leads-tabla");
    	if(errors>0){
    		mv.addObject("listaErrors",listaErrors);
    		mv.addObject("msgCarga","("+listaErrors.size()+") Registros con error de carga !");
    	}else{
    		RegistroLeadsBo bo=new RegistroLeadsBo();
    		//-------------------------Send Email Alert
    		String fechaHoraHoy=bo.getDateTime();
    		String subject="Alerta de carga de Leads";
    		String text="Se han cargado "+leads+" leads con fecha "+fechaHoraHoy;
    		String toList="jdietz@losdelfineshotel.com.pe";
    		String ccList="reservasayb@losdelfineshotel.com.pe,promociones@losdelfineshotel.com.pe,grupoeventos@losdelfineshotel.com.pe,club@losdelfineshotel.com.pe,grupoventas@losdelfineshotel.com.pe,gruposistemas@losdelfineshotel.com.pe,vperalta@losdelfineshotel.com.pe,farbulu@losdelfineshotel.com.pe,tbravo@losdelfineshotel.com.pe";
    		SendEmail.sendEmailLead(toList, ccList, subject, text);
    		//-------------------------
    		String fechaHoy=bo.getDate();    		
    		List<Lead> listaLeads = bo.listLeads(0,fechaHoy,fechaHoy,0,0,9,"","","","",9,0,0,-1,0,pUsuario);
    		
    		mv.addObject("msgCarga","("+leads+") Registros cargados de manera exitosa !");
    		mv.addObject("listaErrors",new ArrayList<ErrorLead>());
   		    mv.addObject("listaLeads",listaLeads);
    	}
   		return mv;
    }
    
    @RequestMapping(value="/downloadFile")
    public void getLogFile(HttpSession session,HttpServletResponse response) throws Exception {
        try {
        	String uploadsDir = "/uploads/";
            String realPathtoUploads =  request.getServletContext().getRealPath(uploadsDir);
        	 String filePath = realPathtoUploads+"\\carga_leads_macro.xlsm";
             File fileToDownload = new File(filePath);
             InputStream inputStream = new FileInputStream(fileToDownload);
             response.setContentType("application/force-download");
             response.setHeader("Content-Disposition", "attachment; filename=carga_leads_macro.xlsm"); 
             IOUtils.copy(inputStream, response.getOutputStream());
             response.flushBuffer();
             inputStream.close();
        } catch (Exception e){
            e.printStackTrace();
        }

    }
    
    private Map<String, Integer>  loadLeads(String filePath){
    	RegistroLeadsBo bo=new RegistroLeadsBo();
    	return bo.loadLeads(filePath);
    }

}
