package com.delfines.spring.controller;

import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.business.GeneralBo;
import com.delfines.business.UsuarioBo;
import com.delfines.vo.Usuario;

/**
 * @author imssbora
 */
@Controller
public class UsuarioController {
   
	UsuarioBo usuarioBo=new UsuarioBo(); 
	
   @RequestMapping(path={"/insert-usuario"},method=RequestMethod.GET)
   public String registroUsuario(String apellidosNombres,Integer idArea,Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario==null){
		   return "registro-usuario";
	   }
	   
	   try{
		   Usuario usuario=new Usuario();
		   usuario.setApellidosNombres(apellidosNombres);
		   usuario.setAreaId(idArea);
		   usuarioBo.registroUsuario(usuario,pUsuario.getUsuarioId());
	   }catch(Exception e){
		   e.printStackTrace();
	   }
       return "registro-usuario";
   }
   
   @RequestMapping(path={"/buscar-usuario-ticket"},method=RequestMethod.GET)
   public ModelAndView buscarUsuario(String apellidosNombres,Integer idArea,Model model,HttpServletRequest request) {
	   
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario==null){
		   ModelAndView mav = new ModelAndView();
		   mav.setViewName("registro-ticket-tabla");
		   return mav;
	   }
	   
	   ModelAndView mav = new ModelAndView();
	   try{
		   List<Usuario> lista=new LinkedList<Usuario>();
		   if(apellidosNombres.trim().length()>0){
			   lista=usuarioBo.buscarUsuariosByApeNom(apellidosNombres,pUsuario);   
		   }else if(idArea>0){
			   lista=usuarioBo.buscarUsuariosByArea(idArea);
		   }
		   mav.setViewName("registro-ticket-tabla");
	       mav.addObject("listaUsuarios", lista);
	   }catch(Exception e){
		   e.printStackTrace();
	   }
	   return mav;
   }
   
   @RequestMapping(path={"/registro-usuario-ticket"},method=RequestMethod.GET)
   public String registroUsuarioTicket(Integer ticketDesde,Integer ticketHasta,Integer cantidad,Integer metaEntregados,Integer metaValidados,Integer idUsuario,Model model) {
	   try{
		   cantidad=ticketHasta-ticketDesde;
		   if(usuarioBo.existeTicketMeta(idUsuario)>0){
			   usuarioBo.actualizaTicketMeta(ticketDesde, ticketHasta, cantidad, metaEntregados,metaValidados, idUsuario);
		   }else{
			   usuarioBo.registroTicketMeta(ticketDesde, ticketHasta, cantidad, metaEntregados,metaValidados, idUsuario);   
		   }
	   }catch(Exception e){
		   e.printStackTrace();
	   }
       return "registro-ticket";
   }
   
   @RequestMapping(path={"/login-usuario"},method=RequestMethod.GET)
   public ModelAndView loginUsuario(String username,String passwd,Model model,HttpServletRequest request) {
	   Usuario usuario=usuarioBo.loginUsuario(username,passwd);

	   ModelAndView mav = new ModelAndView();
		   
	   if(usuario!=null&&usuario.getUsuarioId()>0){
		   request.getSession().setAttribute("p_usuario",usuario);
		   
		   //Link de BI : inicio
		   GeneralBo general=new GeneralBo();
		   List<String> lUrl=general.listarUrl();
		   if(lUrl!=null&&lUrl.size()>0){
			   request.getSession().setAttribute("p_urlbi",(lUrl.get(0)==null?"":lUrl.get(0).trim()));   
		   }else{
			   request.getSession().setAttribute("p_urlbi","");
		   }
		   //Link de BI : fin
		   
		   mav.setViewName("index");
	       mav.addObject("done", "1");
	   }else{
		   request.getSession().setAttribute("p_usuario",new Usuario());
		   
		   mav.setViewName("login");
	       mav.addObject("done", "0");
	   }

       return mav;
   }

   //--
   @RequestMapping(path={"/update-loginpwd-usuario"},method=RequestMethod.GET)
   public String actualizaLoginPassword(String loginUsuario,String pwdUsuario,Integer idPerfil,Integer idUsuario,Model model,HttpServletRequest request) {
	   try{
		   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
		   usuarioBo.actulizaLoginPwd(loginUsuario,pwdUsuario,idPerfil,idUsuario);
	   }catch(Exception e){
		   e.printStackTrace();
	   }
       return "registro-usuario";
   }
}
